// SPDX-FileCopyrightText: 2021 Nheko Contributors
// SPDX-FileCopyrightText: 2022 Nheko Contributors
// SPDX-FileCopyrightText: 2023 Nheko Contributors
//
// SPDX-License-Identifier: GPL-3.0-or-later

#include "emoji/Provider.h"

using namespace emoji;

const std::array<Emoji, 3655> emoji::Provider::emoji = {
  // People
  Emoji{QStringLiteral(u"\U0001F600"),
        QStringLiteral(u"grinning"),
        QStringLiteral(u"grinning face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F603"),
        QStringLiteral(u"grinning_face_with_big_eyes"),
        QStringLiteral(u"grinning face with big eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F604"),
        QStringLiteral(u"smile"),
        QStringLiteral(u"grinning face with smiling eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F601"),
        QStringLiteral(u"beaming_face_with_smiling_eyes"),
        QStringLiteral(u"beaming face with smiling eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F606"),
        QStringLiteral(u"grinning_squinting"),
        QStringLiteral(u"grinning squinting face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F605"),
        QStringLiteral(u"sweat_smile"),
        QStringLiteral(u"grinning face with sweat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F923"),
        QStringLiteral(u"rofl"),
        QStringLiteral(u"rolling on the floor laughing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F602"),
        QStringLiteral(u"face_with_tears_of_joy"),
        QStringLiteral(u"face with tears of joy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F642"),
        QStringLiteral(u"slightly_smiling"),
        QStringLiteral(u"slightly smiling face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F643"),
        QStringLiteral(u"upside_down"),
        QStringLiteral(u"upside-down face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE0"),
        QStringLiteral(u"melting"),
        QStringLiteral(u"melting face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F609"),
        QStringLiteral(u"winking"),
        QStringLiteral(u"winking face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F60A"),
        QStringLiteral(u"smiling_face_with_smiling_eyes"),
        QStringLiteral(u"smiling face with smiling eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F607"),
        QStringLiteral(u"innocent"),
        QStringLiteral(u"smiling face with halo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F970"),
        QStringLiteral(u"smiling_face_with_hearts"),
        QStringLiteral(u"smiling face with hearts"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F60D"),
        QStringLiteral(u"heart_eyes"),
        QStringLiteral(u"smiling face with heart-eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F929"),
        QStringLiteral(u"star_struck"),
        QStringLiteral(u"star-struck"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F618"),
        QStringLiteral(u"face_blowing_a_kiss"),
        QStringLiteral(u"face blowing a kiss"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F617"),
        QStringLiteral(u"kissing"),
        QStringLiteral(u"kissing face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000263A\U0000FE0F"),
        QStringLiteral(u"smiling"),
        QStringLiteral(u"smiling face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F61A"),
        QStringLiteral(u"kissing_face_with_closed_eyes"),
        QStringLiteral(u"kissing face with closed eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F619"),
        QStringLiteral(u"kissing_face_with_smiling_eyes"),
        QStringLiteral(u"kissing face with smiling eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F972"),
        QStringLiteral(u"smiling_face_with_tear"),
        QStringLiteral(u"smiling face with tear"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F60B"),
        QStringLiteral(u"yum"),
        QStringLiteral(u"face savoring food"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F61B"),
        QStringLiteral(u"face_with_tongue"),
        QStringLiteral(u"face with tongue"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F61C"),
        QStringLiteral(u"winking_face_with_tongue"),
        QStringLiteral(u"winking face with tongue"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F92A"),
        QStringLiteral(u"zany"),
        QStringLiteral(u"zany face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F61D"),
        QStringLiteral(u"squinting_face_with_tongue"),
        QStringLiteral(u"squinting face with tongue"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F911"),
        QStringLiteral(u"money_mouth"),
        QStringLiteral(u"money-mouth face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F917"),
        QStringLiteral(u"hugging_face"),
        QStringLiteral(u"smiling face with open hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F92D"),
        QStringLiteral(u"face_with_hand_over_mouth"),
        QStringLiteral(u"face with hand over mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE2"),
        QStringLiteral(u"face_with_open_eyes_and_hand_over_mouth"),
        QStringLiteral(u"face with open eyes and hand over mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE3"),
        QStringLiteral(u"face_with_peeking_eye"),
        QStringLiteral(u"face with peeking eye"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F92B"),
        QStringLiteral(u"shushing"),
        QStringLiteral(u"shushing face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F914"),
        QStringLiteral(u"thinking"),
        QStringLiteral(u"thinking face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE1"),
        QStringLiteral(u"saluting"),
        QStringLiteral(u"saluting face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F910"),
        QStringLiteral(u"zipper_mouth"),
        QStringLiteral(u"zipper-mouth face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F928"),
        QStringLiteral(u"face_with_raised_eyebrow"),
        QStringLiteral(u"face with raised eyebrow"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F610"),
        QStringLiteral(u"neutral"),
        QStringLiteral(u"neutral face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F611"),
        QStringLiteral(u"expressionless"),
        QStringLiteral(u"expressionless face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F636"),
        QStringLiteral(u"face_without_mouth"),
        QStringLiteral(u"face without mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE5"),
        QStringLiteral(u"dotted_line"),
        QStringLiteral(u"dotted line face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F636\U0000200D\U0001F32B\U0000FE0F"),
        QStringLiteral(u"face_in_clouds"),
        QStringLiteral(u"face in clouds"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F60F"),
        QStringLiteral(u"smirking"),
        QStringLiteral(u"smirking face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F612"),
        QStringLiteral(u"unamused"),
        QStringLiteral(u"unamused face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F644"),
        QStringLiteral(u"face_with_rolling_eyes"),
        QStringLiteral(u"face with rolling eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F62C"),
        QStringLiteral(u"grimacing"),
        QStringLiteral(u"grimacing face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F62E\U0000200D\U0001F4A8"),
        QStringLiteral(u"face_exhaling"),
        QStringLiteral(u"face exhaling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F925"),
        QStringLiteral(u"lying"),
        QStringLiteral(u"lying face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE8"),
        QStringLiteral(u"shaking"),
        QStringLiteral(u"shaking face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F60C"),
        QStringLiteral(u"relieved"),
        QStringLiteral(u"relieved face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F614"),
        QStringLiteral(u"pensive"),
        QStringLiteral(u"pensive face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F62A"),
        QStringLiteral(u"sleepy"),
        QStringLiteral(u"sleepy face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F924"),
        QStringLiteral(u"drooling"),
        QStringLiteral(u"drooling face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F634"),
        QStringLiteral(u"sleeping"),
        QStringLiteral(u"sleeping face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F637"),
        QStringLiteral(u"face_with_medical_mask"),
        QStringLiteral(u"face with medical mask"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F912"),
        QStringLiteral(u"face_with_thermometer"),
        QStringLiteral(u"face with thermometer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F915"),
        QStringLiteral(u"face_with_head_bandage"),
        QStringLiteral(u"face with head-bandage"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F922"),
        QStringLiteral(u"nauseated"),
        QStringLiteral(u"nauseated face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F92E"),
        QStringLiteral(u"face_vomiting"),
        QStringLiteral(u"face vomiting"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F927"),
        QStringLiteral(u"cry_smile"),
        QStringLiteral(u"sneezing face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F975"),
        QStringLiteral(u"hot"),
        QStringLiteral(u"hot face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F976"),
        QStringLiteral(u"cold"),
        QStringLiteral(u"cold face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F974"),
        QStringLiteral(u"woozy"),
        QStringLiteral(u"woozy face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F635"),
        QStringLiteral(u"face_with_crossed_out_eyes"),
        QStringLiteral(u"face with crossed-out eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F635\U0000200D\U0001F4AB"),
        QStringLiteral(u"face_with_spiral_eyes"),
        QStringLiteral(u"face with spiral eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F92F"),
        QStringLiteral(u"exploding_head"),
        QStringLiteral(u"exploding head"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F920"),
        QStringLiteral(u"cowboy_hat"),
        QStringLiteral(u"cowboy hat face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F973"),
        QStringLiteral(u"partying"),
        QStringLiteral(u"partying face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F978"),
        QStringLiteral(u"disguised"),
        QStringLiteral(u"disguised face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F60E"),
        QStringLiteral(u"smiling_face_with_sunglasses"),
        QStringLiteral(u"smiling face with sunglasses"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F913"),
        QStringLiteral(u"nerd"),
        QStringLiteral(u"nerd face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D0"),
        QStringLiteral(u"face_with_monocle"),
        QStringLiteral(u"face with monocle"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F615"),
        QStringLiteral(u"confused"),
        QStringLiteral(u"confused face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE4"),
        QStringLiteral(u"face_with_diagonal_mouth"),
        QStringLiteral(u"face with diagonal mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F61F"),
        QStringLiteral(u"worried"),
        QStringLiteral(u"worried face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F641"),
        QStringLiteral(u"slightly_frowning"),
        QStringLiteral(u"slightly frowning face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U00002639\U0000FE0F"),
        QStringLiteral(u"frowning"),
        QStringLiteral(u"frowning face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F62E"),
        QStringLiteral(u"face_with_open_mouth"),
        QStringLiteral(u"face with open mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F62F"),
        QStringLiteral(u"hushed"),
        QStringLiteral(u"hushed face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F632"),
        QStringLiteral(u"astonished"),
        QStringLiteral(u"astonished face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F633"),
        QStringLiteral(u"flushed"),
        QStringLiteral(u"flushed face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F97A"),
        QStringLiteral(u"pleading"),
        QStringLiteral(u"pleading face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F979"),
        QStringLiteral(u"face_holding_back_tears"),
        QStringLiteral(u"face holding back tears"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F626"),
        QStringLiteral(u"frowning_face_with_open_mouth"),
        QStringLiteral(u"frowning face with open mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F627"),
        QStringLiteral(u"anguished"),
        QStringLiteral(u"anguished face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F628"),
        QStringLiteral(u"fearful"),
        QStringLiteral(u"fearful face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F630"),
        QStringLiteral(u"anxious_face_with_sweat"),
        QStringLiteral(u"anxious face with sweat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F625"),
        QStringLiteral(u"sad_but_relieved"),
        QStringLiteral(u"sad but relieved face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F622"),
        QStringLiteral(u"crying"),
        QStringLiteral(u"crying face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F62D"),
        QStringLiteral(u"sob"),
        QStringLiteral(u"loudly crying face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F631"),
        QStringLiteral(u"scream"),
        QStringLiteral(u"face screaming in fear"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F616"),
        QStringLiteral(u"confounded"),
        QStringLiteral(u"confounded face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F623"),
        QStringLiteral(u"persevering"),
        QStringLiteral(u"persevering face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F61E"),
        QStringLiteral(u"disappointed"),
        QStringLiteral(u"disappointed face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F613"),
        QStringLiteral(u"sweat"),
        QStringLiteral(u"downcast face with sweat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F629"),
        QStringLiteral(u"weary"),
        QStringLiteral(u"weary face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F62B"),
        QStringLiteral(u"tired"),
        QStringLiteral(u"tired face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F971"),
        QStringLiteral(u"yawning"),
        QStringLiteral(u"yawning face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F624"),
        QStringLiteral(u"triumph"),
        QStringLiteral(u"face with steam from nose"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F621"),
        QStringLiteral(u"enraged"),
        QStringLiteral(u"enraged face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F620"),
        QStringLiteral(u"angry"),
        QStringLiteral(u"angry face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F92C"),
        QStringLiteral(u"face_with_symbols_on_mouth"),
        QStringLiteral(u"face with symbols on mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F608"),
        QStringLiteral(u"smiling_imp"),
        QStringLiteral(u"smiling face with horns"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47F"),
        QStringLiteral(u"imp"),
        QStringLiteral(u"angry face with horns"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F480"),
        QStringLiteral(u"skull"),
        QStringLiteral(u"skull"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U00002620\U0000FE0F"),
        QStringLiteral(u"skull_and_crossbones"),
        QStringLiteral(u"skull and crossbones"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4A9"),
        QStringLiteral(u"pile_of_poo"),
        QStringLiteral(u"pile of poo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F921"),
        QStringLiteral(u"clown"),
        QStringLiteral(u"clown face"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F479"),
        QStringLiteral(u"ogre"),
        QStringLiteral(u"ogre"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47A"),
        QStringLiteral(u"goblin"),
        QStringLiteral(u"goblin"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47B"),
        QStringLiteral(u"ghost"),
        QStringLiteral(u"ghost"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47D"),
        QStringLiteral(u"alien"),
        QStringLiteral(u"alien"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47E"),
        QStringLiteral(u"alien_monster"),
        QStringLiteral(u"alien monster"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F916"),
        QStringLiteral(u"robot"),
        QStringLiteral(u"robot"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F63A"),
        QStringLiteral(u"smiley_cat"),
        QStringLiteral(u"grinning cat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F638"),
        QStringLiteral(u"smile_cat"),
        QStringLiteral(u"grinning cat with smiling eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F639"),
        QStringLiteral(u"joy_cat"),
        QStringLiteral(u"cat with tears of joy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F63B"),
        QStringLiteral(u"heart_eyes_cat"),
        QStringLiteral(u"smiling cat with heart-eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F63C"),
        QStringLiteral(u"smirk_cat"),
        QStringLiteral(u"cat with wry smile"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F63D"),
        QStringLiteral(u"kissing_cat"),
        QStringLiteral(u"kissing cat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F640"),
        QStringLiteral(u"scream_cat"),
        QStringLiteral(u"weary cat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F63F"),
        QStringLiteral(u"crying_cat"),
        QStringLiteral(u"crying cat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F63E"),
        QStringLiteral(u"pouting_cat"),
        QStringLiteral(u"pouting cat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F648"),
        QStringLiteral(u"see_no_evil_monkey"),
        QStringLiteral(u"see-no-evil monkey"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F649"),
        QStringLiteral(u"hear_no_evil_monkey"),
        QStringLiteral(u"hear-no-evil monkey"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64A"),
        QStringLiteral(u"speak_no_evil_monkey"),
        QStringLiteral(u"speak-no-evil monkey"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48C"),
        QStringLiteral(u"love_letter"),
        QStringLiteral(u"love letter"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F498"),
        QStringLiteral(u"heart_with_arrow"),
        QStringLiteral(u"heart with arrow"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F49D"),
        QStringLiteral(u"heart_with_ribbon"),
        QStringLiteral(u"heart with ribbon"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F496"),
        QStringLiteral(u"sparkling_heart"),
        QStringLiteral(u"sparkling heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F497"),
        QStringLiteral(u"growing_heart"),
        QStringLiteral(u"growing heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F493"),
        QStringLiteral(u"beating_heart"),
        QStringLiteral(u"beating heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F49E"),
        QStringLiteral(u"revolving_hearts"),
        QStringLiteral(u"revolving hearts"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F495"),
        QStringLiteral(u"two_hearts"),
        QStringLiteral(u"two hearts"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F49F"),
        QStringLiteral(u"heart_decoration"),
        QStringLiteral(u"heart decoration"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U00002763\U0000FE0F"),
        QStringLiteral(u"heart_exclamation"),
        QStringLiteral(u"heart exclamation"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F494"),
        QStringLiteral(u"broken_heart"),
        QStringLiteral(u"broken heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U00002764\U0000FE0F\U0000200D\U0001F525"),
        QStringLiteral(u"heart_on_fire"),
        QStringLiteral(u"heart on fire"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U00002764\U0000FE0F\U0000200D\U0001FA79"),
        QStringLiteral(u"mending_heart"),
        QStringLiteral(u"mending heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U00002764\U0000FE0F"),
        QStringLiteral(u"red_heart"),
        QStringLiteral(u"red heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FA77"),
        QStringLiteral(u"pink_heart"),
        QStringLiteral(u"pink heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9E1"),
        QStringLiteral(u"orange_heart"),
        QStringLiteral(u"orange heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F49B"),
        QStringLiteral(u"yellow_heart"),
        QStringLiteral(u"yellow heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F49A"),
        QStringLiteral(u"green_heart"),
        QStringLiteral(u"green heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F499"),
        QStringLiteral(u"blue_heart"),
        QStringLiteral(u"blue heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FA75"),
        QStringLiteral(u"light_blue_heart"),
        QStringLiteral(u"light blue heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F49C"),
        QStringLiteral(u"purple_heart"),
        QStringLiteral(u"purple heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90E"),
        QStringLiteral(u"brown_heart"),
        QStringLiteral(u"brown heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F5A4"),
        QStringLiteral(u"black_heart"),
        QStringLiteral(u"black heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FA76"),
        QStringLiteral(u"grey_heart"),
        QStringLiteral(u"grey heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90D"),
        QStringLiteral(u"white_heart"),
        QStringLiteral(u"white heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48B"),
        QStringLiteral(u"kiss_mark"),
        QStringLiteral(u"kiss mark"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AF"),
        QStringLiteral(u"100"),
        QStringLiteral(u"hundred points"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4A2"),
        QStringLiteral(u"anger_symbol"),
        QStringLiteral(u"anger symbol"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4A5"),
        QStringLiteral(u"boom"),
        QStringLiteral(u"collision"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AB"),
        QStringLiteral(u"dizzy"),
        QStringLiteral(u"dizzy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4A6"),
        QStringLiteral(u"sweat_droplets"),
        QStringLiteral(u"sweat droplets"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4A8"),
        QStringLiteral(u"dashing_away"),
        QStringLiteral(u"dashing away"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F573\U0000FE0F"),
        QStringLiteral(u"hole"),
        QStringLiteral(u"hole"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AC"),
        QStringLiteral(u"speech_balloon"),
        QStringLiteral(u"speech balloon"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F441\U0000FE0F\U0000200D\U0001F5E8\U0000FE0F"),
        QStringLiteral(u"eye_in_speech_bubble"),
        QStringLiteral(u"eye in speech bubble"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F5E8\U0000FE0F"),
        QStringLiteral(u"left_speech_bubble"),
        QStringLiteral(u"left speech bubble"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F5EF\U0000FE0F"),
        QStringLiteral(u"right_anger_bubble"),
        QStringLiteral(u"right anger bubble"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AD"),
        QStringLiteral(u"thought_balloon"),
        QStringLiteral(u"thought balloon"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4A4"),
        QStringLiteral(u"zzz"),
        QStringLiteral(u"ZZZ"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44B"),
        QStringLiteral(u"wave"),
        QStringLiteral(u"waving hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44B\U0001F3FB"),
        QStringLiteral(u"waving_hand_light_skin_tone"),
        QStringLiteral(u"waving hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44B\U0001F3FC"),
        QStringLiteral(u"waving_hand_medium_light_skin_tone"),
        QStringLiteral(u"waving hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44B\U0001F3FD"),
        QStringLiteral(u"waving_hand_medium_skin_tone"),
        QStringLiteral(u"waving hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44B\U0001F3FE"),
        QStringLiteral(u"waving_hand_medium_dark_skin_tone"),
        QStringLiteral(u"waving hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44B\U0001F3FF"),
        QStringLiteral(u"waving_hand_dark_skin_tone"),
        QStringLiteral(u"waving hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91A"),
        QStringLiteral(u"raised_back_of_hand"),
        QStringLiteral(u"raised back of hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91A\U0001F3FB"),
        QStringLiteral(u"raised_back_of_hand_light_skin_tone"),
        QStringLiteral(u"raised back of hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91A\U0001F3FC"),
        QStringLiteral(u"raised_back_of_hand_medium_light_skin_tone"),
        QStringLiteral(u"raised back of hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91A\U0001F3FD"),
        QStringLiteral(u"raised_back_of_hand_medium_skin_tone"),
        QStringLiteral(u"raised back of hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91A\U0001F3FE"),
        QStringLiteral(u"raised_back_of_hand_medium_dark_skin_tone"),
        QStringLiteral(u"raised back of hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91A\U0001F3FF"),
        QStringLiteral(u"raised_back_of_hand_dark_skin_tone"),
        QStringLiteral(u"raised back of hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F590\U0000FE0F"),
        QStringLiteral(u"hand_with_fingers_splayed"),
        QStringLiteral(u"hand with fingers splayed"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F590\U0001F3FB"),
        QStringLiteral(u"hand_with_fingers_splayed_light_skin_tone"),
        QStringLiteral(u"hand with fingers splayed: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F590\U0001F3FC"),
        QStringLiteral(u"hand_with_fingers_splayed_medium_light_skin_tone"),
        QStringLiteral(u"hand with fingers splayed: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F590\U0001F3FD"),
        QStringLiteral(u"hand_with_fingers_splayed_medium_skin_tone"),
        QStringLiteral(u"hand with fingers splayed: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F590\U0001F3FE"),
        QStringLiteral(u"hand_with_fingers_splayed_medium_dark_skin_tone"),
        QStringLiteral(u"hand with fingers splayed: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F590\U0001F3FF"),
        QStringLiteral(u"hand_with_fingers_splayed_dark_skin_tone"),
        QStringLiteral(u"hand with fingers splayed: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270B"),
        QStringLiteral(u"raised_hand"),
        QStringLiteral(u"raised hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270B\U0001F3FB"),
        QStringLiteral(u"raised_hand_light_skin_tone"),
        QStringLiteral(u"raised hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270B\U0001F3FC"),
        QStringLiteral(u"raised_hand_medium_light_skin_tone"),
        QStringLiteral(u"raised hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270B\U0001F3FD"),
        QStringLiteral(u"raised_hand_medium_skin_tone"),
        QStringLiteral(u"raised hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270B\U0001F3FE"),
        QStringLiteral(u"raised_hand_medium_dark_skin_tone"),
        QStringLiteral(u"raised hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270B\U0001F3FF"),
        QStringLiteral(u"raised_hand_dark_skin_tone"),
        QStringLiteral(u"raised hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F596"),
        QStringLiteral(u"vulcan_salute"),
        QStringLiteral(u"vulcan salute"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F596\U0001F3FB"),
        QStringLiteral(u"vulcan_salute_light_skin_tone"),
        QStringLiteral(u"vulcan salute: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F596\U0001F3FC"),
        QStringLiteral(u"vulcan_salute_medium_light_skin_tone"),
        QStringLiteral(u"vulcan salute: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F596\U0001F3FD"),
        QStringLiteral(u"vulcan_salute_medium_skin_tone"),
        QStringLiteral(u"vulcan salute: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F596\U0001F3FE"),
        QStringLiteral(u"vulcan_salute_medium_dark_skin_tone"),
        QStringLiteral(u"vulcan salute: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F596\U0001F3FF"),
        QStringLiteral(u"vulcan_salute_dark_skin_tone"),
        QStringLiteral(u"vulcan salute: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1"),
        QStringLiteral(u"rightwards_hand"),
        QStringLiteral(u"rightwards hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FB"),
        QStringLiteral(u"rightwards_hand_light_skin_tone"),
        QStringLiteral(u"rightwards hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FC"),
        QStringLiteral(u"rightwards_hand_medium_light_skin_tone"),
        QStringLiteral(u"rightwards hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FD"),
        QStringLiteral(u"rightwards_hand_medium_skin_tone"),
        QStringLiteral(u"rightwards hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FE"),
        QStringLiteral(u"rightwards_hand_medium_dark_skin_tone"),
        QStringLiteral(u"rightwards hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FF"),
        QStringLiteral(u"rightwards_hand_dark_skin_tone"),
        QStringLiteral(u"rightwards hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF2"),
        QStringLiteral(u"leftwards_hand"),
        QStringLiteral(u"leftwards hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF2\U0001F3FB"),
        QStringLiteral(u"leftwards_hand_light_skin_tone"),
        QStringLiteral(u"leftwards hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF2\U0001F3FC"),
        QStringLiteral(u"leftwards_hand_medium_light_skin_tone"),
        QStringLiteral(u"leftwards hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF2\U0001F3FD"),
        QStringLiteral(u"leftwards_hand_medium_skin_tone"),
        QStringLiteral(u"leftwards hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF2\U0001F3FE"),
        QStringLiteral(u"leftwards_hand_medium_dark_skin_tone"),
        QStringLiteral(u"leftwards hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF2\U0001F3FF"),
        QStringLiteral(u"leftwards_hand_dark_skin_tone"),
        QStringLiteral(u"leftwards hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF3"),
        QStringLiteral(u"palm_down_hand"),
        QStringLiteral(u"palm down hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF3\U0001F3FB"),
        QStringLiteral(u"palm_down_hand_light_skin_tone"),
        QStringLiteral(u"palm down hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF3\U0001F3FC"),
        QStringLiteral(u"palm_down_hand_medium_light_skin_tone"),
        QStringLiteral(u"palm down hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF3\U0001F3FD"),
        QStringLiteral(u"palm_down_hand_medium_skin_tone"),
        QStringLiteral(u"palm down hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF3\U0001F3FE"),
        QStringLiteral(u"palm_down_hand_medium_dark_skin_tone"),
        QStringLiteral(u"palm down hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF3\U0001F3FF"),
        QStringLiteral(u"palm_down_hand_dark_skin_tone"),
        QStringLiteral(u"palm down hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF4"),
        QStringLiteral(u"palm_up_hand"),
        QStringLiteral(u"palm up hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF4\U0001F3FB"),
        QStringLiteral(u"palm_up_hand_light_skin_tone"),
        QStringLiteral(u"palm up hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF4\U0001F3FC"),
        QStringLiteral(u"palm_up_hand_medium_light_skin_tone"),
        QStringLiteral(u"palm up hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF4\U0001F3FD"),
        QStringLiteral(u"palm_up_hand_medium_skin_tone"),
        QStringLiteral(u"palm up hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF4\U0001F3FE"),
        QStringLiteral(u"palm_up_hand_medium_dark_skin_tone"),
        QStringLiteral(u"palm up hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF4\U0001F3FF"),
        QStringLiteral(u"palm_up_hand_dark_skin_tone"),
        QStringLiteral(u"palm up hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF7"),
        QStringLiteral(u"leftwards_pushing_hand"),
        QStringLiteral(u"leftwards pushing hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF7\U0001F3FB"),
        QStringLiteral(u"leftwards_pushing_hand_light_skin_tone"),
        QStringLiteral(u"leftwards pushing hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF7\U0001F3FC"),
        QStringLiteral(u"leftwards_pushing_hand_medium_light_skin_tone"),
        QStringLiteral(u"leftwards pushing hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF7\U0001F3FD"),
        QStringLiteral(u"leftwards_pushing_hand_medium_skin_tone"),
        QStringLiteral(u"leftwards pushing hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF7\U0001F3FE"),
        QStringLiteral(u"leftwards_pushing_hand_medium_dark_skin_tone"),
        QStringLiteral(u"leftwards pushing hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF7\U0001F3FF"),
        QStringLiteral(u"leftwards_pushing_hand_dark_skin_tone"),
        QStringLiteral(u"leftwards pushing hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF8"),
        QStringLiteral(u"rightwards_pushing_hand"),
        QStringLiteral(u"rightwards pushing hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF8\U0001F3FB"),
        QStringLiteral(u"rightwards_pushing_hand_light_skin_tone"),
        QStringLiteral(u"rightwards pushing hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF8\U0001F3FC"),
        QStringLiteral(u"rightwards_pushing_hand_medium_light_skin_tone"),
        QStringLiteral(u"rightwards pushing hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF8\U0001F3FD"),
        QStringLiteral(u"rightwards_pushing_hand_medium_skin_tone"),
        QStringLiteral(u"rightwards pushing hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF8\U0001F3FE"),
        QStringLiteral(u"rightwards_pushing_hand_medium_dark_skin_tone"),
        QStringLiteral(u"rightwards pushing hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF8\U0001F3FF"),
        QStringLiteral(u"rightwards_pushing_hand_dark_skin_tone"),
        QStringLiteral(u"rightwards pushing hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44C"),
        QStringLiteral(u"ok_hand"),
        QStringLiteral(u"OK hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44C\U0001F3FB"),
        QStringLiteral(u"ok_hand_light_skin_tone"),
        QStringLiteral(u"OK hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44C\U0001F3FC"),
        QStringLiteral(u"ok_hand_medium_light_skin_tone"),
        QStringLiteral(u"OK hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44C\U0001F3FD"),
        QStringLiteral(u"ok_hand_medium_skin_tone"),
        QStringLiteral(u"OK hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44C\U0001F3FE"),
        QStringLiteral(u"ok_hand_medium_dark_skin_tone"),
        QStringLiteral(u"OK hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44C\U0001F3FF"),
        QStringLiteral(u"ok_hand_dark_skin_tone"),
        QStringLiteral(u"OK hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90C"),
        QStringLiteral(u"pinched_fingers"),
        QStringLiteral(u"pinched fingers"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90C\U0001F3FB"),
        QStringLiteral(u"pinched_fingers_light_skin_tone"),
        QStringLiteral(u"pinched fingers: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90C\U0001F3FC"),
        QStringLiteral(u"pinched_fingers_medium_light_skin_tone"),
        QStringLiteral(u"pinched fingers: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90C\U0001F3FD"),
        QStringLiteral(u"pinched_fingers_medium_skin_tone"),
        QStringLiteral(u"pinched fingers: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90C\U0001F3FE"),
        QStringLiteral(u"pinched_fingers_medium_dark_skin_tone"),
        QStringLiteral(u"pinched fingers: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90C\U0001F3FF"),
        QStringLiteral(u"pinched_fingers_dark_skin_tone"),
        QStringLiteral(u"pinched fingers: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90F"),
        QStringLiteral(u"pinching_hand"),
        QStringLiteral(u"pinching hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90F\U0001F3FB"),
        QStringLiteral(u"pinching_hand_light_skin_tone"),
        QStringLiteral(u"pinching hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90F\U0001F3FC"),
        QStringLiteral(u"pinching_hand_medium_light_skin_tone"),
        QStringLiteral(u"pinching hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90F\U0001F3FD"),
        QStringLiteral(u"pinching_hand_medium_skin_tone"),
        QStringLiteral(u"pinching hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90F\U0001F3FE"),
        QStringLiteral(u"pinching_hand_medium_dark_skin_tone"),
        QStringLiteral(u"pinching hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F90F\U0001F3FF"),
        QStringLiteral(u"pinching_hand_dark_skin_tone"),
        QStringLiteral(u"pinching hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270C\U0000FE0F"),
        QStringLiteral(u"victory_hand"),
        QStringLiteral(u"victory hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270C\U0001F3FB"),
        QStringLiteral(u"victory_hand_light_skin_tone"),
        QStringLiteral(u"victory hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270C\U0001F3FC"),
        QStringLiteral(u"victory_hand_medium_light_skin_tone"),
        QStringLiteral(u"victory hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270C\U0001F3FD"),
        QStringLiteral(u"victory_hand_medium_skin_tone"),
        QStringLiteral(u"victory hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270C\U0001F3FE"),
        QStringLiteral(u"victory_hand_medium_dark_skin_tone"),
        QStringLiteral(u"victory hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270C\U0001F3FF"),
        QStringLiteral(u"victory_hand_dark_skin_tone"),
        QStringLiteral(u"victory hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91E"),
        QStringLiteral(u"crossed_fingers"),
        QStringLiteral(u"crossed fingers"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91E\U0001F3FB"),
        QStringLiteral(u"crossed_fingers_light_skin_tone"),
        QStringLiteral(u"crossed fingers: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91E\U0001F3FC"),
        QStringLiteral(u"crossed_fingers_medium_light_skin_tone"),
        QStringLiteral(u"crossed fingers: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91E\U0001F3FD"),
        QStringLiteral(u"crossed_fingers_medium_skin_tone"),
        QStringLiteral(u"crossed fingers: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91E\U0001F3FE"),
        QStringLiteral(u"crossed_fingers_medium_dark_skin_tone"),
        QStringLiteral(u"crossed fingers: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91E\U0001F3FF"),
        QStringLiteral(u"crossed_fingers_dark_skin_tone"),
        QStringLiteral(u"crossed fingers: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF0"),
        QStringLiteral(u"hand_with_index_finger_and_thumb_crossed"),
        QStringLiteral(u"hand with index finger and thumb crossed"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF0\U0001F3FB"),
        QStringLiteral(u"hand_with_index_finger_and_thumb_crossed_light_skin_tone"),
        QStringLiteral(u"hand with index finger and thumb crossed: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF0\U0001F3FC"),
        QStringLiteral(u"hand_with_index_finger_and_thumb_crossed_medium_light_skin_tone"),
        QStringLiteral(u"hand with index finger and thumb crossed: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF0\U0001F3FD"),
        QStringLiteral(u"hand_with_index_finger_and_thumb_crossed_medium_skin_tone"),
        QStringLiteral(u"hand with index finger and thumb crossed: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF0\U0001F3FE"),
        QStringLiteral(u"hand_with_index_finger_and_thumb_crossed_medium_dark_skin_tone"),
        QStringLiteral(u"hand with index finger and thumb crossed: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF0\U0001F3FF"),
        QStringLiteral(u"hand_with_index_finger_and_thumb_crossed_dark_skin_tone"),
        QStringLiteral(u"hand with index finger and thumb crossed: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91F"),
        QStringLiteral(u"love_you_gesture"),
        QStringLiteral(u"love-you gesture"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91F\U0001F3FB"),
        QStringLiteral(u"love_you_gesture_light_skin_tone"),
        QStringLiteral(u"love-you gesture: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91F\U0001F3FC"),
        QStringLiteral(u"love_you_gesture_medium_light_skin_tone"),
        QStringLiteral(u"love-you gesture: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91F\U0001F3FD"),
        QStringLiteral(u"love_you_gesture_medium_skin_tone"),
        QStringLiteral(u"love-you gesture: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91F\U0001F3FE"),
        QStringLiteral(u"love_you_gesture_medium_dark_skin_tone"),
        QStringLiteral(u"love-you gesture: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91F\U0001F3FF"),
        QStringLiteral(u"love_you_gesture_dark_skin_tone"),
        QStringLiteral(u"love-you gesture: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F918"),
        QStringLiteral(u"sign_of_the_horns"),
        QStringLiteral(u"sign of the horns"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F918\U0001F3FB"),
        QStringLiteral(u"sign_of_the_horns_light_skin_tone"),
        QStringLiteral(u"sign of the horns: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F918\U0001F3FC"),
        QStringLiteral(u"sign_of_the_horns_medium_light_skin_tone"),
        QStringLiteral(u"sign of the horns: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F918\U0001F3FD"),
        QStringLiteral(u"sign_of_the_horns_medium_skin_tone"),
        QStringLiteral(u"sign of the horns: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F918\U0001F3FE"),
        QStringLiteral(u"sign_of_the_horns_medium_dark_skin_tone"),
        QStringLiteral(u"sign of the horns: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F918\U0001F3FF"),
        QStringLiteral(u"sign_of_the_horns_dark_skin_tone"),
        QStringLiteral(u"sign of the horns: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F919"),
        QStringLiteral(u"call_me_hand"),
        QStringLiteral(u"call me hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F919\U0001F3FB"),
        QStringLiteral(u"call_me_hand_light_skin_tone"),
        QStringLiteral(u"call me hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F919\U0001F3FC"),
        QStringLiteral(u"call_me_hand_medium_light_skin_tone"),
        QStringLiteral(u"call me hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F919\U0001F3FD"),
        QStringLiteral(u"call_me_hand_medium_skin_tone"),
        QStringLiteral(u"call me hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F919\U0001F3FE"),
        QStringLiteral(u"call_me_hand_medium_dark_skin_tone"),
        QStringLiteral(u"call me hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F919\U0001F3FF"),
        QStringLiteral(u"call_me_hand_dark_skin_tone"),
        QStringLiteral(u"call me hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F448"),
        QStringLiteral(u"point_left"),
        QStringLiteral(u"backhand index pointing left"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F448\U0001F3FB"),
        QStringLiteral(u"backhand_index_pointing_left_light_skin_tone"),
        QStringLiteral(u"backhand index pointing left: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F448\U0001F3FC"),
        QStringLiteral(u"backhand_index_pointing_left_medium_light_skin_tone"),
        QStringLiteral(u"backhand index pointing left: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F448\U0001F3FD"),
        QStringLiteral(u"backhand_index_pointing_left_medium_skin_tone"),
        QStringLiteral(u"backhand index pointing left: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F448\U0001F3FE"),
        QStringLiteral(u"backhand_index_pointing_left_medium_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing left: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F448\U0001F3FF"),
        QStringLiteral(u"backhand_index_pointing_left_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing left: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F449"),
        QStringLiteral(u"point_right"),
        QStringLiteral(u"backhand index pointing right"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F449\U0001F3FB"),
        QStringLiteral(u"backhand_index_pointing_right_light_skin_tone"),
        QStringLiteral(u"backhand index pointing right: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F449\U0001F3FC"),
        QStringLiteral(u"backhand_index_pointing_right_medium_light_skin_tone"),
        QStringLiteral(u"backhand index pointing right: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F449\U0001F3FD"),
        QStringLiteral(u"backhand_index_pointing_right_medium_skin_tone"),
        QStringLiteral(u"backhand index pointing right: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F449\U0001F3FE"),
        QStringLiteral(u"backhand_index_pointing_right_medium_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing right: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F449\U0001F3FF"),
        QStringLiteral(u"backhand_index_pointing_right_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing right: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F446"),
        QStringLiteral(u"point_up_2"),
        QStringLiteral(u"backhand index pointing up"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F446\U0001F3FB"),
        QStringLiteral(u"backhand_index_pointing_up_light_skin_tone"),
        QStringLiteral(u"backhand index pointing up: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F446\U0001F3FC"),
        QStringLiteral(u"backhand_index_pointing_up_medium_light_skin_tone"),
        QStringLiteral(u"backhand index pointing up: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F446\U0001F3FD"),
        QStringLiteral(u"backhand_index_pointing_up_medium_skin_tone"),
        QStringLiteral(u"backhand index pointing up: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F446\U0001F3FE"),
        QStringLiteral(u"backhand_index_pointing_up_medium_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing up: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F446\U0001F3FF"),
        QStringLiteral(u"backhand_index_pointing_up_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing up: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F595"),
        QStringLiteral(u"middle_finger"),
        QStringLiteral(u"middle finger"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F595\U0001F3FB"),
        QStringLiteral(u"middle_finger_light_skin_tone"),
        QStringLiteral(u"middle finger: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F595\U0001F3FC"),
        QStringLiteral(u"middle_finger_medium_light_skin_tone"),
        QStringLiteral(u"middle finger: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F595\U0001F3FD"),
        QStringLiteral(u"middle_finger_medium_skin_tone"),
        QStringLiteral(u"middle finger: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F595\U0001F3FE"),
        QStringLiteral(u"middle_finger_medium_dark_skin_tone"),
        QStringLiteral(u"middle finger: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F595\U0001F3FF"),
        QStringLiteral(u"middle_finger_dark_skin_tone"),
        QStringLiteral(u"middle finger: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F447"),
        QStringLiteral(u"point_down"),
        QStringLiteral(u"backhand index pointing down"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F447\U0001F3FB"),
        QStringLiteral(u"backhand_index_pointing_down_light_skin_tone"),
        QStringLiteral(u"backhand index pointing down: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F447\U0001F3FC"),
        QStringLiteral(u"backhand_index_pointing_down_medium_light_skin_tone"),
        QStringLiteral(u"backhand index pointing down: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F447\U0001F3FD"),
        QStringLiteral(u"backhand_index_pointing_down_medium_skin_tone"),
        QStringLiteral(u"backhand index pointing down: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F447\U0001F3FE"),
        QStringLiteral(u"backhand_index_pointing_down_medium_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing down: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F447\U0001F3FF"),
        QStringLiteral(u"backhand_index_pointing_down_dark_skin_tone"),
        QStringLiteral(u"backhand index pointing down: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000261D\U0000FE0F"),
        QStringLiteral(u"point_up"),
        QStringLiteral(u"index pointing up"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000261D\U0001F3FB"),
        QStringLiteral(u"index_pointing_up_light_skin_tone"),
        QStringLiteral(u"index pointing up: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000261D\U0001F3FC"),
        QStringLiteral(u"index_pointing_up_medium_light_skin_tone"),
        QStringLiteral(u"index pointing up: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000261D\U0001F3FD"),
        QStringLiteral(u"index_pointing_up_medium_skin_tone"),
        QStringLiteral(u"index pointing up: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000261D\U0001F3FE"),
        QStringLiteral(u"index_pointing_up_medium_dark_skin_tone"),
        QStringLiteral(u"index pointing up: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000261D\U0001F3FF"),
        QStringLiteral(u"index_pointing_up_dark_skin_tone"),
        QStringLiteral(u"index pointing up: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF5"),
        QStringLiteral(u"point_you"),
        QStringLiteral(u"index pointing at the viewer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF5\U0001F3FB"),
        QStringLiteral(u"index_pointing_at_the_viewer_light_skin_tone"),
        QStringLiteral(u"index pointing at the viewer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF5\U0001F3FC"),
        QStringLiteral(u"index_pointing_at_the_viewer_medium_light_skin_tone"),
        QStringLiteral(u"index pointing at the viewer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF5\U0001F3FD"),
        QStringLiteral(u"index_pointing_at_the_viewer_medium_skin_tone"),
        QStringLiteral(u"index pointing at the viewer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF5\U0001F3FE"),
        QStringLiteral(u"index_pointing_at_the_viewer_medium_dark_skin_tone"),
        QStringLiteral(u"index pointing at the viewer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF5\U0001F3FF"),
        QStringLiteral(u"index_pointing_at_the_viewer_dark_skin_tone"),
        QStringLiteral(u"index pointing at the viewer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44D"),
        QStringLiteral(u"thumbs_up"),
        QStringLiteral(u"thumbs up"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44D\U0001F3FB"),
        QStringLiteral(u"thumbs_up_light_skin_tone"),
        QStringLiteral(u"thumbs up: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44D\U0001F3FC"),
        QStringLiteral(u"thumbs_up_medium_light_skin_tone"),
        QStringLiteral(u"thumbs up: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44D\U0001F3FD"),
        QStringLiteral(u"thumbs_up_medium_skin_tone"),
        QStringLiteral(u"thumbs up: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44D\U0001F3FE"),
        QStringLiteral(u"thumbs_up_medium_dark_skin_tone"),
        QStringLiteral(u"thumbs up: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44D\U0001F3FF"),
        QStringLiteral(u"thumbs_up_dark_skin_tone"),
        QStringLiteral(u"thumbs up: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44E"),
        QStringLiteral(u"thumbs_down"),
        QStringLiteral(u"thumbs down"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44E\U0001F3FB"),
        QStringLiteral(u"thumbs_down_light_skin_tone"),
        QStringLiteral(u"thumbs down: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44E\U0001F3FC"),
        QStringLiteral(u"thumbs_down_medium_light_skin_tone"),
        QStringLiteral(u"thumbs down: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44E\U0001F3FD"),
        QStringLiteral(u"thumbs_down_medium_skin_tone"),
        QStringLiteral(u"thumbs down: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44E\U0001F3FE"),
        QStringLiteral(u"thumbs_down_medium_dark_skin_tone"),
        QStringLiteral(u"thumbs down: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44E\U0001F3FF"),
        QStringLiteral(u"thumbs_down_dark_skin_tone"),
        QStringLiteral(u"thumbs down: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270A"),
        QStringLiteral(u"raised_fist"),
        QStringLiteral(u"raised fist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270A\U0001F3FB"),
        QStringLiteral(u"raised_fist_light_skin_tone"),
        QStringLiteral(u"raised fist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270A\U0001F3FC"),
        QStringLiteral(u"raised_fist_medium_light_skin_tone"),
        QStringLiteral(u"raised fist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270A\U0001F3FD"),
        QStringLiteral(u"raised_fist_medium_skin_tone"),
        QStringLiteral(u"raised fist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270A\U0001F3FE"),
        QStringLiteral(u"raised_fist_medium_dark_skin_tone"),
        QStringLiteral(u"raised fist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270A\U0001F3FF"),
        QStringLiteral(u"raised_fist_dark_skin_tone"),
        QStringLiteral(u"raised fist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44A"),
        QStringLiteral(u"oncoming_fist"),
        QStringLiteral(u"oncoming fist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44A\U0001F3FB"),
        QStringLiteral(u"oncoming_fist_light_skin_tone"),
        QStringLiteral(u"oncoming fist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44A\U0001F3FC"),
        QStringLiteral(u"oncoming_fist_medium_light_skin_tone"),
        QStringLiteral(u"oncoming fist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44A\U0001F3FD"),
        QStringLiteral(u"oncoming_fist_medium_skin_tone"),
        QStringLiteral(u"oncoming fist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44A\U0001F3FE"),
        QStringLiteral(u"oncoming_fist_medium_dark_skin_tone"),
        QStringLiteral(u"oncoming fist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44A\U0001F3FF"),
        QStringLiteral(u"oncoming_fist_dark_skin_tone"),
        QStringLiteral(u"oncoming fist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91B"),
        QStringLiteral(u"left_facing_fist"),
        QStringLiteral(u"left-facing fist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91B\U0001F3FB"),
        QStringLiteral(u"left_facing_fist_light_skin_tone"),
        QStringLiteral(u"left-facing fist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91B\U0001F3FC"),
        QStringLiteral(u"left_facing_fist_medium_light_skin_tone"),
        QStringLiteral(u"left-facing fist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91B\U0001F3FD"),
        QStringLiteral(u"left_facing_fist_medium_skin_tone"),
        QStringLiteral(u"left-facing fist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91B\U0001F3FE"),
        QStringLiteral(u"left_facing_fist_medium_dark_skin_tone"),
        QStringLiteral(u"left-facing fist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91B\U0001F3FF"),
        QStringLiteral(u"left_facing_fist_dark_skin_tone"),
        QStringLiteral(u"left-facing fist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91C"),
        QStringLiteral(u"right_facing_fist"),
        QStringLiteral(u"right-facing fist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91C\U0001F3FB"),
        QStringLiteral(u"right_facing_fist_light_skin_tone"),
        QStringLiteral(u"right-facing fist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91C\U0001F3FC"),
        QStringLiteral(u"right_facing_fist_medium_light_skin_tone"),
        QStringLiteral(u"right-facing fist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91C\U0001F3FD"),
        QStringLiteral(u"right_facing_fist_medium_skin_tone"),
        QStringLiteral(u"right-facing fist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91C\U0001F3FE"),
        QStringLiteral(u"right_facing_fist_medium_dark_skin_tone"),
        QStringLiteral(u"right-facing fist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91C\U0001F3FF"),
        QStringLiteral(u"right_facing_fist_dark_skin_tone"),
        QStringLiteral(u"right-facing fist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44F"),
        QStringLiteral(u"clapping_hands"),
        QStringLiteral(u"clapping hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44F\U0001F3FB"),
        QStringLiteral(u"clapping_hands_light_skin_tone"),
        QStringLiteral(u"clapping hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44F\U0001F3FC"),
        QStringLiteral(u"clapping_hands_medium_light_skin_tone"),
        QStringLiteral(u"clapping hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44F\U0001F3FD"),
        QStringLiteral(u"clapping_hands_medium_skin_tone"),
        QStringLiteral(u"clapping hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44F\U0001F3FE"),
        QStringLiteral(u"clapping_hands_medium_dark_skin_tone"),
        QStringLiteral(u"clapping hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F44F\U0001F3FF"),
        QStringLiteral(u"clapping_hands_dark_skin_tone"),
        QStringLiteral(u"clapping hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64C"),
        QStringLiteral(u"raising_hands"),
        QStringLiteral(u"raising hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64C\U0001F3FB"),
        QStringLiteral(u"raising_hands_light_skin_tone"),
        QStringLiteral(u"raising hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64C\U0001F3FC"),
        QStringLiteral(u"raising_hands_medium_light_skin_tone"),
        QStringLiteral(u"raising hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64C\U0001F3FD"),
        QStringLiteral(u"raising_hands_medium_skin_tone"),
        QStringLiteral(u"raising hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64C\U0001F3FE"),
        QStringLiteral(u"raising_hands_medium_dark_skin_tone"),
        QStringLiteral(u"raising hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64C\U0001F3FF"),
        QStringLiteral(u"raising_hands_dark_skin_tone"),
        QStringLiteral(u"raising hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF6"),
        QStringLiteral(u"heart_hands"),
        QStringLiteral(u"heart hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF6\U0001F3FB"),
        QStringLiteral(u"heart_hands_light_skin_tone"),
        QStringLiteral(u"heart hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF6\U0001F3FC"),
        QStringLiteral(u"heart_hands_medium_light_skin_tone"),
        QStringLiteral(u"heart hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF6\U0001F3FD"),
        QStringLiteral(u"heart_hands_medium_skin_tone"),
        QStringLiteral(u"heart hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF6\U0001F3FE"),
        QStringLiteral(u"heart_hands_medium_dark_skin_tone"),
        QStringLiteral(u"heart hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF6\U0001F3FF"),
        QStringLiteral(u"heart_hands_dark_skin_tone"),
        QStringLiteral(u"heart hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F450"),
        QStringLiteral(u"open_hands"),
        QStringLiteral(u"open hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F450\U0001F3FB"),
        QStringLiteral(u"open_hands_light_skin_tone"),
        QStringLiteral(u"open hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F450\U0001F3FC"),
        QStringLiteral(u"open_hands_medium_light_skin_tone"),
        QStringLiteral(u"open hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F450\U0001F3FD"),
        QStringLiteral(u"open_hands_medium_skin_tone"),
        QStringLiteral(u"open hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F450\U0001F3FE"),
        QStringLiteral(u"open_hands_medium_dark_skin_tone"),
        QStringLiteral(u"open hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F450\U0001F3FF"),
        QStringLiteral(u"open_hands_dark_skin_tone"),
        QStringLiteral(u"open hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F932"),
        QStringLiteral(u"palms_up_together"),
        QStringLiteral(u"palms up together"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F932\U0001F3FB"),
        QStringLiteral(u"palms_up_together_light_skin_tone"),
        QStringLiteral(u"palms up together: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F932\U0001F3FC"),
        QStringLiteral(u"palms_up_together_medium_light_skin_tone"),
        QStringLiteral(u"palms up together: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F932\U0001F3FD"),
        QStringLiteral(u"palms_up_together_medium_skin_tone"),
        QStringLiteral(u"palms up together: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F932\U0001F3FE"),
        QStringLiteral(u"palms_up_together_medium_dark_skin_tone"),
        QStringLiteral(u"palms up together: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F932\U0001F3FF"),
        QStringLiteral(u"palms_up_together_dark_skin_tone"),
        QStringLiteral(u"palms up together: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91D"),
        QStringLiteral(u"handshake"),
        QStringLiteral(u"handshake"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91D\U0001F3FB"),
        QStringLiteral(u"handshake_light_skin_tone"),
        QStringLiteral(u"handshake: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91D\U0001F3FC"),
        QStringLiteral(u"handshake_medium_light_skin_tone"),
        QStringLiteral(u"handshake: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91D\U0001F3FD"),
        QStringLiteral(u"handshake_medium_skin_tone"),
        QStringLiteral(u"handshake: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91D\U0001F3FE"),
        QStringLiteral(u"handshake_medium_dark_skin_tone"),
        QStringLiteral(u"handshake: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F91D\U0001F3FF"),
        QStringLiteral(u"handshake_dark_skin_tone"),
        QStringLiteral(u"handshake: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FB\U0000200D\U0001FAF2\U0001F3FC"),
        QStringLiteral(u"handshake_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"handshake: light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FB\U0000200D\U0001FAF2\U0001F3FD"),
        QStringLiteral(u"handshake_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"handshake: light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FB\U0000200D\U0001FAF2\U0001F3FE"),
        QStringLiteral(u"handshake_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"handshake: light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FB\U0000200D\U0001FAF2\U0001F3FF"),
        QStringLiteral(u"handshake_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"handshake: light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FC\U0000200D\U0001FAF2\U0001F3FB"),
        QStringLiteral(u"handshake_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"handshake: medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FC\U0000200D\U0001FAF2\U0001F3FD"),
        QStringLiteral(u"handshake_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"handshake: medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FC\U0000200D\U0001FAF2\U0001F3FE"),
        QStringLiteral(u"handshake_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"handshake: medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FC\U0000200D\U0001FAF2\U0001F3FF"),
        QStringLiteral(u"handshake_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"handshake: medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FD\U0000200D\U0001FAF2\U0001F3FB"),
        QStringLiteral(u"handshake_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"handshake: medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FD\U0000200D\U0001FAF2\U0001F3FC"),
        QStringLiteral(u"handshake_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"handshake: medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FD\U0000200D\U0001FAF2\U0001F3FE"),
        QStringLiteral(u"handshake_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"handshake: medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FD\U0000200D\U0001FAF2\U0001F3FF"),
        QStringLiteral(u"handshake_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"handshake: medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FE\U0000200D\U0001FAF2\U0001F3FB"),
        QStringLiteral(u"handshake_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"handshake: medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FE\U0000200D\U0001FAF2\U0001F3FC"),
        QStringLiteral(u"handshake_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"handshake: medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FE\U0000200D\U0001FAF2\U0001F3FD"),
        QStringLiteral(u"handshake_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"handshake: medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FE\U0000200D\U0001FAF2\U0001F3FF"),
        QStringLiteral(u"handshake_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"handshake: medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FF\U0000200D\U0001FAF2\U0001F3FB"),
        QStringLiteral(u"handshake_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"handshake: dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FF\U0000200D\U0001FAF2\U0001F3FC"),
        QStringLiteral(u"handshake_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"handshake: dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FF\U0000200D\U0001FAF2\U0001F3FD"),
        QStringLiteral(u"handshake_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"handshake: dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAF1\U0001F3FF\U0000200D\U0001FAF2\U0001F3FE"),
        QStringLiteral(u"handshake_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"handshake: dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64F"),
        QStringLiteral(u"folded_hands"),
        QStringLiteral(u"folded hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64F\U0001F3FB"),
        QStringLiteral(u"folded_hands_light_skin_tone"),
        QStringLiteral(u"folded hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64F\U0001F3FC"),
        QStringLiteral(u"folded_hands_medium_light_skin_tone"),
        QStringLiteral(u"folded hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64F\U0001F3FD"),
        QStringLiteral(u"folded_hands_medium_skin_tone"),
        QStringLiteral(u"folded hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64F\U0001F3FE"),
        QStringLiteral(u"folded_hands_medium_dark_skin_tone"),
        QStringLiteral(u"folded hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64F\U0001F3FF"),
        QStringLiteral(u"folded_hands_dark_skin_tone"),
        QStringLiteral(u"folded hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270D\U0000FE0F"),
        QStringLiteral(u"writing_hand"),
        QStringLiteral(u"writing hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270D\U0001F3FB"),
        QStringLiteral(u"writing_hand_light_skin_tone"),
        QStringLiteral(u"writing hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270D\U0001F3FC"),
        QStringLiteral(u"writing_hand_medium_light_skin_tone"),
        QStringLiteral(u"writing hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270D\U0001F3FD"),
        QStringLiteral(u"writing_hand_medium_skin_tone"),
        QStringLiteral(u"writing hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270D\U0001F3FE"),
        QStringLiteral(u"writing_hand_medium_dark_skin_tone"),
        QStringLiteral(u"writing hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0000270D\U0001F3FF"),
        QStringLiteral(u"writing_hand_dark_skin_tone"),
        QStringLiteral(u"writing hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F485"),
        QStringLiteral(u"nail_polish"),
        QStringLiteral(u"nail polish"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F485\U0001F3FB"),
        QStringLiteral(u"nail_polish_light_skin_tone"),
        QStringLiteral(u"nail polish: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F485\U0001F3FC"),
        QStringLiteral(u"nail_polish_medium_light_skin_tone"),
        QStringLiteral(u"nail polish: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F485\U0001F3FD"),
        QStringLiteral(u"nail_polish_medium_skin_tone"),
        QStringLiteral(u"nail polish: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F485\U0001F3FE"),
        QStringLiteral(u"nail_polish_medium_dark_skin_tone"),
        QStringLiteral(u"nail polish: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F485\U0001F3FF"),
        QStringLiteral(u"nail_polish_dark_skin_tone"),
        QStringLiteral(u"nail polish: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F933"),
        QStringLiteral(u"selfie"),
        QStringLiteral(u"selfie"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F933\U0001F3FB"),
        QStringLiteral(u"selfie_light_skin_tone"),
        QStringLiteral(u"selfie: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F933\U0001F3FC"),
        QStringLiteral(u"selfie_medium_light_skin_tone"),
        QStringLiteral(u"selfie: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F933\U0001F3FD"),
        QStringLiteral(u"selfie_medium_skin_tone"),
        QStringLiteral(u"selfie: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F933\U0001F3FE"),
        QStringLiteral(u"selfie_medium_dark_skin_tone"),
        QStringLiteral(u"selfie: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F933\U0001F3FF"),
        QStringLiteral(u"selfie_dark_skin_tone"),
        QStringLiteral(u"selfie: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AA"),
        QStringLiteral(u"flexed_biceps"),
        QStringLiteral(u"flexed biceps"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AA\U0001F3FB"),
        QStringLiteral(u"flexed_biceps_light_skin_tone"),
        QStringLiteral(u"flexed biceps: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AA\U0001F3FC"),
        QStringLiteral(u"flexed_biceps_medium_light_skin_tone"),
        QStringLiteral(u"flexed biceps: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AA\U0001F3FD"),
        QStringLiteral(u"flexed_biceps_medium_skin_tone"),
        QStringLiteral(u"flexed biceps: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AA\U0001F3FE"),
        QStringLiteral(u"flexed_biceps_medium_dark_skin_tone"),
        QStringLiteral(u"flexed biceps: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F4AA\U0001F3FF"),
        QStringLiteral(u"flexed_biceps_dark_skin_tone"),
        QStringLiteral(u"flexed biceps: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BE"),
        QStringLiteral(u"mechanical_arm"),
        QStringLiteral(u"mechanical arm"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BF"),
        QStringLiteral(u"mechanical_leg"),
        QStringLiteral(u"mechanical leg"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B5"),
        QStringLiteral(u"leg"),
        QStringLiteral(u"leg"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B5\U0001F3FB"),
        QStringLiteral(u"leg_light_skin_tone"),
        QStringLiteral(u"leg: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B5\U0001F3FC"),
        QStringLiteral(u"leg_medium_light_skin_tone"),
        QStringLiteral(u"leg: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B5\U0001F3FD"),
        QStringLiteral(u"leg_medium_skin_tone"),
        QStringLiteral(u"leg: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B5\U0001F3FE"),
        QStringLiteral(u"leg_medium_dark_skin_tone"),
        QStringLiteral(u"leg: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B5\U0001F3FF"),
        QStringLiteral(u"leg_dark_skin_tone"),
        QStringLiteral(u"leg: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B6"),
        QStringLiteral(u"foot"),
        QStringLiteral(u"foot"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B6\U0001F3FB"),
        QStringLiteral(u"foot_light_skin_tone"),
        QStringLiteral(u"foot: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B6\U0001F3FC"),
        QStringLiteral(u"foot_medium_light_skin_tone"),
        QStringLiteral(u"foot: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B6\U0001F3FD"),
        QStringLiteral(u"foot_medium_skin_tone"),
        QStringLiteral(u"foot: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B6\U0001F3FE"),
        QStringLiteral(u"foot_medium_dark_skin_tone"),
        QStringLiteral(u"foot: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B6\U0001F3FF"),
        QStringLiteral(u"foot_dark_skin_tone"),
        QStringLiteral(u"foot: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F442"),
        QStringLiteral(u"ear"),
        QStringLiteral(u"ear"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F442\U0001F3FB"),
        QStringLiteral(u"ear_light_skin_tone"),
        QStringLiteral(u"ear: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F442\U0001F3FC"),
        QStringLiteral(u"ear_medium_light_skin_tone"),
        QStringLiteral(u"ear: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F442\U0001F3FD"),
        QStringLiteral(u"ear_medium_skin_tone"),
        QStringLiteral(u"ear: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F442\U0001F3FE"),
        QStringLiteral(u"ear_medium_dark_skin_tone"),
        QStringLiteral(u"ear: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F442\U0001F3FF"),
        QStringLiteral(u"ear_dark_skin_tone"),
        QStringLiteral(u"ear: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BB"),
        QStringLiteral(u"ear_with_hearing_aid"),
        QStringLiteral(u"ear with hearing aid"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BB\U0001F3FB"),
        QStringLiteral(u"ear_with_hearing_aid_light_skin_tone"),
        QStringLiteral(u"ear with hearing aid: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BB\U0001F3FC"),
        QStringLiteral(u"ear_with_hearing_aid_medium_light_skin_tone"),
        QStringLiteral(u"ear with hearing aid: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BB\U0001F3FD"),
        QStringLiteral(u"ear_with_hearing_aid_medium_skin_tone"),
        QStringLiteral(u"ear with hearing aid: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BB\U0001F3FE"),
        QStringLiteral(u"ear_with_hearing_aid_medium_dark_skin_tone"),
        QStringLiteral(u"ear with hearing aid: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9BB\U0001F3FF"),
        QStringLiteral(u"ear_with_hearing_aid_dark_skin_tone"),
        QStringLiteral(u"ear with hearing aid: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F443"),
        QStringLiteral(u"nose"),
        QStringLiteral(u"nose"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F443\U0001F3FB"),
        QStringLiteral(u"nose_light_skin_tone"),
        QStringLiteral(u"nose: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F443\U0001F3FC"),
        QStringLiteral(u"nose_medium_light_skin_tone"),
        QStringLiteral(u"nose: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F443\U0001F3FD"),
        QStringLiteral(u"nose_medium_skin_tone"),
        QStringLiteral(u"nose: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F443\U0001F3FE"),
        QStringLiteral(u"nose_medium_dark_skin_tone"),
        QStringLiteral(u"nose: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F443\U0001F3FF"),
        QStringLiteral(u"nose_dark_skin_tone"),
        QStringLiteral(u"nose: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9E0"),
        QStringLiteral(u"brain"),
        QStringLiteral(u"brain"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC0"),
        QStringLiteral(u"anatomical_heart"),
        QStringLiteral(u"anatomical heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC1"),
        QStringLiteral(u"lungs"),
        QStringLiteral(u"lungs"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B7"),
        QStringLiteral(u"tooth"),
        QStringLiteral(u"tooth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B4"),
        QStringLiteral(u"bone"),
        QStringLiteral(u"bone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F440"),
        QStringLiteral(u"eyes"),
        QStringLiteral(u"eyes"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F441\U0000FE0F"),
        QStringLiteral(u"eye"),
        QStringLiteral(u"eye"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F445"),
        QStringLiteral(u"tongue"),
        QStringLiteral(u"tongue"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F444"),
        QStringLiteral(u"mouth"),
        QStringLiteral(u"mouth"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAE6"),
        QStringLiteral(u"biting_lip"),
        QStringLiteral(u"biting lip"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F476"),
        QStringLiteral(u"baby"),
        QStringLiteral(u"baby"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F476\U0001F3FB"),
        QStringLiteral(u"baby_light_skin_tone"),
        QStringLiteral(u"baby: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F476\U0001F3FC"),
        QStringLiteral(u"baby_medium_light_skin_tone"),
        QStringLiteral(u"baby: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F476\U0001F3FD"),
        QStringLiteral(u"baby_medium_skin_tone"),
        QStringLiteral(u"baby: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F476\U0001F3FE"),
        QStringLiteral(u"baby_medium_dark_skin_tone"),
        QStringLiteral(u"baby: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F476\U0001F3FF"),
        QStringLiteral(u"baby_dark_skin_tone"),
        QStringLiteral(u"baby: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D2"),
        QStringLiteral(u"child"),
        QStringLiteral(u"child"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D2\U0001F3FB"),
        QStringLiteral(u"child_light_skin_tone"),
        QStringLiteral(u"child: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D2\U0001F3FC"),
        QStringLiteral(u"child_medium_light_skin_tone"),
        QStringLiteral(u"child: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D2\U0001F3FD"),
        QStringLiteral(u"child_medium_skin_tone"),
        QStringLiteral(u"child: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D2\U0001F3FE"),
        QStringLiteral(u"child_medium_dark_skin_tone"),
        QStringLiteral(u"child: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D2\U0001F3FF"),
        QStringLiteral(u"child_dark_skin_tone"),
        QStringLiteral(u"child: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F466"),
        QStringLiteral(u"boy"),
        QStringLiteral(u"boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F466\U0001F3FB"),
        QStringLiteral(u"boy_light_skin_tone"),
        QStringLiteral(u"boy: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F466\U0001F3FC"),
        QStringLiteral(u"boy_medium_light_skin_tone"),
        QStringLiteral(u"boy: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F466\U0001F3FD"),
        QStringLiteral(u"boy_medium_skin_tone"),
        QStringLiteral(u"boy: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F466\U0001F3FE"),
        QStringLiteral(u"boy_medium_dark_skin_tone"),
        QStringLiteral(u"boy: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F466\U0001F3FF"),
        QStringLiteral(u"boy_dark_skin_tone"),
        QStringLiteral(u"boy: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F467"),
        QStringLiteral(u"girl"),
        QStringLiteral(u"girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F467\U0001F3FB"),
        QStringLiteral(u"girl_light_skin_tone"),
        QStringLiteral(u"girl: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F467\U0001F3FC"),
        QStringLiteral(u"girl_medium_light_skin_tone"),
        QStringLiteral(u"girl: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F467\U0001F3FD"),
        QStringLiteral(u"girl_medium_skin_tone"),
        QStringLiteral(u"girl: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F467\U0001F3FE"),
        QStringLiteral(u"girl_medium_dark_skin_tone"),
        QStringLiteral(u"girl: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F467\U0001F3FF"),
        QStringLiteral(u"girl_dark_skin_tone"),
        QStringLiteral(u"girl: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1"),
        QStringLiteral(u"person"),
        QStringLiteral(u"person"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"person_light_skin_tone"),
        QStringLiteral(u"person: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"person_medium_light_skin_tone"),
        QStringLiteral(u"person: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"person_medium_skin_tone"),
        QStringLiteral(u"person: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"person_medium_dark_skin_tone"),
        QStringLiteral(u"person: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"person_dark_skin_tone"),
        QStringLiteral(u"person: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471"),
        QStringLiteral(u"person_blond_hair"),
        QStringLiteral(u"person: blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FB"),
        QStringLiteral(u"person_light_skin_tone_blond_hair"),
        QStringLiteral(u"person: light skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FC"),
        QStringLiteral(u"person_medium_light_skin_tone_blond_hair"),
        QStringLiteral(u"person: medium-light skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FD"),
        QStringLiteral(u"person_medium_skin_tone_blond_hair"),
        QStringLiteral(u"person: medium skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FE"),
        QStringLiteral(u"person_medium_dark_skin_tone_blond_hair"),
        QStringLiteral(u"person: medium-dark skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FF"),
        QStringLiteral(u"person_dark_skin_tone_blond_hair"),
        QStringLiteral(u"person: dark skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468"),
        QStringLiteral(u"man"),
        QStringLiteral(u"man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB"),
        QStringLiteral(u"man_light_skin_tone"),
        QStringLiteral(u"man: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC"),
        QStringLiteral(u"man_medium_light_skin_tone"),
        QStringLiteral(u"man: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD"),
        QStringLiteral(u"man_medium_skin_tone"),
        QStringLiteral(u"man: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE"),
        QStringLiteral(u"man_medium_dark_skin_tone"),
        QStringLiteral(u"man: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF"),
        QStringLiteral(u"man_dark_skin_tone"),
        QStringLiteral(u"man: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4"),
        QStringLiteral(u"bearded_person"),
        QStringLiteral(u"person: beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FB"),
        QStringLiteral(u"person_light_skin_tone_beard"),
        QStringLiteral(u"person: light skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FC"),
        QStringLiteral(u"person_medium_light_skin_tone_beard"),
        QStringLiteral(u"person: medium-light skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FD"),
        QStringLiteral(u"person_medium_skin_tone_beard"),
        QStringLiteral(u"person: medium skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FE"),
        QStringLiteral(u"person_medium_dark_skin_tone_beard"),
        QStringLiteral(u"person: medium-dark skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FF"),
        QStringLiteral(u"person_dark_skin_tone_beard"),
        QStringLiteral(u"person: dark skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"bearded_man"),
        QStringLiteral(u"man: beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_light_skin_tone_beard"),
        QStringLiteral(u"man: light skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_medium_light_skin_tone_beard"),
        QStringLiteral(u"man: medium-light skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_medium_skin_tone_beard"),
        QStringLiteral(u"man: medium skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_medium_dark_skin_tone_beard"),
        QStringLiteral(u"man: medium-dark skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_dark_skin_tone_beard"),
        QStringLiteral(u"man: dark skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"bearded_woman"),
        QStringLiteral(u"woman: beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_light_skin_tone_beard"),
        QStringLiteral(u"woman: light skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_medium_light_skin_tone_beard"),
        QStringLiteral(u"woman: medium-light skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_medium_skin_tone_beard"),
        QStringLiteral(u"woman: medium skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_medium_dark_skin_tone_beard"),
        QStringLiteral(u"woman: medium-dark skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D4\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_dark_skin_tone_beard"),
        QStringLiteral(u"woman: dark skin tone, beard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F9B0"),
        QStringLiteral(u"red_haired_man"),
        QStringLiteral(u"man: red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F9B0"),
        QStringLiteral(u"man_light_skin_tone_red_hair"),
        QStringLiteral(u"man: light skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F9B0"),
        QStringLiteral(u"man_medium_light_skin_tone_red_hair"),
        QStringLiteral(u"man: medium-light skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F9B0"),
        QStringLiteral(u"man_medium_skin_tone_red_hair"),
        QStringLiteral(u"man: medium skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F9B0"),
        QStringLiteral(u"man_medium_dark_skin_tone_red_hair"),
        QStringLiteral(u"man: medium-dark skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F9B0"),
        QStringLiteral(u"man_dark_skin_tone_red_hair"),
        QStringLiteral(u"man: dark skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F9B1"),
        QStringLiteral(u"curly_haired_man"),
        QStringLiteral(u"man: curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F9B1"),
        QStringLiteral(u"man_light_skin_tone_curly_hair"),
        QStringLiteral(u"man: light skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F9B1"),
        QStringLiteral(u"man_medium_light_skin_tone_curly_hair"),
        QStringLiteral(u"man: medium-light skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F9B1"),
        QStringLiteral(u"man_medium_skin_tone_curly_hair"),
        QStringLiteral(u"man: medium skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F9B1"),
        QStringLiteral(u"man_medium_dark_skin_tone_curly_hair"),
        QStringLiteral(u"man: medium-dark skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F9B1"),
        QStringLiteral(u"man_dark_skin_tone_curly_hair"),
        QStringLiteral(u"man: dark skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F9B3"),
        QStringLiteral(u"white_haried_man"),
        QStringLiteral(u"man: white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F9B3"),
        QStringLiteral(u"man_light_skin_tone_white_hair"),
        QStringLiteral(u"man: light skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F9B3"),
        QStringLiteral(u"man_medium_light_skin_tone_white_hair"),
        QStringLiteral(u"man: medium-light skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F9B3"),
        QStringLiteral(u"man_medium_skin_tone_white_hair"),
        QStringLiteral(u"man: medium skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F9B3"),
        QStringLiteral(u"man_medium_dark_skin_tone_white_hair"),
        QStringLiteral(u"man: medium-dark skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F9B3"),
        QStringLiteral(u"man_dark_skin_tone_white_hair"),
        QStringLiteral(u"man: dark skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F9B2"),
        QStringLiteral(u"bald_man"),
        QStringLiteral(u"man: bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F9B2"),
        QStringLiteral(u"man_light_skin_tone_bald"),
        QStringLiteral(u"man: light skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F9B2"),
        QStringLiteral(u"man_medium_light_skin_tone_bald"),
        QStringLiteral(u"man: medium-light skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F9B2"),
        QStringLiteral(u"man_medium_skin_tone_bald"),
        QStringLiteral(u"man: medium skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F9B2"),
        QStringLiteral(u"man_medium_dark_skin_tone_bald"),
        QStringLiteral(u"man: medium-dark skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F9B2"),
        QStringLiteral(u"man_dark_skin_tone_bald"),
        QStringLiteral(u"man: dark skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469"),
        QStringLiteral(u"woman"),
        QStringLiteral(u"woman"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB"),
        QStringLiteral(u"woman_light_skin_tone"),
        QStringLiteral(u"woman: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC"),
        QStringLiteral(u"woman_medium_light_skin_tone"),
        QStringLiteral(u"woman: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD"),
        QStringLiteral(u"woman_medium_skin_tone"),
        QStringLiteral(u"woman: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE"),
        QStringLiteral(u"woman_medium_dark_skin_tone"),
        QStringLiteral(u"woman: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF"),
        QStringLiteral(u"woman_dark_skin_tone"),
        QStringLiteral(u"woman: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F9B0"),
        QStringLiteral(u"red_haired_woman"),
        QStringLiteral(u"woman: red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F9B0"),
        QStringLiteral(u"woman_light_skin_tone_red_hair"),
        QStringLiteral(u"woman: light skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F9B0"),
        QStringLiteral(u"woman_medium_light_skin_tone_red_hair"),
        QStringLiteral(u"woman: medium-light skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F9B0"),
        QStringLiteral(u"woman_medium_skin_tone_red_hair"),
        QStringLiteral(u"woman: medium skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F9B0"),
        QStringLiteral(u"woman_medium_dark_skin_tone_red_hair"),
        QStringLiteral(u"woman: medium-dark skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F9B0"),
        QStringLiteral(u"woman_dark_skin_tone_red_hair"),
        QStringLiteral(u"woman: dark skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F9B0"),
        QStringLiteral(u"red_haired_person"),
        QStringLiteral(u"person: red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F9B0"),
        QStringLiteral(u"person_light_skin_tone_red_hair"),
        QStringLiteral(u"person: light skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F9B0"),
        QStringLiteral(u"person_medium_light_skin_tone_red_hair"),
        QStringLiteral(u"person: medium-light skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F9B0"),
        QStringLiteral(u"person_medium_skin_tone_red_hair"),
        QStringLiteral(u"person: medium skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F9B0"),
        QStringLiteral(u"person_medium_dark_skin_tone_red_hair"),
        QStringLiteral(u"person: medium-dark skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F9B0"),
        QStringLiteral(u"person_dark_skin_tone_red_hair"),
        QStringLiteral(u"person: dark skin tone, red hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F9B1"),
        QStringLiteral(u"curly_haired_woman"),
        QStringLiteral(u"woman: curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F9B1"),
        QStringLiteral(u"woman_light_skin_tone_curly_hair"),
        QStringLiteral(u"woman: light skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F9B1"),
        QStringLiteral(u"woman_medium_light_skin_tone_curly_hair"),
        QStringLiteral(u"woman: medium-light skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F9B1"),
        QStringLiteral(u"woman_medium_skin_tone_curly_hair"),
        QStringLiteral(u"woman: medium skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F9B1"),
        QStringLiteral(u"woman_medium_dark_skin_tone_curly_hair"),
        QStringLiteral(u"woman: medium-dark skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F9B1"),
        QStringLiteral(u"woman_dark_skin_tone_curly_hair"),
        QStringLiteral(u"woman: dark skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F9B1"),
        QStringLiteral(u"curly_haired_person"),
        QStringLiteral(u"person: curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F9B1"),
        QStringLiteral(u"person_light_skin_tone_curly_hair"),
        QStringLiteral(u"person: light skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F9B1"),
        QStringLiteral(u"person_medium_light_skin_tone_curly_hair"),
        QStringLiteral(u"person: medium-light skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F9B1"),
        QStringLiteral(u"person_medium_skin_tone_curly_hair"),
        QStringLiteral(u"person: medium skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F9B1"),
        QStringLiteral(u"person_medium_dark_skin_tone_curly_hair"),
        QStringLiteral(u"person: medium-dark skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F9B1"),
        QStringLiteral(u"person_dark_skin_tone_curly_hair"),
        QStringLiteral(u"person: dark skin tone, curly hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F9B3"),
        QStringLiteral(u"white_haried_woman"),
        QStringLiteral(u"woman: white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F9B3"),
        QStringLiteral(u"woman_light_skin_tone_white_hair"),
        QStringLiteral(u"woman: light skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F9B3"),
        QStringLiteral(u"woman_medium_light_skin_tone_white_hair"),
        QStringLiteral(u"woman: medium-light skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F9B3"),
        QStringLiteral(u"woman_medium_skin_tone_white_hair"),
        QStringLiteral(u"woman: medium skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F9B3"),
        QStringLiteral(u"woman_medium_dark_skin_tone_white_hair"),
        QStringLiteral(u"woman: medium-dark skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F9B3"),
        QStringLiteral(u"woman_dark_skin_tone_white_hair"),
        QStringLiteral(u"woman: dark skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F9B3"),
        QStringLiteral(u"white_haried_person"),
        QStringLiteral(u"person: white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F9B3"),
        QStringLiteral(u"person_light_skin_tone_white_hair"),
        QStringLiteral(u"person: light skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F9B3"),
        QStringLiteral(u"person_medium_light_skin_tone_white_hair"),
        QStringLiteral(u"person: medium-light skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F9B3"),
        QStringLiteral(u"person_medium_skin_tone_white_hair"),
        QStringLiteral(u"person: medium skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F9B3"),
        QStringLiteral(u"person_medium_dark_skin_tone_white_hair"),
        QStringLiteral(u"person: medium-dark skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F9B3"),
        QStringLiteral(u"person_dark_skin_tone_white_hair"),
        QStringLiteral(u"person: dark skin tone, white hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F9B2"),
        QStringLiteral(u"bald_woman"),
        QStringLiteral(u"woman: bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F9B2"),
        QStringLiteral(u"woman_light_skin_tone_bald"),
        QStringLiteral(u"woman: light skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F9B2"),
        QStringLiteral(u"woman_medium_light_skin_tone_bald"),
        QStringLiteral(u"woman: medium-light skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F9B2"),
        QStringLiteral(u"woman_medium_skin_tone_bald"),
        QStringLiteral(u"woman: medium skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F9B2"),
        QStringLiteral(u"woman_medium_dark_skin_tone_bald"),
        QStringLiteral(u"woman: medium-dark skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F9B2"),
        QStringLiteral(u"woman_dark_skin_tone_bald"),
        QStringLiteral(u"woman: dark skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F9B2"),
        QStringLiteral(u"bald_person"),
        QStringLiteral(u"person: bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F9B2"),
        QStringLiteral(u"person_light_skin_tone_bald"),
        QStringLiteral(u"person: light skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F9B2"),
        QStringLiteral(u"person_medium_light_skin_tone_bald"),
        QStringLiteral(u"person: medium-light skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F9B2"),
        QStringLiteral(u"person_medium_skin_tone_bald"),
        QStringLiteral(u"person: medium skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F9B2"),
        QStringLiteral(u"person_medium_dark_skin_tone_bald"),
        QStringLiteral(u"person: medium-dark skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F9B2"),
        QStringLiteral(u"person_dark_skin_tone_bald"),
        QStringLiteral(u"person: dark skin tone, bald"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_blond_hair"),
        QStringLiteral(u"woman: blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_light_skin_tone_blond_hair"),
        QStringLiteral(u"woman: light skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_medium_light_skin_tone_blond_hair"),
        QStringLiteral(u"woman: medium-light skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_medium_skin_tone_blond_hair"),
        QStringLiteral(u"woman: medium skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_medium_dark_skin_tone_blond_hair"),
        QStringLiteral(u"woman: medium-dark skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_dark_skin_tone_blond_hair"),
        QStringLiteral(u"woman: dark skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_blond_hair"),
        QStringLiteral(u"man: blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_light_skin_tone_blond_hair"),
        QStringLiteral(u"man: light skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_medium_light_skin_tone_blond_hair"),
        QStringLiteral(u"man: medium-light skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_medium_skin_tone_blond_hair"),
        QStringLiteral(u"man: medium skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_medium_dark_skin_tone_blond_hair"),
        QStringLiteral(u"man: medium-dark skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F471\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_dark_skin_tone_blond_hair"),
        QStringLiteral(u"man: dark skin tone, blond hair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D3"),
        QStringLiteral(u"older_person"),
        QStringLiteral(u"older person"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D3\U0001F3FB"),
        QStringLiteral(u"older_person_light_skin_tone"),
        QStringLiteral(u"older person: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D3\U0001F3FC"),
        QStringLiteral(u"older_person_medium_light_skin_tone"),
        QStringLiteral(u"older person: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D3\U0001F3FD"),
        QStringLiteral(u"older_person_medium_skin_tone"),
        QStringLiteral(u"older person: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D3\U0001F3FE"),
        QStringLiteral(u"older_person_medium_dark_skin_tone"),
        QStringLiteral(u"older person: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D3\U0001F3FF"),
        QStringLiteral(u"older_person_dark_skin_tone"),
        QStringLiteral(u"older person: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F474"),
        QStringLiteral(u"old_man"),
        QStringLiteral(u"old man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F474\U0001F3FB"),
        QStringLiteral(u"old_man_light_skin_tone"),
        QStringLiteral(u"old man: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F474\U0001F3FC"),
        QStringLiteral(u"old_man_medium_light_skin_tone"),
        QStringLiteral(u"old man: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F474\U0001F3FD"),
        QStringLiteral(u"old_man_medium_skin_tone"),
        QStringLiteral(u"old man: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F474\U0001F3FE"),
        QStringLiteral(u"old_man_medium_dark_skin_tone"),
        QStringLiteral(u"old man: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F474\U0001F3FF"),
        QStringLiteral(u"old_man_dark_skin_tone"),
        QStringLiteral(u"old man: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F475"),
        QStringLiteral(u"old_woman"),
        QStringLiteral(u"old woman"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F475\U0001F3FB"),
        QStringLiteral(u"old_woman_light_skin_tone"),
        QStringLiteral(u"old woman: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F475\U0001F3FC"),
        QStringLiteral(u"old_woman_medium_light_skin_tone"),
        QStringLiteral(u"old woman: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F475\U0001F3FD"),
        QStringLiteral(u"old_woman_medium_skin_tone"),
        QStringLiteral(u"old woman: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F475\U0001F3FE"),
        QStringLiteral(u"old_woman_medium_dark_skin_tone"),
        QStringLiteral(u"old woman: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F475\U0001F3FF"),
        QStringLiteral(u"old_woman_dark_skin_tone"),
        QStringLiteral(u"old woman: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D"),
        QStringLiteral(u"person_frowning"),
        QStringLiteral(u"person frowning"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FB"),
        QStringLiteral(u"person_frowning_light_skin_tone"),
        QStringLiteral(u"person frowning: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FC"),
        QStringLiteral(u"person_frowning_medium_light_skin_tone"),
        QStringLiteral(u"person frowning: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FD"),
        QStringLiteral(u"person_frowning_medium_skin_tone"),
        QStringLiteral(u"person frowning: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FE"),
        QStringLiteral(u"person_frowning_medium_dark_skin_tone"),
        QStringLiteral(u"person frowning: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FF"),
        QStringLiteral(u"person_frowning_dark_skin_tone"),
        QStringLiteral(u"person frowning: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_frowning"),
        QStringLiteral(u"man frowning"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_frowning_light_skin_tone"),
        QStringLiteral(u"man frowning: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_frowning_medium_light_skin_tone"),
        QStringLiteral(u"man frowning: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_frowning_medium_skin_tone"),
        QStringLiteral(u"man frowning: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_frowning_medium_dark_skin_tone"),
        QStringLiteral(u"man frowning: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_frowning_dark_skin_tone"),
        QStringLiteral(u"man frowning: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_frowning"),
        QStringLiteral(u"woman frowning"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_frowning_light_skin_tone"),
        QStringLiteral(u"woman frowning: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_frowning_medium_light_skin_tone"),
        QStringLiteral(u"woman frowning: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_frowning_medium_skin_tone"),
        QStringLiteral(u"woman frowning: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_frowning_medium_dark_skin_tone"),
        QStringLiteral(u"woman frowning: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64D\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_frowning_dark_skin_tone"),
        QStringLiteral(u"woman frowning: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E"),
        QStringLiteral(u"person_pouting"),
        QStringLiteral(u"person pouting"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FB"),
        QStringLiteral(u"person_pouting_light_skin_tone"),
        QStringLiteral(u"person pouting: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FC"),
        QStringLiteral(u"person_pouting_medium_light_skin_tone"),
        QStringLiteral(u"person pouting: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FD"),
        QStringLiteral(u"person_pouting_medium_skin_tone"),
        QStringLiteral(u"person pouting: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FE"),
        QStringLiteral(u"person_pouting_medium_dark_skin_tone"),
        QStringLiteral(u"person pouting: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FF"),
        QStringLiteral(u"person_pouting_dark_skin_tone"),
        QStringLiteral(u"person pouting: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_pouting"),
        QStringLiteral(u"man pouting"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_pouting_light_skin_tone"),
        QStringLiteral(u"man pouting: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_pouting_medium_light_skin_tone"),
        QStringLiteral(u"man pouting: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_pouting_medium_skin_tone"),
        QStringLiteral(u"man pouting: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_pouting_medium_dark_skin_tone"),
        QStringLiteral(u"man pouting: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_pouting_dark_skin_tone"),
        QStringLiteral(u"man pouting: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_pouting"),
        QStringLiteral(u"woman pouting"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_pouting_light_skin_tone"),
        QStringLiteral(u"woman pouting: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_pouting_medium_light_skin_tone"),
        QStringLiteral(u"woman pouting: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_pouting_medium_skin_tone"),
        QStringLiteral(u"woman pouting: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_pouting_medium_dark_skin_tone"),
        QStringLiteral(u"woman pouting: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64E\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_pouting_dark_skin_tone"),
        QStringLiteral(u"woman pouting: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645"),
        QStringLiteral(u"person_gesturing_no"),
        QStringLiteral(u"person gesturing NO"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FB"),
        QStringLiteral(u"person_gesturing_no_light_skin_tone"),
        QStringLiteral(u"person gesturing NO: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FC"),
        QStringLiteral(u"person_gesturing_no_medium_light_skin_tone"),
        QStringLiteral(u"person gesturing NO: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FD"),
        QStringLiteral(u"person_gesturing_no_medium_skin_tone"),
        QStringLiteral(u"person gesturing NO: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FE"),
        QStringLiteral(u"person_gesturing_no_medium_dark_skin_tone"),
        QStringLiteral(u"person gesturing NO: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FF"),
        QStringLiteral(u"person_gesturing_no_dark_skin_tone"),
        QStringLiteral(u"person gesturing NO: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_no"),
        QStringLiteral(u"man gesturing NO"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_no_light_skin_tone"),
        QStringLiteral(u"man gesturing NO: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_no_medium_light_skin_tone"),
        QStringLiteral(u"man gesturing NO: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_no_medium_skin_tone"),
        QStringLiteral(u"man gesturing NO: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_no_medium_dark_skin_tone"),
        QStringLiteral(u"man gesturing NO: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_no_dark_skin_tone"),
        QStringLiteral(u"man gesturing NO: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_no"),
        QStringLiteral(u"woman gesturing NO"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_no_light_skin_tone"),
        QStringLiteral(u"woman gesturing NO: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_no_medium_light_skin_tone"),
        QStringLiteral(u"woman gesturing NO: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_no_medium_skin_tone"),
        QStringLiteral(u"woman gesturing NO: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_no_medium_dark_skin_tone"),
        QStringLiteral(u"woman gesturing NO: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F645\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_no_dark_skin_tone"),
        QStringLiteral(u"woman gesturing NO: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646"),
        QStringLiteral(u"person_gesturing_ok"),
        QStringLiteral(u"person gesturing OK"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FB"),
        QStringLiteral(u"person_gesturing_ok_light_skin_tone"),
        QStringLiteral(u"person gesturing OK: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FC"),
        QStringLiteral(u"person_gesturing_ok_medium_light_skin_tone"),
        QStringLiteral(u"person gesturing OK: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FD"),
        QStringLiteral(u"person_gesturing_ok_medium_skin_tone"),
        QStringLiteral(u"person gesturing OK: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FE"),
        QStringLiteral(u"person_gesturing_ok_medium_dark_skin_tone"),
        QStringLiteral(u"person gesturing OK: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FF"),
        QStringLiteral(u"person_gesturing_ok_dark_skin_tone"),
        QStringLiteral(u"person gesturing OK: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_ok"),
        QStringLiteral(u"man gesturing OK"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_ok_light_skin_tone"),
        QStringLiteral(u"man gesturing OK: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_ok_medium_light_skin_tone"),
        QStringLiteral(u"man gesturing OK: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_ok_medium_skin_tone"),
        QStringLiteral(u"man gesturing OK: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_ok_medium_dark_skin_tone"),
        QStringLiteral(u"man gesturing OK: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_gesturing_ok_dark_skin_tone"),
        QStringLiteral(u"man gesturing OK: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_ok"),
        QStringLiteral(u"woman gesturing OK"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_ok_light_skin_tone"),
        QStringLiteral(u"woman gesturing OK: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_ok_medium_light_skin_tone"),
        QStringLiteral(u"woman gesturing OK: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_ok_medium_skin_tone"),
        QStringLiteral(u"woman gesturing OK: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_ok_medium_dark_skin_tone"),
        QStringLiteral(u"woman gesturing OK: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F646\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_gesturing_ok_dark_skin_tone"),
        QStringLiteral(u"woman gesturing OK: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481"),
        QStringLiteral(u"person_tipping_hand"),
        QStringLiteral(u"person tipping hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FB"),
        QStringLiteral(u"person_tipping_hand_light_skin_tone"),
        QStringLiteral(u"person tipping hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FC"),
        QStringLiteral(u"person_tipping_hand_medium_light_skin_tone"),
        QStringLiteral(u"person tipping hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FD"),
        QStringLiteral(u"person_tipping_hand_medium_skin_tone"),
        QStringLiteral(u"person tipping hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FE"),
        QStringLiteral(u"person_tipping_hand_medium_dark_skin_tone"),
        QStringLiteral(u"person tipping hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FF"),
        QStringLiteral(u"person_tipping_hand_dark_skin_tone"),
        QStringLiteral(u"person tipping hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_tipping_hand"),
        QStringLiteral(u"man tipping hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_tipping_hand_light_skin_tone"),
        QStringLiteral(u"man tipping hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_tipping_hand_medium_light_skin_tone"),
        QStringLiteral(u"man tipping hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_tipping_hand_medium_skin_tone"),
        QStringLiteral(u"man tipping hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_tipping_hand_medium_dark_skin_tone"),
        QStringLiteral(u"man tipping hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_tipping_hand_dark_skin_tone"),
        QStringLiteral(u"man tipping hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_tipping_hand"),
        QStringLiteral(u"woman tipping hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_tipping_hand_light_skin_tone"),
        QStringLiteral(u"woman tipping hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_tipping_hand_medium_light_skin_tone"),
        QStringLiteral(u"woman tipping hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_tipping_hand_medium_skin_tone"),
        QStringLiteral(u"woman tipping hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_tipping_hand_medium_dark_skin_tone"),
        QStringLiteral(u"woman tipping hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F481\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_tipping_hand_dark_skin_tone"),
        QStringLiteral(u"woman tipping hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B"),
        QStringLiteral(u"person_raising_hand"),
        QStringLiteral(u"person raising hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FB"),
        QStringLiteral(u"person_raising_hand_light_skin_tone"),
        QStringLiteral(u"person raising hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FC"),
        QStringLiteral(u"person_raising_hand_medium_light_skin_tone"),
        QStringLiteral(u"person raising hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FD"),
        QStringLiteral(u"person_raising_hand_medium_skin_tone"),
        QStringLiteral(u"person raising hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FE"),
        QStringLiteral(u"person_raising_hand_medium_dark_skin_tone"),
        QStringLiteral(u"person raising hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FF"),
        QStringLiteral(u"person_raising_hand_dark_skin_tone"),
        QStringLiteral(u"person raising hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_raising_hand"),
        QStringLiteral(u"man raising hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_raising_hand_light_skin_tone"),
        QStringLiteral(u"man raising hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_raising_hand_medium_light_skin_tone"),
        QStringLiteral(u"man raising hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_raising_hand_medium_skin_tone"),
        QStringLiteral(u"man raising hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_raising_hand_medium_dark_skin_tone"),
        QStringLiteral(u"man raising hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_raising_hand_dark_skin_tone"),
        QStringLiteral(u"man raising hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_raising_hand"),
        QStringLiteral(u"woman raising hand"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_raising_hand_light_skin_tone"),
        QStringLiteral(u"woman raising hand: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_raising_hand_medium_light_skin_tone"),
        QStringLiteral(u"woman raising hand: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_raising_hand_medium_skin_tone"),
        QStringLiteral(u"woman raising hand: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_raising_hand_medium_dark_skin_tone"),
        QStringLiteral(u"woman raising hand: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F64B\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_raising_hand_dark_skin_tone"),
        QStringLiteral(u"woman raising hand: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF"),
        QStringLiteral(u"deaf_person"),
        QStringLiteral(u"deaf person"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FB"),
        QStringLiteral(u"deaf_person_light_skin_tone"),
        QStringLiteral(u"deaf person: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FC"),
        QStringLiteral(u"deaf_person_medium_light_skin_tone"),
        QStringLiteral(u"deaf person: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FD"),
        QStringLiteral(u"deaf_person_medium_skin_tone"),
        QStringLiteral(u"deaf person: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FE"),
        QStringLiteral(u"deaf_person_medium_dark_skin_tone"),
        QStringLiteral(u"deaf person: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FF"),
        QStringLiteral(u"deaf_person_dark_skin_tone"),
        QStringLiteral(u"deaf person: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"deaf_man"),
        QStringLiteral(u"deaf man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"deaf_man_light_skin_tone"),
        QStringLiteral(u"deaf man: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"deaf_man_medium_light_skin_tone"),
        QStringLiteral(u"deaf man: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"deaf_man_medium_skin_tone"),
        QStringLiteral(u"deaf man: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"deaf_man_medium_dark_skin_tone"),
        QStringLiteral(u"deaf man: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"deaf_man_dark_skin_tone"),
        QStringLiteral(u"deaf man: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"deaf_woman"),
        QStringLiteral(u"deaf woman"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"deaf_woman_light_skin_tone"),
        QStringLiteral(u"deaf woman: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"deaf_woman_medium_light_skin_tone"),
        QStringLiteral(u"deaf woman: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"deaf_woman_medium_skin_tone"),
        QStringLiteral(u"deaf woman: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"deaf_woman_medium_dark_skin_tone"),
        QStringLiteral(u"deaf woman: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CF\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"deaf_woman_dark_skin_tone"),
        QStringLiteral(u"deaf woman: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647"),
        QStringLiteral(u"person_bowing"),
        QStringLiteral(u"person bowing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FB"),
        QStringLiteral(u"person_bowing_light_skin_tone"),
        QStringLiteral(u"person bowing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FC"),
        QStringLiteral(u"person_bowing_medium_light_skin_tone"),
        QStringLiteral(u"person bowing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FD"),
        QStringLiteral(u"person_bowing_medium_skin_tone"),
        QStringLiteral(u"person bowing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FE"),
        QStringLiteral(u"person_bowing_medium_dark_skin_tone"),
        QStringLiteral(u"person bowing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FF"),
        QStringLiteral(u"person_bowing_dark_skin_tone"),
        QStringLiteral(u"person bowing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bowing"),
        QStringLiteral(u"man bowing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bowing_light_skin_tone"),
        QStringLiteral(u"man bowing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bowing_medium_light_skin_tone"),
        QStringLiteral(u"man bowing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bowing_medium_skin_tone"),
        QStringLiteral(u"man bowing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bowing_medium_dark_skin_tone"),
        QStringLiteral(u"man bowing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bowing_dark_skin_tone"),
        QStringLiteral(u"man bowing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bowing"),
        QStringLiteral(u"woman bowing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bowing_light_skin_tone"),
        QStringLiteral(u"woman bowing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bowing_medium_light_skin_tone"),
        QStringLiteral(u"woman bowing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bowing_medium_skin_tone"),
        QStringLiteral(u"woman bowing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bowing_medium_dark_skin_tone"),
        QStringLiteral(u"woman bowing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F647\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bowing_dark_skin_tone"),
        QStringLiteral(u"woman bowing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926"),
        QStringLiteral(u"person_facepalming"),
        QStringLiteral(u"person facepalming"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FB"),
        QStringLiteral(u"person_facepalming_light_skin_tone"),
        QStringLiteral(u"person facepalming: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FC"),
        QStringLiteral(u"person_facepalming_medium_light_skin_tone"),
        QStringLiteral(u"person facepalming: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FD"),
        QStringLiteral(u"person_facepalming_medium_skin_tone"),
        QStringLiteral(u"person facepalming: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FE"),
        QStringLiteral(u"person_facepalming_medium_dark_skin_tone"),
        QStringLiteral(u"person facepalming: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FF"),
        QStringLiteral(u"person_facepalming_dark_skin_tone"),
        QStringLiteral(u"person facepalming: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_facepalming"),
        QStringLiteral(u"man facepalming"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_facepalming_light_skin_tone"),
        QStringLiteral(u"man facepalming: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_facepalming_medium_light_skin_tone"),
        QStringLiteral(u"man facepalming: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_facepalming_medium_skin_tone"),
        QStringLiteral(u"man facepalming: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_facepalming_medium_dark_skin_tone"),
        QStringLiteral(u"man facepalming: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_facepalming_dark_skin_tone"),
        QStringLiteral(u"man facepalming: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_facepalming"),
        QStringLiteral(u"woman facepalming"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_facepalming_light_skin_tone"),
        QStringLiteral(u"woman facepalming: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_facepalming_medium_light_skin_tone"),
        QStringLiteral(u"woman facepalming: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_facepalming_medium_skin_tone"),
        QStringLiteral(u"woman facepalming: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_facepalming_medium_dark_skin_tone"),
        QStringLiteral(u"woman facepalming: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F926\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_facepalming_dark_skin_tone"),
        QStringLiteral(u"woman facepalming: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937"),
        QStringLiteral(u"shrug"),
        QStringLiteral(u"person shrugging"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FB"),
        QStringLiteral(u"person_shrugging_light_skin_tone"),
        QStringLiteral(u"person shrugging: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FC"),
        QStringLiteral(u"person_shrugging_medium_light_skin_tone"),
        QStringLiteral(u"person shrugging: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FD"),
        QStringLiteral(u"person_shrugging_medium_skin_tone"),
        QStringLiteral(u"person shrugging: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FE"),
        QStringLiteral(u"person_shrugging_medium_dark_skin_tone"),
        QStringLiteral(u"person shrugging: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FF"),
        QStringLiteral(u"person_shrugging_dark_skin_tone"),
        QStringLiteral(u"person shrugging: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_shrugging"),
        QStringLiteral(u"man shrugging"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_shrugging_light_skin_tone"),
        QStringLiteral(u"man shrugging: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_shrugging_medium_light_skin_tone"),
        QStringLiteral(u"man shrugging: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_shrugging_medium_skin_tone"),
        QStringLiteral(u"man shrugging: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_shrugging_medium_dark_skin_tone"),
        QStringLiteral(u"man shrugging: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_shrugging_dark_skin_tone"),
        QStringLiteral(u"man shrugging: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_shrugging"),
        QStringLiteral(u"woman shrugging"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_shrugging_light_skin_tone"),
        QStringLiteral(u"woman shrugging: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_shrugging_medium_light_skin_tone"),
        QStringLiteral(u"woman shrugging: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_shrugging_medium_skin_tone"),
        QStringLiteral(u"woman shrugging: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_shrugging_medium_dark_skin_tone"),
        QStringLiteral(u"woman shrugging: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F937\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_shrugging_dark_skin_tone"),
        QStringLiteral(u"woman shrugging: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"health_worker"),
        QStringLiteral(u"health worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"health_worker_light_skin_tone"),
        QStringLiteral(u"health worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"health_worker_medium_light_skin_tone"),
        QStringLiteral(u"health worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"health_worker_medium_skin_tone"),
        QStringLiteral(u"health worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"health_worker_medium_dark_skin_tone"),
        QStringLiteral(u"health worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"health_worker_dark_skin_tone"),
        QStringLiteral(u"health worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"man_health_worker"),
        QStringLiteral(u"man health worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"man_health_worker_light_skin_tone"),
        QStringLiteral(u"man health worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"man_health_worker_medium_light_skin_tone"),
        QStringLiteral(u"man health worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"man_health_worker_medium_skin_tone"),
        QStringLiteral(u"man health worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"man_health_worker_medium_dark_skin_tone"),
        QStringLiteral(u"man health worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"man_health_worker_dark_skin_tone"),
        QStringLiteral(u"man health worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"woman_health_worker"),
        QStringLiteral(u"woman health worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"woman_health_worker_light_skin_tone"),
        QStringLiteral(u"woman health worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"woman_health_worker_medium_light_skin_tone"),
        QStringLiteral(u"woman health worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"woman_health_worker_medium_skin_tone"),
        QStringLiteral(u"woman health worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"woman_health_worker_medium_dark_skin_tone"),
        QStringLiteral(u"woman health worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002695\U0000FE0F"),
        QStringLiteral(u"woman_health_worker_dark_skin_tone"),
        QStringLiteral(u"woman health worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F393"),
        QStringLiteral(u"student"),
        QStringLiteral(u"student"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F393"),
        QStringLiteral(u"student_light_skin_tone"),
        QStringLiteral(u"student: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F393"),
        QStringLiteral(u"student_medium_light_skin_tone"),
        QStringLiteral(u"student: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F393"),
        QStringLiteral(u"student_medium_skin_tone"),
        QStringLiteral(u"student: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F393"),
        QStringLiteral(u"student_medium_dark_skin_tone"),
        QStringLiteral(u"student: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F393"),
        QStringLiteral(u"student_dark_skin_tone"),
        QStringLiteral(u"student: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F393"),
        QStringLiteral(u"man_student"),
        QStringLiteral(u"man student"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F393"),
        QStringLiteral(u"man_student_light_skin_tone"),
        QStringLiteral(u"man student: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F393"),
        QStringLiteral(u"man_student_medium_light_skin_tone"),
        QStringLiteral(u"man student: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F393"),
        QStringLiteral(u"man_student_medium_skin_tone"),
        QStringLiteral(u"man student: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F393"),
        QStringLiteral(u"man_student_medium_dark_skin_tone"),
        QStringLiteral(u"man student: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F393"),
        QStringLiteral(u"man_student_dark_skin_tone"),
        QStringLiteral(u"man student: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F393"),
        QStringLiteral(u"woman_student"),
        QStringLiteral(u"woman student"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F393"),
        QStringLiteral(u"woman_student_light_skin_tone"),
        QStringLiteral(u"woman student: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F393"),
        QStringLiteral(u"woman_student_medium_light_skin_tone"),
        QStringLiteral(u"woman student: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F393"),
        QStringLiteral(u"woman_student_medium_skin_tone"),
        QStringLiteral(u"woman student: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F393"),
        QStringLiteral(u"woman_student_medium_dark_skin_tone"),
        QStringLiteral(u"woman student: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F393"),
        QStringLiteral(u"woman_student_dark_skin_tone"),
        QStringLiteral(u"woman student: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F3EB"),
        QStringLiteral(u"teacher"),
        QStringLiteral(u"teacher"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F3EB"),
        QStringLiteral(u"teacher_light_skin_tone"),
        QStringLiteral(u"teacher: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F3EB"),
        QStringLiteral(u"teacher_medium_light_skin_tone"),
        QStringLiteral(u"teacher: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F3EB"),
        QStringLiteral(u"teacher_medium_skin_tone"),
        QStringLiteral(u"teacher: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F3EB"),
        QStringLiteral(u"teacher_medium_dark_skin_tone"),
        QStringLiteral(u"teacher: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F3EB"),
        QStringLiteral(u"teacher_dark_skin_tone"),
        QStringLiteral(u"teacher: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F3EB"),
        QStringLiteral(u"man_teacher"),
        QStringLiteral(u"man teacher"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F3EB"),
        QStringLiteral(u"man_teacher_light_skin_tone"),
        QStringLiteral(u"man teacher: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F3EB"),
        QStringLiteral(u"man_teacher_medium_light_skin_tone"),
        QStringLiteral(u"man teacher: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F3EB"),
        QStringLiteral(u"man_teacher_medium_skin_tone"),
        QStringLiteral(u"man teacher: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F3EB"),
        QStringLiteral(u"man_teacher_medium_dark_skin_tone"),
        QStringLiteral(u"man teacher: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F3EB"),
        QStringLiteral(u"man_teacher_dark_skin_tone"),
        QStringLiteral(u"man teacher: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F3EB"),
        QStringLiteral(u"woman_teacher"),
        QStringLiteral(u"woman teacher"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F3EB"),
        QStringLiteral(u"woman_teacher_light_skin_tone"),
        QStringLiteral(u"woman teacher: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F3EB"),
        QStringLiteral(u"woman_teacher_medium_light_skin_tone"),
        QStringLiteral(u"woman teacher: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F3EB"),
        QStringLiteral(u"woman_teacher_medium_skin_tone"),
        QStringLiteral(u"woman teacher: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F3EB"),
        QStringLiteral(u"woman_teacher_medium_dark_skin_tone"),
        QStringLiteral(u"woman teacher: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F3EB"),
        QStringLiteral(u"woman_teacher_dark_skin_tone"),
        QStringLiteral(u"woman teacher: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"judge"),
        QStringLiteral(u"judge"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"judge_light_skin_tone"),
        QStringLiteral(u"judge: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"judge_medium_light_skin_tone"),
        QStringLiteral(u"judge: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"judge_medium_skin_tone"),
        QStringLiteral(u"judge: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"judge_medium_dark_skin_tone"),
        QStringLiteral(u"judge: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"judge_dark_skin_tone"),
        QStringLiteral(u"judge: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"man_judge"),
        QStringLiteral(u"man judge"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"man_judge_light_skin_tone"),
        QStringLiteral(u"man judge: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"man_judge_medium_light_skin_tone"),
        QStringLiteral(u"man judge: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"man_judge_medium_skin_tone"),
        QStringLiteral(u"man judge: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"man_judge_medium_dark_skin_tone"),
        QStringLiteral(u"man judge: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"man_judge_dark_skin_tone"),
        QStringLiteral(u"man judge: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"woman_judge"),
        QStringLiteral(u"woman judge"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"woman_judge_light_skin_tone"),
        QStringLiteral(u"woman judge: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"woman_judge_medium_light_skin_tone"),
        QStringLiteral(u"woman judge: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"woman_judge_medium_skin_tone"),
        QStringLiteral(u"woman judge: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"woman_judge_medium_dark_skin_tone"),
        QStringLiteral(u"woman judge: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002696\U0000FE0F"),
        QStringLiteral(u"woman_judge_dark_skin_tone"),
        QStringLiteral(u"woman judge: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F33E"),
        QStringLiteral(u"farmer"),
        QStringLiteral(u"farmer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F33E"),
        QStringLiteral(u"farmer_light_skin_tone"),
        QStringLiteral(u"farmer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F33E"),
        QStringLiteral(u"farmer_medium_light_skin_tone"),
        QStringLiteral(u"farmer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F33E"),
        QStringLiteral(u"farmer_medium_skin_tone"),
        QStringLiteral(u"farmer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F33E"),
        QStringLiteral(u"farmer_medium_dark_skin_tone"),
        QStringLiteral(u"farmer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F33E"),
        QStringLiteral(u"farmer_dark_skin_tone"),
        QStringLiteral(u"farmer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F33E"),
        QStringLiteral(u"man_farmer"),
        QStringLiteral(u"man farmer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F33E"),
        QStringLiteral(u"man_farmer_light_skin_tone"),
        QStringLiteral(u"man farmer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F33E"),
        QStringLiteral(u"man_farmer_medium_light_skin_tone"),
        QStringLiteral(u"man farmer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F33E"),
        QStringLiteral(u"man_farmer_medium_skin_tone"),
        QStringLiteral(u"man farmer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F33E"),
        QStringLiteral(u"man_farmer_medium_dark_skin_tone"),
        QStringLiteral(u"man farmer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F33E"),
        QStringLiteral(u"man_farmer_dark_skin_tone"),
        QStringLiteral(u"man farmer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F33E"),
        QStringLiteral(u"woman_farmer"),
        QStringLiteral(u"woman farmer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F33E"),
        QStringLiteral(u"woman_farmer_light_skin_tone"),
        QStringLiteral(u"woman farmer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F33E"),
        QStringLiteral(u"woman_farmer_medium_light_skin_tone"),
        QStringLiteral(u"woman farmer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F33E"),
        QStringLiteral(u"woman_farmer_medium_skin_tone"),
        QStringLiteral(u"woman farmer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F33E"),
        QStringLiteral(u"woman_farmer_medium_dark_skin_tone"),
        QStringLiteral(u"woman farmer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F33E"),
        QStringLiteral(u"woman_farmer_dark_skin_tone"),
        QStringLiteral(u"woman farmer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F373"),
        QStringLiteral(u"cook"),
        QStringLiteral(u"cook"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F373"),
        QStringLiteral(u"cook_light_skin_tone"),
        QStringLiteral(u"cook: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F373"),
        QStringLiteral(u"cook_medium_light_skin_tone"),
        QStringLiteral(u"cook: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F373"),
        QStringLiteral(u"cook_medium_skin_tone"),
        QStringLiteral(u"cook: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F373"),
        QStringLiteral(u"cook_medium_dark_skin_tone"),
        QStringLiteral(u"cook: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F373"),
        QStringLiteral(u"cook_dark_skin_tone"),
        QStringLiteral(u"cook: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F373"),
        QStringLiteral(u"man_cook"),
        QStringLiteral(u"man cook"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F373"),
        QStringLiteral(u"man_cook_light_skin_tone"),
        QStringLiteral(u"man cook: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F373"),
        QStringLiteral(u"man_cook_medium_light_skin_tone"),
        QStringLiteral(u"man cook: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F373"),
        QStringLiteral(u"man_cook_medium_skin_tone"),
        QStringLiteral(u"man cook: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F373"),
        QStringLiteral(u"man_cook_medium_dark_skin_tone"),
        QStringLiteral(u"man cook: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F373"),
        QStringLiteral(u"man_cook_dark_skin_tone"),
        QStringLiteral(u"man cook: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F373"),
        QStringLiteral(u"woman_cook"),
        QStringLiteral(u"woman cook"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F373"),
        QStringLiteral(u"woman_cook_light_skin_tone"),
        QStringLiteral(u"woman cook: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F373"),
        QStringLiteral(u"woman_cook_medium_light_skin_tone"),
        QStringLiteral(u"woman cook: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F373"),
        QStringLiteral(u"woman_cook_medium_skin_tone"),
        QStringLiteral(u"woman cook: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F373"),
        QStringLiteral(u"woman_cook_medium_dark_skin_tone"),
        QStringLiteral(u"woman cook: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F373"),
        QStringLiteral(u"woman_cook_dark_skin_tone"),
        QStringLiteral(u"woman cook: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F527"),
        QStringLiteral(u"mechanic"),
        QStringLiteral(u"mechanic"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F527"),
        QStringLiteral(u"mechanic_light_skin_tone"),
        QStringLiteral(u"mechanic: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F527"),
        QStringLiteral(u"mechanic_medium_light_skin_tone"),
        QStringLiteral(u"mechanic: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F527"),
        QStringLiteral(u"mechanic_medium_skin_tone"),
        QStringLiteral(u"mechanic: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F527"),
        QStringLiteral(u"mechanic_medium_dark_skin_tone"),
        QStringLiteral(u"mechanic: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F527"),
        QStringLiteral(u"mechanic_dark_skin_tone"),
        QStringLiteral(u"mechanic: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F527"),
        QStringLiteral(u"man_mechanic"),
        QStringLiteral(u"man mechanic"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F527"),
        QStringLiteral(u"man_mechanic_light_skin_tone"),
        QStringLiteral(u"man mechanic: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F527"),
        QStringLiteral(u"man_mechanic_medium_light_skin_tone"),
        QStringLiteral(u"man mechanic: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F527"),
        QStringLiteral(u"man_mechanic_medium_skin_tone"),
        QStringLiteral(u"man mechanic: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F527"),
        QStringLiteral(u"man_mechanic_medium_dark_skin_tone"),
        QStringLiteral(u"man mechanic: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F527"),
        QStringLiteral(u"man_mechanic_dark_skin_tone"),
        QStringLiteral(u"man mechanic: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F527"),
        QStringLiteral(u"woman_mechanic"),
        QStringLiteral(u"woman mechanic"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F527"),
        QStringLiteral(u"woman_mechanic_light_skin_tone"),
        QStringLiteral(u"woman mechanic: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F527"),
        QStringLiteral(u"woman_mechanic_medium_light_skin_tone"),
        QStringLiteral(u"woman mechanic: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F527"),
        QStringLiteral(u"woman_mechanic_medium_skin_tone"),
        QStringLiteral(u"woman mechanic: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F527"),
        QStringLiteral(u"woman_mechanic_medium_dark_skin_tone"),
        QStringLiteral(u"woman mechanic: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F527"),
        QStringLiteral(u"woman_mechanic_dark_skin_tone"),
        QStringLiteral(u"woman mechanic: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F3ED"),
        QStringLiteral(u"factory_worker"),
        QStringLiteral(u"factory worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F3ED"),
        QStringLiteral(u"factory_worker_light_skin_tone"),
        QStringLiteral(u"factory worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F3ED"),
        QStringLiteral(u"factory_worker_medium_light_skin_tone"),
        QStringLiteral(u"factory worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F3ED"),
        QStringLiteral(u"factory_worker_medium_skin_tone"),
        QStringLiteral(u"factory worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F3ED"),
        QStringLiteral(u"factory_worker_medium_dark_skin_tone"),
        QStringLiteral(u"factory worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F3ED"),
        QStringLiteral(u"factory_worker_dark_skin_tone"),
        QStringLiteral(u"factory worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F3ED"),
        QStringLiteral(u"man_factory_worker"),
        QStringLiteral(u"man factory worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F3ED"),
        QStringLiteral(u"man_factory_worker_light_skin_tone"),
        QStringLiteral(u"man factory worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F3ED"),
        QStringLiteral(u"man_factory_worker_medium_light_skin_tone"),
        QStringLiteral(u"man factory worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F3ED"),
        QStringLiteral(u"man_factory_worker_medium_skin_tone"),
        QStringLiteral(u"man factory worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F3ED"),
        QStringLiteral(u"man_factory_worker_medium_dark_skin_tone"),
        QStringLiteral(u"man factory worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F3ED"),
        QStringLiteral(u"man_factory_worker_dark_skin_tone"),
        QStringLiteral(u"man factory worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F3ED"),
        QStringLiteral(u"woman_factory_worker"),
        QStringLiteral(u"woman factory worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F3ED"),
        QStringLiteral(u"woman_factory_worker_light_skin_tone"),
        QStringLiteral(u"woman factory worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F3ED"),
        QStringLiteral(u"woman_factory_worker_medium_light_skin_tone"),
        QStringLiteral(u"woman factory worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F3ED"),
        QStringLiteral(u"woman_factory_worker_medium_skin_tone"),
        QStringLiteral(u"woman factory worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F3ED"),
        QStringLiteral(u"woman_factory_worker_medium_dark_skin_tone"),
        QStringLiteral(u"woman factory worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F3ED"),
        QStringLiteral(u"woman_factory_worker_dark_skin_tone"),
        QStringLiteral(u"woman factory worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F4BC"),
        QStringLiteral(u"office_worker"),
        QStringLiteral(u"office worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F4BC"),
        QStringLiteral(u"office_worker_light_skin_tone"),
        QStringLiteral(u"office worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F4BC"),
        QStringLiteral(u"office_worker_medium_light_skin_tone"),
        QStringLiteral(u"office worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F4BC"),
        QStringLiteral(u"office_worker_medium_skin_tone"),
        QStringLiteral(u"office worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F4BC"),
        QStringLiteral(u"office_worker_medium_dark_skin_tone"),
        QStringLiteral(u"office worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F4BC"),
        QStringLiteral(u"office_worker_dark_skin_tone"),
        QStringLiteral(u"office worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F4BC"),
        QStringLiteral(u"man_office_worker"),
        QStringLiteral(u"man office worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F4BC"),
        QStringLiteral(u"man_office_worker_light_skin_tone"),
        QStringLiteral(u"man office worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F4BC"),
        QStringLiteral(u"man_office_worker_medium_light_skin_tone"),
        QStringLiteral(u"man office worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F4BC"),
        QStringLiteral(u"man_office_worker_medium_skin_tone"),
        QStringLiteral(u"man office worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F4BC"),
        QStringLiteral(u"man_office_worker_medium_dark_skin_tone"),
        QStringLiteral(u"man office worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F4BC"),
        QStringLiteral(u"man_office_worker_dark_skin_tone"),
        QStringLiteral(u"man office worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F4BC"),
        QStringLiteral(u"woman_office_worker"),
        QStringLiteral(u"woman office worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F4BC"),
        QStringLiteral(u"woman_office_worker_light_skin_tone"),
        QStringLiteral(u"woman office worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F4BC"),
        QStringLiteral(u"woman_office_worker_medium_light_skin_tone"),
        QStringLiteral(u"woman office worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F4BC"),
        QStringLiteral(u"woman_office_worker_medium_skin_tone"),
        QStringLiteral(u"woman office worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F4BC"),
        QStringLiteral(u"woman_office_worker_medium_dark_skin_tone"),
        QStringLiteral(u"woman office worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F4BC"),
        QStringLiteral(u"woman_office_worker_dark_skin_tone"),
        QStringLiteral(u"woman office worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F52C"),
        QStringLiteral(u"scientist"),
        QStringLiteral(u"scientist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F52C"),
        QStringLiteral(u"scientist_light_skin_tone"),
        QStringLiteral(u"scientist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F52C"),
        QStringLiteral(u"scientist_medium_light_skin_tone"),
        QStringLiteral(u"scientist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F52C"),
        QStringLiteral(u"scientist_medium_skin_tone"),
        QStringLiteral(u"scientist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F52C"),
        QStringLiteral(u"scientist_medium_dark_skin_tone"),
        QStringLiteral(u"scientist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F52C"),
        QStringLiteral(u"scientist_dark_skin_tone"),
        QStringLiteral(u"scientist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F52C"),
        QStringLiteral(u"man_scientist"),
        QStringLiteral(u"man scientist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F52C"),
        QStringLiteral(u"man_scientist_light_skin_tone"),
        QStringLiteral(u"man scientist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F52C"),
        QStringLiteral(u"man_scientist_medium_light_skin_tone"),
        QStringLiteral(u"man scientist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F52C"),
        QStringLiteral(u"man_scientist_medium_skin_tone"),
        QStringLiteral(u"man scientist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F52C"),
        QStringLiteral(u"man_scientist_medium_dark_skin_tone"),
        QStringLiteral(u"man scientist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F52C"),
        QStringLiteral(u"man_scientist_dark_skin_tone"),
        QStringLiteral(u"man scientist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F52C"),
        QStringLiteral(u"woman_scientist"),
        QStringLiteral(u"woman scientist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F52C"),
        QStringLiteral(u"woman_scientist_light_skin_tone"),
        QStringLiteral(u"woman scientist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F52C"),
        QStringLiteral(u"woman_scientist_medium_light_skin_tone"),
        QStringLiteral(u"woman scientist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F52C"),
        QStringLiteral(u"woman_scientist_medium_skin_tone"),
        QStringLiteral(u"woman scientist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F52C"),
        QStringLiteral(u"woman_scientist_medium_dark_skin_tone"),
        QStringLiteral(u"woman scientist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F52C"),
        QStringLiteral(u"woman_scientist_dark_skin_tone"),
        QStringLiteral(u"woman scientist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F4BB"),
        QStringLiteral(u"technologist"),
        QStringLiteral(u"technologist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F4BB"),
        QStringLiteral(u"technologist_light_skin_tone"),
        QStringLiteral(u"technologist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F4BB"),
        QStringLiteral(u"technologist_medium_light_skin_tone"),
        QStringLiteral(u"technologist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F4BB"),
        QStringLiteral(u"technologist_medium_skin_tone"),
        QStringLiteral(u"technologist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F4BB"),
        QStringLiteral(u"technologist_medium_dark_skin_tone"),
        QStringLiteral(u"technologist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F4BB"),
        QStringLiteral(u"technologist_dark_skin_tone"),
        QStringLiteral(u"technologist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F4BB"),
        QStringLiteral(u"man_technologist"),
        QStringLiteral(u"man technologist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F4BB"),
        QStringLiteral(u"man_technologist_light_skin_tone"),
        QStringLiteral(u"man technologist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F4BB"),
        QStringLiteral(u"man_technologist_medium_light_skin_tone"),
        QStringLiteral(u"man technologist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F4BB"),
        QStringLiteral(u"man_technologist_medium_skin_tone"),
        QStringLiteral(u"man technologist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F4BB"),
        QStringLiteral(u"man_technologist_medium_dark_skin_tone"),
        QStringLiteral(u"man technologist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F4BB"),
        QStringLiteral(u"man_technologist_dark_skin_tone"),
        QStringLiteral(u"man technologist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F4BB"),
        QStringLiteral(u"woman_technologist"),
        QStringLiteral(u"woman technologist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F4BB"),
        QStringLiteral(u"woman_technologist_light_skin_tone"),
        QStringLiteral(u"woman technologist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F4BB"),
        QStringLiteral(u"woman_technologist_medium_light_skin_tone"),
        QStringLiteral(u"woman technologist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F4BB"),
        QStringLiteral(u"woman_technologist_medium_skin_tone"),
        QStringLiteral(u"woman technologist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F4BB"),
        QStringLiteral(u"woman_technologist_medium_dark_skin_tone"),
        QStringLiteral(u"woman technologist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F4BB"),
        QStringLiteral(u"woman_technologist_dark_skin_tone"),
        QStringLiteral(u"woman technologist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F3A4"),
        QStringLiteral(u"singer"),
        QStringLiteral(u"singer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F3A4"),
        QStringLiteral(u"singer_light_skin_tone"),
        QStringLiteral(u"singer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F3A4"),
        QStringLiteral(u"singer_medium_light_skin_tone"),
        QStringLiteral(u"singer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F3A4"),
        QStringLiteral(u"singer_medium_skin_tone"),
        QStringLiteral(u"singer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F3A4"),
        QStringLiteral(u"singer_medium_dark_skin_tone"),
        QStringLiteral(u"singer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F3A4"),
        QStringLiteral(u"singer_dark_skin_tone"),
        QStringLiteral(u"singer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F3A4"),
        QStringLiteral(u"man_singer"),
        QStringLiteral(u"man singer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F3A4"),
        QStringLiteral(u"man_singer_light_skin_tone"),
        QStringLiteral(u"man singer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F3A4"),
        QStringLiteral(u"man_singer_medium_light_skin_tone"),
        QStringLiteral(u"man singer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F3A4"),
        QStringLiteral(u"man_singer_medium_skin_tone"),
        QStringLiteral(u"man singer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F3A4"),
        QStringLiteral(u"man_singer_medium_dark_skin_tone"),
        QStringLiteral(u"man singer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F3A4"),
        QStringLiteral(u"man_singer_dark_skin_tone"),
        QStringLiteral(u"man singer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F3A4"),
        QStringLiteral(u"woman_singer"),
        QStringLiteral(u"woman singer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F3A4"),
        QStringLiteral(u"woman_singer_light_skin_tone"),
        QStringLiteral(u"woman singer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F3A4"),
        QStringLiteral(u"woman_singer_medium_light_skin_tone"),
        QStringLiteral(u"woman singer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F3A4"),
        QStringLiteral(u"woman_singer_medium_skin_tone"),
        QStringLiteral(u"woman singer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F3A4"),
        QStringLiteral(u"woman_singer_medium_dark_skin_tone"),
        QStringLiteral(u"woman singer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F3A4"),
        QStringLiteral(u"woman_singer_dark_skin_tone"),
        QStringLiteral(u"woman singer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F3A8"),
        QStringLiteral(u"artist"),
        QStringLiteral(u"artist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F3A8"),
        QStringLiteral(u"artist_light_skin_tone"),
        QStringLiteral(u"artist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F3A8"),
        QStringLiteral(u"artist_medium_light_skin_tone"),
        QStringLiteral(u"artist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F3A8"),
        QStringLiteral(u"artist_medium_skin_tone"),
        QStringLiteral(u"artist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F3A8"),
        QStringLiteral(u"artist_medium_dark_skin_tone"),
        QStringLiteral(u"artist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F3A8"),
        QStringLiteral(u"artist_dark_skin_tone"),
        QStringLiteral(u"artist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F3A8"),
        QStringLiteral(u"man_artist"),
        QStringLiteral(u"man artist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F3A8"),
        QStringLiteral(u"man_artist_light_skin_tone"),
        QStringLiteral(u"man artist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F3A8"),
        QStringLiteral(u"man_artist_medium_light_skin_tone"),
        QStringLiteral(u"man artist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F3A8"),
        QStringLiteral(u"man_artist_medium_skin_tone"),
        QStringLiteral(u"man artist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F3A8"),
        QStringLiteral(u"man_artist_medium_dark_skin_tone"),
        QStringLiteral(u"man artist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F3A8"),
        QStringLiteral(u"man_artist_dark_skin_tone"),
        QStringLiteral(u"man artist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F3A8"),
        QStringLiteral(u"woman_artist"),
        QStringLiteral(u"woman artist"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F3A8"),
        QStringLiteral(u"woman_artist_light_skin_tone"),
        QStringLiteral(u"woman artist: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F3A8"),
        QStringLiteral(u"woman_artist_medium_light_skin_tone"),
        QStringLiteral(u"woman artist: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F3A8"),
        QStringLiteral(u"woman_artist_medium_skin_tone"),
        QStringLiteral(u"woman artist: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F3A8"),
        QStringLiteral(u"woman_artist_medium_dark_skin_tone"),
        QStringLiteral(u"woman artist: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F3A8"),
        QStringLiteral(u"woman_artist_dark_skin_tone"),
        QStringLiteral(u"woman artist: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"pilot"),
        QStringLiteral(u"pilot"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"pilot_light_skin_tone"),
        QStringLiteral(u"pilot: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"pilot_medium_light_skin_tone"),
        QStringLiteral(u"pilot: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"pilot_medium_skin_tone"),
        QStringLiteral(u"pilot: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"pilot_medium_dark_skin_tone"),
        QStringLiteral(u"pilot: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"pilot_dark_skin_tone"),
        QStringLiteral(u"pilot: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"man_pilot"),
        QStringLiteral(u"man pilot"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"man_pilot_light_skin_tone"),
        QStringLiteral(u"man pilot: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"man_pilot_medium_light_skin_tone"),
        QStringLiteral(u"man pilot: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"man_pilot_medium_skin_tone"),
        QStringLiteral(u"man pilot: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"man_pilot_medium_dark_skin_tone"),
        QStringLiteral(u"man pilot: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"man_pilot_dark_skin_tone"),
        QStringLiteral(u"man pilot: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"woman_pilot"),
        QStringLiteral(u"woman pilot"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"woman_pilot_light_skin_tone"),
        QStringLiteral(u"woman pilot: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"woman_pilot_medium_light_skin_tone"),
        QStringLiteral(u"woman pilot: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"woman_pilot_medium_skin_tone"),
        QStringLiteral(u"woman pilot: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"woman_pilot_medium_dark_skin_tone"),
        QStringLiteral(u"woman pilot: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002708\U0000FE0F"),
        QStringLiteral(u"woman_pilot_dark_skin_tone"),
        QStringLiteral(u"woman pilot: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F680"),
        QStringLiteral(u"astronaut"),
        QStringLiteral(u"astronaut"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F680"),
        QStringLiteral(u"astronaut_light_skin_tone"),
        QStringLiteral(u"astronaut: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F680"),
        QStringLiteral(u"astronaut_medium_light_skin_tone"),
        QStringLiteral(u"astronaut: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F680"),
        QStringLiteral(u"astronaut_medium_skin_tone"),
        QStringLiteral(u"astronaut: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F680"),
        QStringLiteral(u"astronaut_medium_dark_skin_tone"),
        QStringLiteral(u"astronaut: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F680"),
        QStringLiteral(u"astronaut_dark_skin_tone"),
        QStringLiteral(u"astronaut: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F680"),
        QStringLiteral(u"man_astronaut"),
        QStringLiteral(u"man astronaut"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F680"),
        QStringLiteral(u"man_astronaut_light_skin_tone"),
        QStringLiteral(u"man astronaut: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F680"),
        QStringLiteral(u"man_astronaut_medium_light_skin_tone"),
        QStringLiteral(u"man astronaut: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F680"),
        QStringLiteral(u"man_astronaut_medium_skin_tone"),
        QStringLiteral(u"man astronaut: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F680"),
        QStringLiteral(u"man_astronaut_medium_dark_skin_tone"),
        QStringLiteral(u"man astronaut: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F680"),
        QStringLiteral(u"man_astronaut_dark_skin_tone"),
        QStringLiteral(u"man astronaut: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F680"),
        QStringLiteral(u"woman_astronaut"),
        QStringLiteral(u"woman astronaut"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F680"),
        QStringLiteral(u"woman_astronaut_light_skin_tone"),
        QStringLiteral(u"woman astronaut: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F680"),
        QStringLiteral(u"woman_astronaut_medium_light_skin_tone"),
        QStringLiteral(u"woman astronaut: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F680"),
        QStringLiteral(u"woman_astronaut_medium_skin_tone"),
        QStringLiteral(u"woman astronaut: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F680"),
        QStringLiteral(u"woman_astronaut_medium_dark_skin_tone"),
        QStringLiteral(u"woman astronaut: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F680"),
        QStringLiteral(u"woman_astronaut_dark_skin_tone"),
        QStringLiteral(u"woman astronaut: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F692"),
        QStringLiteral(u"firefighter"),
        QStringLiteral(u"firefighter"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F692"),
        QStringLiteral(u"firefighter_light_skin_tone"),
        QStringLiteral(u"firefighter: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F692"),
        QStringLiteral(u"firefighter_medium_light_skin_tone"),
        QStringLiteral(u"firefighter: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F692"),
        QStringLiteral(u"firefighter_medium_skin_tone"),
        QStringLiteral(u"firefighter: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F692"),
        QStringLiteral(u"firefighter_medium_dark_skin_tone"),
        QStringLiteral(u"firefighter: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F692"),
        QStringLiteral(u"firefighter_dark_skin_tone"),
        QStringLiteral(u"firefighter: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F692"),
        QStringLiteral(u"man_firefighter"),
        QStringLiteral(u"man firefighter"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F692"),
        QStringLiteral(u"man_firefighter_light_skin_tone"),
        QStringLiteral(u"man firefighter: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F692"),
        QStringLiteral(u"man_firefighter_medium_light_skin_tone"),
        QStringLiteral(u"man firefighter: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F692"),
        QStringLiteral(u"man_firefighter_medium_skin_tone"),
        QStringLiteral(u"man firefighter: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F692"),
        QStringLiteral(u"man_firefighter_medium_dark_skin_tone"),
        QStringLiteral(u"man firefighter: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F692"),
        QStringLiteral(u"man_firefighter_dark_skin_tone"),
        QStringLiteral(u"man firefighter: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F692"),
        QStringLiteral(u"woman_firefighter"),
        QStringLiteral(u"woman firefighter"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F692"),
        QStringLiteral(u"woman_firefighter_light_skin_tone"),
        QStringLiteral(u"woman firefighter: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F692"),
        QStringLiteral(u"woman_firefighter_medium_light_skin_tone"),
        QStringLiteral(u"woman firefighter: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F692"),
        QStringLiteral(u"woman_firefighter_medium_skin_tone"),
        QStringLiteral(u"woman firefighter: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F692"),
        QStringLiteral(u"woman_firefighter_medium_dark_skin_tone"),
        QStringLiteral(u"woman firefighter: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F692"),
        QStringLiteral(u"woman_firefighter_dark_skin_tone"),
        QStringLiteral(u"woman firefighter: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E"),
        QStringLiteral(u"police_officer"),
        QStringLiteral(u"police officer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FB"),
        QStringLiteral(u"police_officer_light_skin_tone"),
        QStringLiteral(u"police officer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FC"),
        QStringLiteral(u"police_officer_medium_light_skin_tone"),
        QStringLiteral(u"police officer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FD"),
        QStringLiteral(u"police_officer_medium_skin_tone"),
        QStringLiteral(u"police officer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FE"),
        QStringLiteral(u"police_officer_medium_dark_skin_tone"),
        QStringLiteral(u"police officer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FF"),
        QStringLiteral(u"police_officer_dark_skin_tone"),
        QStringLiteral(u"police officer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_police_officer"),
        QStringLiteral(u"man police officer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_police_officer_light_skin_tone"),
        QStringLiteral(u"man police officer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_police_officer_medium_light_skin_tone"),
        QStringLiteral(u"man police officer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_police_officer_medium_skin_tone"),
        QStringLiteral(u"man police officer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_police_officer_medium_dark_skin_tone"),
        QStringLiteral(u"man police officer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_police_officer_dark_skin_tone"),
        QStringLiteral(u"man police officer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_police_officer"),
        QStringLiteral(u"woman police officer"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_police_officer_light_skin_tone"),
        QStringLiteral(u"woman police officer: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_police_officer_medium_light_skin_tone"),
        QStringLiteral(u"woman police officer: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_police_officer_medium_skin_tone"),
        QStringLiteral(u"woman police officer: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_police_officer_medium_dark_skin_tone"),
        QStringLiteral(u"woman police officer: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46E\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_police_officer_dark_skin_tone"),
        QStringLiteral(u"woman police officer: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0000FE0F"),
        QStringLiteral(u"detective"),
        QStringLiteral(u"detective"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FB"),
        QStringLiteral(u"detective_light_skin_tone"),
        QStringLiteral(u"detective: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FC"),
        QStringLiteral(u"detective_medium_light_skin_tone"),
        QStringLiteral(u"detective: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FD"),
        QStringLiteral(u"detective_medium_skin_tone"),
        QStringLiteral(u"detective: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FE"),
        QStringLiteral(u"detective_medium_dark_skin_tone"),
        QStringLiteral(u"detective: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FF"),
        QStringLiteral(u"detective_dark_skin_tone"),
        QStringLiteral(u"detective: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0000FE0F\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_detective"),
        QStringLiteral(u"man detective"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_detective_light_skin_tone"),
        QStringLiteral(u"man detective: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_detective_medium_light_skin_tone"),
        QStringLiteral(u"man detective: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_detective_medium_skin_tone"),
        QStringLiteral(u"man detective: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_detective_medium_dark_skin_tone"),
        QStringLiteral(u"man detective: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_detective_dark_skin_tone"),
        QStringLiteral(u"man detective: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0000FE0F\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_detective"),
        QStringLiteral(u"woman detective"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_detective_light_skin_tone"),
        QStringLiteral(u"woman detective: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_detective_medium_light_skin_tone"),
        QStringLiteral(u"woman detective: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_detective_medium_skin_tone"),
        QStringLiteral(u"woman detective: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_detective_medium_dark_skin_tone"),
        QStringLiteral(u"woman detective: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F575\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_detective_dark_skin_tone"),
        QStringLiteral(u"woman detective: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482"),
        QStringLiteral(u"guard"),
        QStringLiteral(u"guard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FB"),
        QStringLiteral(u"guard_light_skin_tone"),
        QStringLiteral(u"guard: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FC"),
        QStringLiteral(u"guard_medium_light_skin_tone"),
        QStringLiteral(u"guard: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FD"),
        QStringLiteral(u"guard_medium_skin_tone"),
        QStringLiteral(u"guard: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FE"),
        QStringLiteral(u"guard_medium_dark_skin_tone"),
        QStringLiteral(u"guard: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FF"),
        QStringLiteral(u"guard_dark_skin_tone"),
        QStringLiteral(u"guard: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_guard"),
        QStringLiteral(u"man guard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_guard_light_skin_tone"),
        QStringLiteral(u"man guard: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_guard_medium_light_skin_tone"),
        QStringLiteral(u"man guard: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_guard_medium_skin_tone"),
        QStringLiteral(u"man guard: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_guard_medium_dark_skin_tone"),
        QStringLiteral(u"man guard: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_guard_dark_skin_tone"),
        QStringLiteral(u"man guard: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_guard"),
        QStringLiteral(u"woman guard"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_guard_light_skin_tone"),
        QStringLiteral(u"woman guard: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_guard_medium_light_skin_tone"),
        QStringLiteral(u"woman guard: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_guard_medium_skin_tone"),
        QStringLiteral(u"woman guard: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_guard_medium_dark_skin_tone"),
        QStringLiteral(u"woman guard: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F482\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_guard_dark_skin_tone"),
        QStringLiteral(u"woman guard: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F977"),
        QStringLiteral(u"ninja"),
        QStringLiteral(u"ninja"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F977\U0001F3FB"),
        QStringLiteral(u"ninja_light_skin_tone"),
        QStringLiteral(u"ninja: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F977\U0001F3FC"),
        QStringLiteral(u"ninja_medium_light_skin_tone"),
        QStringLiteral(u"ninja: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F977\U0001F3FD"),
        QStringLiteral(u"ninja_medium_skin_tone"),
        QStringLiteral(u"ninja: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F977\U0001F3FE"),
        QStringLiteral(u"ninja_medium_dark_skin_tone"),
        QStringLiteral(u"ninja: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F977\U0001F3FF"),
        QStringLiteral(u"ninja_dark_skin_tone"),
        QStringLiteral(u"ninja: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477"),
        QStringLiteral(u"construction_worker"),
        QStringLiteral(u"construction worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FB"),
        QStringLiteral(u"construction_worker_light_skin_tone"),
        QStringLiteral(u"construction worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FC"),
        QStringLiteral(u"construction_worker_medium_light_skin_tone"),
        QStringLiteral(u"construction worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FD"),
        QStringLiteral(u"construction_worker_medium_skin_tone"),
        QStringLiteral(u"construction worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FE"),
        QStringLiteral(u"construction_worker_medium_dark_skin_tone"),
        QStringLiteral(u"construction worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FF"),
        QStringLiteral(u"construction_worker_dark_skin_tone"),
        QStringLiteral(u"construction worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_construction_worker"),
        QStringLiteral(u"man construction worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_construction_worker_light_skin_tone"),
        QStringLiteral(u"man construction worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_construction_worker_medium_light_skin_tone"),
        QStringLiteral(u"man construction worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_construction_worker_medium_skin_tone"),
        QStringLiteral(u"man construction worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_construction_worker_medium_dark_skin_tone"),
        QStringLiteral(u"man construction worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_construction_worker_dark_skin_tone"),
        QStringLiteral(u"man construction worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_construction_worker"),
        QStringLiteral(u"woman construction worker"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_construction_worker_light_skin_tone"),
        QStringLiteral(u"woman construction worker: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_construction_worker_medium_light_skin_tone"),
        QStringLiteral(u"woman construction worker: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_construction_worker_medium_skin_tone"),
        QStringLiteral(u"woman construction worker: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_construction_worker_medium_dark_skin_tone"),
        QStringLiteral(u"woman construction worker: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F477\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_construction_worker_dark_skin_tone"),
        QStringLiteral(u"woman construction worker: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC5"),
        QStringLiteral(u"person_with_crown"),
        QStringLiteral(u"person with crown"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC5\U0001F3FB"),
        QStringLiteral(u"person_with_crown_light_skin_tone"),
        QStringLiteral(u"person with crown: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC5\U0001F3FC"),
        QStringLiteral(u"person_with_crown_medium_light_skin_tone"),
        QStringLiteral(u"person with crown: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC5\U0001F3FD"),
        QStringLiteral(u"person_with_crown_medium_skin_tone"),
        QStringLiteral(u"person with crown: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC5\U0001F3FE"),
        QStringLiteral(u"person_with_crown_medium_dark_skin_tone"),
        QStringLiteral(u"person with crown: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC5\U0001F3FF"),
        QStringLiteral(u"person_with_crown_dark_skin_tone"),
        QStringLiteral(u"person with crown: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F934"),
        QStringLiteral(u"prince"),
        QStringLiteral(u"prince"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F934\U0001F3FB"),
        QStringLiteral(u"prince_light_skin_tone"),
        QStringLiteral(u"prince: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F934\U0001F3FC"),
        QStringLiteral(u"prince_medium_light_skin_tone"),
        QStringLiteral(u"prince: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F934\U0001F3FD"),
        QStringLiteral(u"prince_medium_skin_tone"),
        QStringLiteral(u"prince: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F934\U0001F3FE"),
        QStringLiteral(u"prince_medium_dark_skin_tone"),
        QStringLiteral(u"prince: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F934\U0001F3FF"),
        QStringLiteral(u"prince_dark_skin_tone"),
        QStringLiteral(u"prince: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F478"),
        QStringLiteral(u"princess"),
        QStringLiteral(u"princess"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F478\U0001F3FB"),
        QStringLiteral(u"princess_light_skin_tone"),
        QStringLiteral(u"princess: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F478\U0001F3FC"),
        QStringLiteral(u"princess_medium_light_skin_tone"),
        QStringLiteral(u"princess: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F478\U0001F3FD"),
        QStringLiteral(u"princess_medium_skin_tone"),
        QStringLiteral(u"princess: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F478\U0001F3FE"),
        QStringLiteral(u"princess_medium_dark_skin_tone"),
        QStringLiteral(u"princess: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F478\U0001F3FF"),
        QStringLiteral(u"princess_dark_skin_tone"),
        QStringLiteral(u"princess: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473"),
        QStringLiteral(u"person_wearing_turban"),
        QStringLiteral(u"person wearing turban"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FB"),
        QStringLiteral(u"person_wearing_turban_light_skin_tone"),
        QStringLiteral(u"person wearing turban: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FC"),
        QStringLiteral(u"person_wearing_turban_medium_light_skin_tone"),
        QStringLiteral(u"person wearing turban: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FD"),
        QStringLiteral(u"person_wearing_turban_medium_skin_tone"),
        QStringLiteral(u"person wearing turban: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FE"),
        QStringLiteral(u"person_wearing_turban_medium_dark_skin_tone"),
        QStringLiteral(u"person wearing turban: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FF"),
        QStringLiteral(u"person_wearing_turban_dark_skin_tone"),
        QStringLiteral(u"person wearing turban: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_wearing_turban"),
        QStringLiteral(u"man wearing turban"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_wearing_turban_light_skin_tone"),
        QStringLiteral(u"man wearing turban: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_wearing_turban_medium_light_skin_tone"),
        QStringLiteral(u"man wearing turban: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_wearing_turban_medium_skin_tone"),
        QStringLiteral(u"man wearing turban: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_wearing_turban_medium_dark_skin_tone"),
        QStringLiteral(u"man wearing turban: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_wearing_turban_dark_skin_tone"),
        QStringLiteral(u"man wearing turban: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_wearing_turban"),
        QStringLiteral(u"woman wearing turban"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_wearing_turban_light_skin_tone"),
        QStringLiteral(u"woman wearing turban: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_wearing_turban_medium_light_skin_tone"),
        QStringLiteral(u"woman wearing turban: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_wearing_turban_medium_skin_tone"),
        QStringLiteral(u"woman wearing turban: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_wearing_turban_medium_dark_skin_tone"),
        QStringLiteral(u"woman wearing turban: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F473\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_wearing_turban_dark_skin_tone"),
        QStringLiteral(u"woman wearing turban: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F472"),
        QStringLiteral(u"person_with_skullcap"),
        QStringLiteral(u"person with skullcap"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F472\U0001F3FB"),
        QStringLiteral(u"person_with_skullcap_light_skin_tone"),
        QStringLiteral(u"person with skullcap: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F472\U0001F3FC"),
        QStringLiteral(u"person_with_skullcap_medium_light_skin_tone"),
        QStringLiteral(u"person with skullcap: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F472\U0001F3FD"),
        QStringLiteral(u"person_with_skullcap_medium_skin_tone"),
        QStringLiteral(u"person with skullcap: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F472\U0001F3FE"),
        QStringLiteral(u"person_with_skullcap_medium_dark_skin_tone"),
        QStringLiteral(u"person with skullcap: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F472\U0001F3FF"),
        QStringLiteral(u"person_with_skullcap_dark_skin_tone"),
        QStringLiteral(u"person with skullcap: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D5"),
        QStringLiteral(u"woman_with_headscarf"),
        QStringLiteral(u"woman with headscarf"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D5\U0001F3FB"),
        QStringLiteral(u"woman_with_headscarf_light_skin_tone"),
        QStringLiteral(u"woman with headscarf: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D5\U0001F3FC"),
        QStringLiteral(u"woman_with_headscarf_medium_light_skin_tone"),
        QStringLiteral(u"woman with headscarf: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D5\U0001F3FD"),
        QStringLiteral(u"woman_with_headscarf_medium_skin_tone"),
        QStringLiteral(u"woman with headscarf: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D5\U0001F3FE"),
        QStringLiteral(u"woman_with_headscarf_medium_dark_skin_tone"),
        QStringLiteral(u"woman with headscarf: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D5\U0001F3FF"),
        QStringLiteral(u"woman_with_headscarf_dark_skin_tone"),
        QStringLiteral(u"woman with headscarf: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935"),
        QStringLiteral(u"person_in_tuxedo"),
        QStringLiteral(u"person in tuxedo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FB"),
        QStringLiteral(u"person_in_tuxedo_light_skin_tone"),
        QStringLiteral(u"person in tuxedo: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FC"),
        QStringLiteral(u"person_in_tuxedo_medium_light_skin_tone"),
        QStringLiteral(u"person in tuxedo: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FD"),
        QStringLiteral(u"person_in_tuxedo_medium_skin_tone"),
        QStringLiteral(u"person in tuxedo: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FE"),
        QStringLiteral(u"person_in_tuxedo_medium_dark_skin_tone"),
        QStringLiteral(u"person in tuxedo: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FF"),
        QStringLiteral(u"person_in_tuxedo_dark_skin_tone"),
        QStringLiteral(u"person in tuxedo: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_tuxedo"),
        QStringLiteral(u"man in tuxedo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_tuxedo_light_skin_tone"),
        QStringLiteral(u"man in tuxedo: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_tuxedo_medium_light_skin_tone"),
        QStringLiteral(u"man in tuxedo: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_tuxedo_medium_skin_tone"),
        QStringLiteral(u"man in tuxedo: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_tuxedo_medium_dark_skin_tone"),
        QStringLiteral(u"man in tuxedo: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_tuxedo_dark_skin_tone"),
        QStringLiteral(u"man in tuxedo: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_tuxedo"),
        QStringLiteral(u"woman in tuxedo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_tuxedo_light_skin_tone"),
        QStringLiteral(u"woman in tuxedo: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_tuxedo_medium_light_skin_tone"),
        QStringLiteral(u"woman in tuxedo: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_tuxedo_medium_skin_tone"),
        QStringLiteral(u"woman in tuxedo: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_tuxedo_medium_dark_skin_tone"),
        QStringLiteral(u"woman in tuxedo: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F935\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_tuxedo_dark_skin_tone"),
        QStringLiteral(u"woman in tuxedo: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470"),
        QStringLiteral(u"person_with_veil"),
        QStringLiteral(u"person with veil"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FB"),
        QStringLiteral(u"person_with_veil_light_skin_tone"),
        QStringLiteral(u"person with veil: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FC"),
        QStringLiteral(u"person_with_veil_medium_light_skin_tone"),
        QStringLiteral(u"person with veil: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FD"),
        QStringLiteral(u"person_with_veil_medium_skin_tone"),
        QStringLiteral(u"person with veil: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FE"),
        QStringLiteral(u"person_with_veil_medium_dark_skin_tone"),
        QStringLiteral(u"person with veil: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FF"),
        QStringLiteral(u"person_with_veil_dark_skin_tone"),
        QStringLiteral(u"person with veil: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_with_veil"),
        QStringLiteral(u"man with veil"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_with_veil_light_skin_tone"),
        QStringLiteral(u"man with veil: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_with_veil_medium_light_skin_tone"),
        QStringLiteral(u"man with veil: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_with_veil_medium_skin_tone"),
        QStringLiteral(u"man with veil: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_with_veil_medium_dark_skin_tone"),
        QStringLiteral(u"man with veil: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_with_veil_dark_skin_tone"),
        QStringLiteral(u"man with veil: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_with_veil"),
        QStringLiteral(u"woman with veil"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_with_veil_light_skin_tone"),
        QStringLiteral(u"woman with veil: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_with_veil_medium_light_skin_tone"),
        QStringLiteral(u"woman with veil: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_with_veil_medium_skin_tone"),
        QStringLiteral(u"woman with veil: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_with_veil_medium_dark_skin_tone"),
        QStringLiteral(u"woman with veil: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F470\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_with_veil_dark_skin_tone"),
        QStringLiteral(u"woman with veil: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F930"),
        QStringLiteral(u"pregnant_woman"),
        QStringLiteral(u"pregnant woman"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F930\U0001F3FB"),
        QStringLiteral(u"pregnant_woman_light_skin_tone"),
        QStringLiteral(u"pregnant woman: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F930\U0001F3FC"),
        QStringLiteral(u"pregnant_woman_medium_light_skin_tone"),
        QStringLiteral(u"pregnant woman: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F930\U0001F3FD"),
        QStringLiteral(u"pregnant_woman_medium_skin_tone"),
        QStringLiteral(u"pregnant woman: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F930\U0001F3FE"),
        QStringLiteral(u"pregnant_woman_medium_dark_skin_tone"),
        QStringLiteral(u"pregnant woman: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F930\U0001F3FF"),
        QStringLiteral(u"pregnant_woman_dark_skin_tone"),
        QStringLiteral(u"pregnant woman: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC3"),
        QStringLiteral(u"pregnant_man"),
        QStringLiteral(u"pregnant man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC3\U0001F3FB"),
        QStringLiteral(u"pregnant_man_light_skin_tone"),
        QStringLiteral(u"pregnant man: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC3\U0001F3FC"),
        QStringLiteral(u"pregnant_man_medium_light_skin_tone"),
        QStringLiteral(u"pregnant man: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC3\U0001F3FD"),
        QStringLiteral(u"pregnant_man_medium_skin_tone"),
        QStringLiteral(u"pregnant man: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC3\U0001F3FE"),
        QStringLiteral(u"pregnant_man_medium_dark_skin_tone"),
        QStringLiteral(u"pregnant man: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC3\U0001F3FF"),
        QStringLiteral(u"pregnant_man_dark_skin_tone"),
        QStringLiteral(u"pregnant man: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC4"),
        QStringLiteral(u"pregnant_person"),
        QStringLiteral(u"pregnant person"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC4\U0001F3FB"),
        QStringLiteral(u"pregnant_person_light_skin_tone"),
        QStringLiteral(u"pregnant person: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC4\U0001F3FC"),
        QStringLiteral(u"pregnant_person_medium_light_skin_tone"),
        QStringLiteral(u"pregnant person: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC4\U0001F3FD"),
        QStringLiteral(u"pregnant_person_medium_skin_tone"),
        QStringLiteral(u"pregnant person: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC4\U0001F3FE"),
        QStringLiteral(u"pregnant_person_medium_dark_skin_tone"),
        QStringLiteral(u"pregnant person: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC4\U0001F3FF"),
        QStringLiteral(u"pregnant_person_dark_skin_tone"),
        QStringLiteral(u"pregnant person: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F931"),
        QStringLiteral(u"breast_feeding"),
        QStringLiteral(u"breast-feeding"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F931\U0001F3FB"),
        QStringLiteral(u"breast_feeding_light_skin_tone"),
        QStringLiteral(u"breast-feeding: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F931\U0001F3FC"),
        QStringLiteral(u"breast_feeding_medium_light_skin_tone"),
        QStringLiteral(u"breast-feeding: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F931\U0001F3FD"),
        QStringLiteral(u"breast_feeding_medium_skin_tone"),
        QStringLiteral(u"breast-feeding: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F931\U0001F3FE"),
        QStringLiteral(u"breast_feeding_medium_dark_skin_tone"),
        QStringLiteral(u"breast-feeding: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F931\U0001F3FF"),
        QStringLiteral(u"breast_feeding_dark_skin_tone"),
        QStringLiteral(u"breast-feeding: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F37C"),
        QStringLiteral(u"woman_feeding_baby"),
        QStringLiteral(u"woman feeding baby"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F37C"),
        QStringLiteral(u"woman_feeding_baby_light_skin_tone"),
        QStringLiteral(u"woman feeding baby: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F37C"),
        QStringLiteral(u"woman_feeding_baby_medium_light_skin_tone"),
        QStringLiteral(u"woman feeding baby: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F37C"),
        QStringLiteral(u"woman_feeding_baby_medium_skin_tone"),
        QStringLiteral(u"woman feeding baby: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F37C"),
        QStringLiteral(u"woman_feeding_baby_medium_dark_skin_tone"),
        QStringLiteral(u"woman feeding baby: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F37C"),
        QStringLiteral(u"woman_feeding_baby_dark_skin_tone"),
        QStringLiteral(u"woman feeding baby: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F37C"),
        QStringLiteral(u"man_feeding_baby"),
        QStringLiteral(u"man feeding baby"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F37C"),
        QStringLiteral(u"man_feeding_baby_light_skin_tone"),
        QStringLiteral(u"man feeding baby: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F37C"),
        QStringLiteral(u"man_feeding_baby_medium_light_skin_tone"),
        QStringLiteral(u"man feeding baby: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F37C"),
        QStringLiteral(u"man_feeding_baby_medium_skin_tone"),
        QStringLiteral(u"man feeding baby: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F37C"),
        QStringLiteral(u"man_feeding_baby_medium_dark_skin_tone"),
        QStringLiteral(u"man feeding baby: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F37C"),
        QStringLiteral(u"man_feeding_baby_dark_skin_tone"),
        QStringLiteral(u"man feeding baby: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F37C"),
        QStringLiteral(u"person_feeding_baby"),
        QStringLiteral(u"person feeding baby"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F37C"),
        QStringLiteral(u"person_feeding_baby_light_skin_tone"),
        QStringLiteral(u"person feeding baby: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F37C"),
        QStringLiteral(u"person_feeding_baby_medium_light_skin_tone"),
        QStringLiteral(u"person feeding baby: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F37C"),
        QStringLiteral(u"person_feeding_baby_medium_skin_tone"),
        QStringLiteral(u"person feeding baby: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F37C"),
        QStringLiteral(u"person_feeding_baby_medium_dark_skin_tone"),
        QStringLiteral(u"person feeding baby: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F37C"),
        QStringLiteral(u"person_feeding_baby_dark_skin_tone"),
        QStringLiteral(u"person feeding baby: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47C"),
        QStringLiteral(u"baby_angel"),
        QStringLiteral(u"baby angel"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47C\U0001F3FB"),
        QStringLiteral(u"baby_angel_light_skin_tone"),
        QStringLiteral(u"baby angel: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47C\U0001F3FC"),
        QStringLiteral(u"baby_angel_medium_light_skin_tone"),
        QStringLiteral(u"baby angel: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47C\U0001F3FD"),
        QStringLiteral(u"baby_angel_medium_skin_tone"),
        QStringLiteral(u"baby angel: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47C\U0001F3FE"),
        QStringLiteral(u"baby_angel_medium_dark_skin_tone"),
        QStringLiteral(u"baby angel: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F47C\U0001F3FF"),
        QStringLiteral(u"baby_angel_dark_skin_tone"),
        QStringLiteral(u"baby angel: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F385"),
        QStringLiteral(u"santa_claus"),
        QStringLiteral(u"Santa Claus"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F385\U0001F3FB"),
        QStringLiteral(u"santa_claus_light_skin_tone"),
        QStringLiteral(u"Santa Claus: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F385\U0001F3FC"),
        QStringLiteral(u"santa_claus_medium_light_skin_tone"),
        QStringLiteral(u"Santa Claus: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F385\U0001F3FD"),
        QStringLiteral(u"santa_claus_medium_skin_tone"),
        QStringLiteral(u"Santa Claus: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F385\U0001F3FE"),
        QStringLiteral(u"santa_claus_medium_dark_skin_tone"),
        QStringLiteral(u"Santa Claus: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F385\U0001F3FF"),
        QStringLiteral(u"santa_claus_dark_skin_tone"),
        QStringLiteral(u"Santa Claus: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F936"),
        QStringLiteral(u"mrs_claus"),
        QStringLiteral(u"Mrs. Claus"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F936\U0001F3FB"),
        QStringLiteral(u"mrs_claus_light_skin_tone"),
        QStringLiteral(u"Mrs. Claus: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F936\U0001F3FC"),
        QStringLiteral(u"mrs_claus_medium_light_skin_tone"),
        QStringLiteral(u"Mrs. Claus: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F936\U0001F3FD"),
        QStringLiteral(u"mrs_claus_medium_skin_tone"),
        QStringLiteral(u"Mrs. Claus: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F936\U0001F3FE"),
        QStringLiteral(u"mrs_claus_medium_dark_skin_tone"),
        QStringLiteral(u"Mrs. Claus: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F936\U0001F3FF"),
        QStringLiteral(u"mrs_claus_dark_skin_tone"),
        QStringLiteral(u"Mrs. Claus: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F384"),
        QStringLiteral(u"mx_claus"),
        QStringLiteral(u"mx claus"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F384"),
        QStringLiteral(u"mx_claus_light_skin_tone"),
        QStringLiteral(u"mx claus: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F384"),
        QStringLiteral(u"mx_claus_medium_light_skin_tone"),
        QStringLiteral(u"mx claus: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F384"),
        QStringLiteral(u"mx_claus_medium_skin_tone"),
        QStringLiteral(u"mx claus: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F384"),
        QStringLiteral(u"mx_claus_medium_dark_skin_tone"),
        QStringLiteral(u"mx claus: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F384"),
        QStringLiteral(u"mx_claus_dark_skin_tone"),
        QStringLiteral(u"mx claus: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8"),
        QStringLiteral(u"superhero"),
        QStringLiteral(u"superhero"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FB"),
        QStringLiteral(u"superhero_light_skin_tone"),
        QStringLiteral(u"superhero: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FC"),
        QStringLiteral(u"superhero_medium_light_skin_tone"),
        QStringLiteral(u"superhero: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FD"),
        QStringLiteral(u"superhero_medium_skin_tone"),
        QStringLiteral(u"superhero: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FE"),
        QStringLiteral(u"superhero_medium_dark_skin_tone"),
        QStringLiteral(u"superhero: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FF"),
        QStringLiteral(u"superhero_dark_skin_tone"),
        QStringLiteral(u"superhero: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_superhero"),
        QStringLiteral(u"man superhero"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_superhero_light_skin_tone"),
        QStringLiteral(u"man superhero: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_superhero_medium_light_skin_tone"),
        QStringLiteral(u"man superhero: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_superhero_medium_skin_tone"),
        QStringLiteral(u"man superhero: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_superhero_medium_dark_skin_tone"),
        QStringLiteral(u"man superhero: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_superhero_dark_skin_tone"),
        QStringLiteral(u"man superhero: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_superhero"),
        QStringLiteral(u"woman superhero"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_superhero_light_skin_tone"),
        QStringLiteral(u"woman superhero: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_superhero_medium_light_skin_tone"),
        QStringLiteral(u"woman superhero: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_superhero_medium_skin_tone"),
        QStringLiteral(u"woman superhero: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_superhero_medium_dark_skin_tone"),
        QStringLiteral(u"woman superhero: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B8\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_superhero_dark_skin_tone"),
        QStringLiteral(u"woman superhero: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9"),
        QStringLiteral(u"supervillain"),
        QStringLiteral(u"supervillain"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FB"),
        QStringLiteral(u"supervillain_light_skin_tone"),
        QStringLiteral(u"supervillain: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FC"),
        QStringLiteral(u"supervillain_medium_light_skin_tone"),
        QStringLiteral(u"supervillain: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FD"),
        QStringLiteral(u"supervillain_medium_skin_tone"),
        QStringLiteral(u"supervillain: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FE"),
        QStringLiteral(u"supervillain_medium_dark_skin_tone"),
        QStringLiteral(u"supervillain: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FF"),
        QStringLiteral(u"supervillain_dark_skin_tone"),
        QStringLiteral(u"supervillain: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_supervillain"),
        QStringLiteral(u"man supervillain"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_supervillain_light_skin_tone"),
        QStringLiteral(u"man supervillain: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_supervillain_medium_light_skin_tone"),
        QStringLiteral(u"man supervillain: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_supervillain_medium_skin_tone"),
        QStringLiteral(u"man supervillain: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_supervillain_medium_dark_skin_tone"),
        QStringLiteral(u"man supervillain: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_supervillain_dark_skin_tone"),
        QStringLiteral(u"man supervillain: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_supervillain"),
        QStringLiteral(u"woman supervillain"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_supervillain_light_skin_tone"),
        QStringLiteral(u"woman supervillain: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_supervillain_medium_light_skin_tone"),
        QStringLiteral(u"woman supervillain: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_supervillain_medium_skin_tone"),
        QStringLiteral(u"woman supervillain: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_supervillain_medium_dark_skin_tone"),
        QStringLiteral(u"woman supervillain: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9B9\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_supervillain_dark_skin_tone"),
        QStringLiteral(u"woman supervillain: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9"),
        QStringLiteral(u"mage"),
        QStringLiteral(u"mage"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FB"),
        QStringLiteral(u"mage_light_skin_tone"),
        QStringLiteral(u"mage: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FC"),
        QStringLiteral(u"mage_medium_light_skin_tone"),
        QStringLiteral(u"mage: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FD"),
        QStringLiteral(u"mage_medium_skin_tone"),
        QStringLiteral(u"mage: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FE"),
        QStringLiteral(u"mage_medium_dark_skin_tone"),
        QStringLiteral(u"mage: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FF"),
        QStringLiteral(u"mage_dark_skin_tone"),
        QStringLiteral(u"mage: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mage"),
        QStringLiteral(u"man mage"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mage_light_skin_tone"),
        QStringLiteral(u"man mage: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mage_medium_light_skin_tone"),
        QStringLiteral(u"man mage: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mage_medium_skin_tone"),
        QStringLiteral(u"man mage: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mage_medium_dark_skin_tone"),
        QStringLiteral(u"man mage: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mage_dark_skin_tone"),
        QStringLiteral(u"man mage: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mage"),
        QStringLiteral(u"woman mage"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mage_light_skin_tone"),
        QStringLiteral(u"woman mage: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mage_medium_light_skin_tone"),
        QStringLiteral(u"woman mage: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mage_medium_skin_tone"),
        QStringLiteral(u"woman mage: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mage_medium_dark_skin_tone"),
        QStringLiteral(u"woman mage: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D9\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mage_dark_skin_tone"),
        QStringLiteral(u"woman mage: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA"),
        QStringLiteral(u"fairy"),
        QStringLiteral(u"fairy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FB"),
        QStringLiteral(u"fairy_light_skin_tone"),
        QStringLiteral(u"fairy: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FC"),
        QStringLiteral(u"fairy_medium_light_skin_tone"),
        QStringLiteral(u"fairy: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FD"),
        QStringLiteral(u"fairy_medium_skin_tone"),
        QStringLiteral(u"fairy: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FE"),
        QStringLiteral(u"fairy_medium_dark_skin_tone"),
        QStringLiteral(u"fairy: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FF"),
        QStringLiteral(u"fairy_dark_skin_tone"),
        QStringLiteral(u"fairy: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_fairy"),
        QStringLiteral(u"man fairy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_fairy_light_skin_tone"),
        QStringLiteral(u"man fairy: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_fairy_medium_light_skin_tone"),
        QStringLiteral(u"man fairy: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_fairy_medium_skin_tone"),
        QStringLiteral(u"man fairy: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_fairy_medium_dark_skin_tone"),
        QStringLiteral(u"man fairy: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_fairy_dark_skin_tone"),
        QStringLiteral(u"man fairy: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_fairy"),
        QStringLiteral(u"woman fairy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_fairy_light_skin_tone"),
        QStringLiteral(u"woman fairy: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_fairy_medium_light_skin_tone"),
        QStringLiteral(u"woman fairy: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_fairy_medium_skin_tone"),
        QStringLiteral(u"woman fairy: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_fairy_medium_dark_skin_tone"),
        QStringLiteral(u"woman fairy: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DA\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_fairy_dark_skin_tone"),
        QStringLiteral(u"woman fairy: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB"),
        QStringLiteral(u"vampire"),
        QStringLiteral(u"vampire"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FB"),
        QStringLiteral(u"vampire_light_skin_tone"),
        QStringLiteral(u"vampire: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FC"),
        QStringLiteral(u"vampire_medium_light_skin_tone"),
        QStringLiteral(u"vampire: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FD"),
        QStringLiteral(u"vampire_medium_skin_tone"),
        QStringLiteral(u"vampire: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FE"),
        QStringLiteral(u"vampire_medium_dark_skin_tone"),
        QStringLiteral(u"vampire: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FF"),
        QStringLiteral(u"vampire_dark_skin_tone"),
        QStringLiteral(u"vampire: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_vampire"),
        QStringLiteral(u"man vampire"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_vampire_light_skin_tone"),
        QStringLiteral(u"man vampire: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_vampire_medium_light_skin_tone"),
        QStringLiteral(u"man vampire: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_vampire_medium_skin_tone"),
        QStringLiteral(u"man vampire: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_vampire_medium_dark_skin_tone"),
        QStringLiteral(u"man vampire: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_vampire_dark_skin_tone"),
        QStringLiteral(u"man vampire: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_vampire"),
        QStringLiteral(u"woman vampire"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_vampire_light_skin_tone"),
        QStringLiteral(u"woman vampire: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_vampire_medium_light_skin_tone"),
        QStringLiteral(u"woman vampire: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_vampire_medium_skin_tone"),
        QStringLiteral(u"woman vampire: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_vampire_medium_dark_skin_tone"),
        QStringLiteral(u"woman vampire: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DB\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_vampire_dark_skin_tone"),
        QStringLiteral(u"woman vampire: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC"),
        QStringLiteral(u"merperson"),
        QStringLiteral(u"merperson"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FB"),
        QStringLiteral(u"merperson_light_skin_tone"),
        QStringLiteral(u"merperson: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FC"),
        QStringLiteral(u"merperson_medium_light_skin_tone"),
        QStringLiteral(u"merperson: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FD"),
        QStringLiteral(u"merperson_medium_skin_tone"),
        QStringLiteral(u"merperson: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FE"),
        QStringLiteral(u"merperson_medium_dark_skin_tone"),
        QStringLiteral(u"merperson: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FF"),
        QStringLiteral(u"merperson_dark_skin_tone"),
        QStringLiteral(u"merperson: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"merman"),
        QStringLiteral(u"merman"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"merman_light_skin_tone"),
        QStringLiteral(u"merman: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"merman_medium_light_skin_tone"),
        QStringLiteral(u"merman: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"merman_medium_skin_tone"),
        QStringLiteral(u"merman: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"merman_medium_dark_skin_tone"),
        QStringLiteral(u"merman: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"merman_dark_skin_tone"),
        QStringLiteral(u"merman: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"mermaid"),
        QStringLiteral(u"mermaid"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"mermaid_light_skin_tone"),
        QStringLiteral(u"mermaid: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"mermaid_medium_light_skin_tone"),
        QStringLiteral(u"mermaid: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"mermaid_medium_skin_tone"),
        QStringLiteral(u"mermaid: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"mermaid_medium_dark_skin_tone"),
        QStringLiteral(u"mermaid: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DC\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"mermaid_dark_skin_tone"),
        QStringLiteral(u"mermaid: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD"),
        QStringLiteral(u"elf"),
        QStringLiteral(u"elf"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FB"),
        QStringLiteral(u"elf_light_skin_tone"),
        QStringLiteral(u"elf: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FC"),
        QStringLiteral(u"elf_medium_light_skin_tone"),
        QStringLiteral(u"elf: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FD"),
        QStringLiteral(u"elf_medium_skin_tone"),
        QStringLiteral(u"elf: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FE"),
        QStringLiteral(u"elf_medium_dark_skin_tone"),
        QStringLiteral(u"elf: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FF"),
        QStringLiteral(u"elf_dark_skin_tone"),
        QStringLiteral(u"elf: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_elf"),
        QStringLiteral(u"man elf"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_elf_light_skin_tone"),
        QStringLiteral(u"man elf: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_elf_medium_light_skin_tone"),
        QStringLiteral(u"man elf: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_elf_medium_skin_tone"),
        QStringLiteral(u"man elf: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_elf_medium_dark_skin_tone"),
        QStringLiteral(u"man elf: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_elf_dark_skin_tone"),
        QStringLiteral(u"man elf: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_elf"),
        QStringLiteral(u"woman elf"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_elf_light_skin_tone"),
        QStringLiteral(u"woman elf: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_elf_medium_light_skin_tone"),
        QStringLiteral(u"woman elf: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_elf_medium_skin_tone"),
        QStringLiteral(u"woman elf: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_elf_medium_dark_skin_tone"),
        QStringLiteral(u"woman elf: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DD\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_elf_dark_skin_tone"),
        QStringLiteral(u"woman elf: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DE"),
        QStringLiteral(u"genie"),
        QStringLiteral(u"genie"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_genie"),
        QStringLiteral(u"man genie"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_genie"),
        QStringLiteral(u"woman genie"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DF"),
        QStringLiteral(u"zombie"),
        QStringLiteral(u"zombie"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_zombie"),
        QStringLiteral(u"man zombie"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9DF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_zombie"),
        QStringLiteral(u"woman zombie"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CC"),
        QStringLiteral(u"troll"),
        QStringLiteral(u"troll"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486"),
        QStringLiteral(u"person_getting_massage"),
        QStringLiteral(u"person getting massage"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FB"),
        QStringLiteral(u"person_getting_massage_light_skin_tone"),
        QStringLiteral(u"person getting massage: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FC"),
        QStringLiteral(u"person_getting_massage_medium_light_skin_tone"),
        QStringLiteral(u"person getting massage: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FD"),
        QStringLiteral(u"person_getting_massage_medium_skin_tone"),
        QStringLiteral(u"person getting massage: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FE"),
        QStringLiteral(u"person_getting_massage_medium_dark_skin_tone"),
        QStringLiteral(u"person getting massage: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FF"),
        QStringLiteral(u"person_getting_massage_dark_skin_tone"),
        QStringLiteral(u"person getting massage: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_massage"),
        QStringLiteral(u"man getting massage"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_massage_light_skin_tone"),
        QStringLiteral(u"man getting massage: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_massage_medium_light_skin_tone"),
        QStringLiteral(u"man getting massage: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_massage_medium_skin_tone"),
        QStringLiteral(u"man getting massage: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_massage_medium_dark_skin_tone"),
        QStringLiteral(u"man getting massage: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_massage_dark_skin_tone"),
        QStringLiteral(u"man getting massage: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_massage"),
        QStringLiteral(u"woman getting massage"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_massage_light_skin_tone"),
        QStringLiteral(u"woman getting massage: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_massage_medium_light_skin_tone"),
        QStringLiteral(u"woman getting massage: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_massage_medium_skin_tone"),
        QStringLiteral(u"woman getting massage: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_massage_medium_dark_skin_tone"),
        QStringLiteral(u"woman getting massage: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F486\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_massage_dark_skin_tone"),
        QStringLiteral(u"woman getting massage: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487"),
        QStringLiteral(u"person_getting_haircut"),
        QStringLiteral(u"person getting haircut"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FB"),
        QStringLiteral(u"person_getting_haircut_light_skin_tone"),
        QStringLiteral(u"person getting haircut: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FC"),
        QStringLiteral(u"person_getting_haircut_medium_light_skin_tone"),
        QStringLiteral(u"person getting haircut: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FD"),
        QStringLiteral(u"person_getting_haircut_medium_skin_tone"),
        QStringLiteral(u"person getting haircut: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FE"),
        QStringLiteral(u"person_getting_haircut_medium_dark_skin_tone"),
        QStringLiteral(u"person getting haircut: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FF"),
        QStringLiteral(u"person_getting_haircut_dark_skin_tone"),
        QStringLiteral(u"person getting haircut: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_haircut"),
        QStringLiteral(u"man getting haircut"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_haircut_light_skin_tone"),
        QStringLiteral(u"man getting haircut: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_haircut_medium_light_skin_tone"),
        QStringLiteral(u"man getting haircut: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_haircut_medium_skin_tone"),
        QStringLiteral(u"man getting haircut: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_haircut_medium_dark_skin_tone"),
        QStringLiteral(u"man getting haircut: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_getting_haircut_dark_skin_tone"),
        QStringLiteral(u"man getting haircut: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_haircut"),
        QStringLiteral(u"woman getting haircut"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_haircut_light_skin_tone"),
        QStringLiteral(u"woman getting haircut: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_haircut_medium_light_skin_tone"),
        QStringLiteral(u"woman getting haircut: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_haircut_medium_skin_tone"),
        QStringLiteral(u"woman getting haircut: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_haircut_medium_dark_skin_tone"),
        QStringLiteral(u"woman getting haircut: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F487\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_getting_haircut_dark_skin_tone"),
        QStringLiteral(u"woman getting haircut: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6"),
        QStringLiteral(u"person_walking"),
        QStringLiteral(u"person walking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FB"),
        QStringLiteral(u"person_walking_light_skin_tone"),
        QStringLiteral(u"person walking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FC"),
        QStringLiteral(u"person_walking_medium_light_skin_tone"),
        QStringLiteral(u"person walking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FD"),
        QStringLiteral(u"person_walking_medium_skin_tone"),
        QStringLiteral(u"person walking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FE"),
        QStringLiteral(u"person_walking_medium_dark_skin_tone"),
        QStringLiteral(u"person walking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FF"),
        QStringLiteral(u"person_walking_dark_skin_tone"),
        QStringLiteral(u"person walking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_walking"),
        QStringLiteral(u"man walking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_walking_light_skin_tone"),
        QStringLiteral(u"man walking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_walking_medium_light_skin_tone"),
        QStringLiteral(u"man walking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_walking_medium_skin_tone"),
        QStringLiteral(u"man walking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_walking_medium_dark_skin_tone"),
        QStringLiteral(u"man walking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_walking_dark_skin_tone"),
        QStringLiteral(u"man walking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_walking"),
        QStringLiteral(u"woman walking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_walking_light_skin_tone"),
        QStringLiteral(u"woman walking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_walking_medium_light_skin_tone"),
        QStringLiteral(u"woman walking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_walking_medium_skin_tone"),
        QStringLiteral(u"woman walking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_walking_medium_dark_skin_tone"),
        QStringLiteral(u"woman walking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B6\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_walking_dark_skin_tone"),
        QStringLiteral(u"woman walking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD"),
        QStringLiteral(u"person_standing"),
        QStringLiteral(u"person standing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FB"),
        QStringLiteral(u"person_standing_light_skin_tone"),
        QStringLiteral(u"person standing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FC"),
        QStringLiteral(u"person_standing_medium_light_skin_tone"),
        QStringLiteral(u"person standing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FD"),
        QStringLiteral(u"person_standing_medium_skin_tone"),
        QStringLiteral(u"person standing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FE"),
        QStringLiteral(u"person_standing_medium_dark_skin_tone"),
        QStringLiteral(u"person standing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FF"),
        QStringLiteral(u"person_standing_dark_skin_tone"),
        QStringLiteral(u"person standing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_standing"),
        QStringLiteral(u"man standing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_standing_light_skin_tone"),
        QStringLiteral(u"man standing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_standing_medium_light_skin_tone"),
        QStringLiteral(u"man standing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_standing_medium_skin_tone"),
        QStringLiteral(u"man standing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_standing_medium_dark_skin_tone"),
        QStringLiteral(u"man standing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_standing_dark_skin_tone"),
        QStringLiteral(u"man standing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_standing"),
        QStringLiteral(u"woman standing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_standing_light_skin_tone"),
        QStringLiteral(u"woman standing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_standing_medium_light_skin_tone"),
        QStringLiteral(u"woman standing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_standing_medium_skin_tone"),
        QStringLiteral(u"woman standing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_standing_medium_dark_skin_tone"),
        QStringLiteral(u"woman standing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CD\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_standing_dark_skin_tone"),
        QStringLiteral(u"woman standing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE"),
        QStringLiteral(u"person_kneeling"),
        QStringLiteral(u"person kneeling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FB"),
        QStringLiteral(u"person_kneeling_light_skin_tone"),
        QStringLiteral(u"person kneeling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FC"),
        QStringLiteral(u"person_kneeling_medium_light_skin_tone"),
        QStringLiteral(u"person kneeling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FD"),
        QStringLiteral(u"person_kneeling_medium_skin_tone"),
        QStringLiteral(u"person kneeling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FE"),
        QStringLiteral(u"person_kneeling_medium_dark_skin_tone"),
        QStringLiteral(u"person kneeling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FF"),
        QStringLiteral(u"person_kneeling_dark_skin_tone"),
        QStringLiteral(u"person kneeling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_kneeling"),
        QStringLiteral(u"man kneeling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_kneeling_light_skin_tone"),
        QStringLiteral(u"man kneeling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_kneeling_medium_light_skin_tone"),
        QStringLiteral(u"man kneeling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_kneeling_medium_skin_tone"),
        QStringLiteral(u"man kneeling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_kneeling_medium_dark_skin_tone"),
        QStringLiteral(u"man kneeling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_kneeling_dark_skin_tone"),
        QStringLiteral(u"man kneeling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_kneeling"),
        QStringLiteral(u"woman kneeling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_kneeling_light_skin_tone"),
        QStringLiteral(u"woman kneeling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_kneeling_medium_light_skin_tone"),
        QStringLiteral(u"woman kneeling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_kneeling_medium_skin_tone"),
        QStringLiteral(u"woman kneeling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_kneeling_medium_dark_skin_tone"),
        QStringLiteral(u"woman kneeling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9CE\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_kneeling_dark_skin_tone"),
        QStringLiteral(u"woman kneeling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F9AF"),
        QStringLiteral(u"person_with_white_cane"),
        QStringLiteral(u"person with white cane"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F9AF"),
        QStringLiteral(u"person_with_white_cane_light_skin_tone"),
        QStringLiteral(u"person with white cane: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F9AF"),
        QStringLiteral(u"person_with_white_cane_medium_light_skin_tone"),
        QStringLiteral(u"person with white cane: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F9AF"),
        QStringLiteral(u"person_with_white_cane_medium_skin_tone"),
        QStringLiteral(u"person with white cane: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F9AF"),
        QStringLiteral(u"person_with_white_cane_medium_dark_skin_tone"),
        QStringLiteral(u"person with white cane: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F9AF"),
        QStringLiteral(u"person_with_white_cane_dark_skin_tone"),
        QStringLiteral(u"person with white cane: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F9AF"),
        QStringLiteral(u"man_with_white_cane"),
        QStringLiteral(u"man with white cane"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F9AF"),
        QStringLiteral(u"man_with_white_cane_light_skin_tone"),
        QStringLiteral(u"man with white cane: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F9AF"),
        QStringLiteral(u"man_with_white_cane_medium_light_skin_tone"),
        QStringLiteral(u"man with white cane: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F9AF"),
        QStringLiteral(u"man_with_white_cane_medium_skin_tone"),
        QStringLiteral(u"man with white cane: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F9AF"),
        QStringLiteral(u"man_with_white_cane_medium_dark_skin_tone"),
        QStringLiteral(u"man with white cane: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F9AF"),
        QStringLiteral(u"man_with_white_cane_dark_skin_tone"),
        QStringLiteral(u"man with white cane: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F9AF"),
        QStringLiteral(u"woman_with_white_cane"),
        QStringLiteral(u"woman with white cane"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F9AF"),
        QStringLiteral(u"woman_with_white_cane_light_skin_tone"),
        QStringLiteral(u"woman with white cane: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F9AF"),
        QStringLiteral(u"woman_with_white_cane_medium_light_skin_tone"),
        QStringLiteral(u"woman with white cane: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F9AF"),
        QStringLiteral(u"woman_with_white_cane_medium_skin_tone"),
        QStringLiteral(u"woman with white cane: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F9AF"),
        QStringLiteral(u"woman_with_white_cane_medium_dark_skin_tone"),
        QStringLiteral(u"woman with white cane: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F9AF"),
        QStringLiteral(u"woman_with_white_cane_dark_skin_tone"),
        QStringLiteral(u"woman with white cane: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F9BC"),
        QStringLiteral(u"person_in_motorized_wheelchair"),
        QStringLiteral(u"person in motorized wheelchair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F9BC"),
        QStringLiteral(u"person_in_motorized_wheelchair_light_skin_tone"),
        QStringLiteral(u"person in motorized wheelchair: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F9BC"),
        QStringLiteral(u"person_in_motorized_wheelchair_medium_light_skin_tone"),
        QStringLiteral(u"person in motorized wheelchair: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F9BC"),
        QStringLiteral(u"person_in_motorized_wheelchair_medium_skin_tone"),
        QStringLiteral(u"person in motorized wheelchair: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F9BC"),
        QStringLiteral(u"person_in_motorized_wheelchair_medium_dark_skin_tone"),
        QStringLiteral(u"person in motorized wheelchair: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F9BC"),
        QStringLiteral(u"person_in_motorized_wheelchair_dark_skin_tone"),
        QStringLiteral(u"person in motorized wheelchair: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F9BC"),
        QStringLiteral(u"man_in_motorized_wheelchair"),
        QStringLiteral(u"man in motorized wheelchair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F9BC"),
        QStringLiteral(u"man_in_motorized_wheelchair_light_skin_tone"),
        QStringLiteral(u"man in motorized wheelchair: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F9BC"),
        QStringLiteral(u"man_in_motorized_wheelchair_medium_light_skin_tone"),
        QStringLiteral(u"man in motorized wheelchair: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F9BC"),
        QStringLiteral(u"man_in_motorized_wheelchair_medium_skin_tone"),
        QStringLiteral(u"man in motorized wheelchair: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F9BC"),
        QStringLiteral(u"man_in_motorized_wheelchair_medium_dark_skin_tone"),
        QStringLiteral(u"man in motorized wheelchair: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F9BC"),
        QStringLiteral(u"man_in_motorized_wheelchair_dark_skin_tone"),
        QStringLiteral(u"man in motorized wheelchair: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F9BC"),
        QStringLiteral(u"woman_in_motorized_wheelchair"),
        QStringLiteral(u"woman in motorized wheelchair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F9BC"),
        QStringLiteral(u"woman_in_motorized_wheelchair_light_skin_tone"),
        QStringLiteral(u"woman in motorized wheelchair: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F9BC"),
        QStringLiteral(u"woman_in_motorized_wheelchair_medium_light_skin_tone"),
        QStringLiteral(u"woman in motorized wheelchair: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F9BC"),
        QStringLiteral(u"woman_in_motorized_wheelchair_medium_skin_tone"),
        QStringLiteral(u"woman in motorized wheelchair: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F9BC"),
        QStringLiteral(u"woman_in_motorized_wheelchair_medium_dark_skin_tone"),
        QStringLiteral(u"woman in motorized wheelchair: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F9BC"),
        QStringLiteral(u"woman_in_motorized_wheelchair_dark_skin_tone"),
        QStringLiteral(u"woman in motorized wheelchair: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F9BD"),
        QStringLiteral(u"person_in_manual_wheelchair"),
        QStringLiteral(u"person in manual wheelchair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F9BD"),
        QStringLiteral(u"person_in_manual_wheelchair_light_skin_tone"),
        QStringLiteral(u"person in manual wheelchair: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F9BD"),
        QStringLiteral(u"person_in_manual_wheelchair_medium_light_skin_tone"),
        QStringLiteral(u"person in manual wheelchair: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F9BD"),
        QStringLiteral(u"person_in_manual_wheelchair_medium_skin_tone"),
        QStringLiteral(u"person in manual wheelchair: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F9BD"),
        QStringLiteral(u"person_in_manual_wheelchair_medium_dark_skin_tone"),
        QStringLiteral(u"person in manual wheelchair: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F9BD"),
        QStringLiteral(u"person_in_manual_wheelchair_dark_skin_tone"),
        QStringLiteral(u"person in manual wheelchair: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F9BD"),
        QStringLiteral(u"man_in_manual_wheelchair"),
        QStringLiteral(u"man in manual wheelchair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F9BD"),
        QStringLiteral(u"man_in_manual_wheelchair_light_skin_tone"),
        QStringLiteral(u"man in manual wheelchair: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F9BD"),
        QStringLiteral(u"man_in_manual_wheelchair_medium_light_skin_tone"),
        QStringLiteral(u"man in manual wheelchair: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F9BD"),
        QStringLiteral(u"man_in_manual_wheelchair_medium_skin_tone"),
        QStringLiteral(u"man in manual wheelchair: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F9BD"),
        QStringLiteral(u"man_in_manual_wheelchair_medium_dark_skin_tone"),
        QStringLiteral(u"man in manual wheelchair: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F9BD"),
        QStringLiteral(u"man_in_manual_wheelchair_dark_skin_tone"),
        QStringLiteral(u"man in manual wheelchair: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F9BD"),
        QStringLiteral(u"woman_in_manual_wheelchair"),
        QStringLiteral(u"woman in manual wheelchair"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F9BD"),
        QStringLiteral(u"woman_in_manual_wheelchair_light_skin_tone"),
        QStringLiteral(u"woman in manual wheelchair: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F9BD"),
        QStringLiteral(u"woman_in_manual_wheelchair_medium_light_skin_tone"),
        QStringLiteral(u"woman in manual wheelchair: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F9BD"),
        QStringLiteral(u"woman_in_manual_wheelchair_medium_skin_tone"),
        QStringLiteral(u"woman in manual wheelchair: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F9BD"),
        QStringLiteral(u"woman_in_manual_wheelchair_medium_dark_skin_tone"),
        QStringLiteral(u"woman in manual wheelchair: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F9BD"),
        QStringLiteral(u"woman_in_manual_wheelchair_dark_skin_tone"),
        QStringLiteral(u"woman in manual wheelchair: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3"),
        QStringLiteral(u"person_running"),
        QStringLiteral(u"person running"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FB"),
        QStringLiteral(u"person_running_light_skin_tone"),
        QStringLiteral(u"person running: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FC"),
        QStringLiteral(u"person_running_medium_light_skin_tone"),
        QStringLiteral(u"person running: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FD"),
        QStringLiteral(u"person_running_medium_skin_tone"),
        QStringLiteral(u"person running: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FE"),
        QStringLiteral(u"person_running_medium_dark_skin_tone"),
        QStringLiteral(u"person running: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FF"),
        QStringLiteral(u"person_running_dark_skin_tone"),
        QStringLiteral(u"person running: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_running"),
        QStringLiteral(u"man running"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_running_light_skin_tone"),
        QStringLiteral(u"man running: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_running_medium_light_skin_tone"),
        QStringLiteral(u"man running: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_running_medium_skin_tone"),
        QStringLiteral(u"man running: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_running_medium_dark_skin_tone"),
        QStringLiteral(u"man running: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_running_dark_skin_tone"),
        QStringLiteral(u"man running: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_running"),
        QStringLiteral(u"woman running"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_running_light_skin_tone"),
        QStringLiteral(u"woman running: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_running_medium_light_skin_tone"),
        QStringLiteral(u"woman running: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_running_medium_skin_tone"),
        QStringLiteral(u"woman running: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_running_medium_dark_skin_tone"),
        QStringLiteral(u"woman running: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C3\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_running_dark_skin_tone"),
        QStringLiteral(u"woman running: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F483"),
        QStringLiteral(u"woman_dancing"),
        QStringLiteral(u"woman dancing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F483\U0001F3FB"),
        QStringLiteral(u"woman_dancing_light_skin_tone"),
        QStringLiteral(u"woman dancing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F483\U0001F3FC"),
        QStringLiteral(u"woman_dancing_medium_light_skin_tone"),
        QStringLiteral(u"woman dancing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F483\U0001F3FD"),
        QStringLiteral(u"woman_dancing_medium_skin_tone"),
        QStringLiteral(u"woman dancing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F483\U0001F3FE"),
        QStringLiteral(u"woman_dancing_medium_dark_skin_tone"),
        QStringLiteral(u"woman dancing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F483\U0001F3FF"),
        QStringLiteral(u"woman_dancing_dark_skin_tone"),
        QStringLiteral(u"woman dancing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F57A"),
        QStringLiteral(u"man_dancing"),
        QStringLiteral(u"man dancing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F57A\U0001F3FB"),
        QStringLiteral(u"man_dancing_light_skin_tone"),
        QStringLiteral(u"man dancing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F57A\U0001F3FC"),
        QStringLiteral(u"man_dancing_medium_light_skin_tone"),
        QStringLiteral(u"man dancing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F57A\U0001F3FD"),
        QStringLiteral(u"man_dancing_medium_skin_tone"),
        QStringLiteral(u"man dancing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F57A\U0001F3FE"),
        QStringLiteral(u"man_dancing_medium_dark_skin_tone"),
        QStringLiteral(u"man dancing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F57A\U0001F3FF"),
        QStringLiteral(u"man_dancing_dark_skin_tone"),
        QStringLiteral(u"man dancing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F574\U0000FE0F"),
        QStringLiteral(u"person_in_suit_levitating"),
        QStringLiteral(u"person in suit levitating"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F574\U0001F3FB"),
        QStringLiteral(u"person_in_suit_levitating_light_skin_tone"),
        QStringLiteral(u"person in suit levitating: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F574\U0001F3FC"),
        QStringLiteral(u"person_in_suit_levitating_medium_light_skin_tone"),
        QStringLiteral(u"person in suit levitating: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F574\U0001F3FD"),
        QStringLiteral(u"person_in_suit_levitating_medium_skin_tone"),
        QStringLiteral(u"person in suit levitating: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F574\U0001F3FE"),
        QStringLiteral(u"person_in_suit_levitating_medium_dark_skin_tone"),
        QStringLiteral(u"person in suit levitating: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F574\U0001F3FF"),
        QStringLiteral(u"person_in_suit_levitating_dark_skin_tone"),
        QStringLiteral(u"person in suit levitating: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46F"),
        QStringLiteral(u"people_with_bunny_ears"),
        QStringLiteral(u"people with bunny ears"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46F\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"men_with_bunny_ears"),
        QStringLiteral(u"men with bunny ears"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46F\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"women_with_bunny_ears"),
        QStringLiteral(u"women with bunny ears"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6"),
        QStringLiteral(u"person_in_steamy_room"),
        QStringLiteral(u"person in steamy room"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FB"),
        QStringLiteral(u"person_in_steamy_room_light_skin_tone"),
        QStringLiteral(u"person in steamy room: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FC"),
        QStringLiteral(u"person_in_steamy_room_medium_light_skin_tone"),
        QStringLiteral(u"person in steamy room: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FD"),
        QStringLiteral(u"person_in_steamy_room_medium_skin_tone"),
        QStringLiteral(u"person in steamy room: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FE"),
        QStringLiteral(u"person_in_steamy_room_medium_dark_skin_tone"),
        QStringLiteral(u"person in steamy room: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FF"),
        QStringLiteral(u"person_in_steamy_room_dark_skin_tone"),
        QStringLiteral(u"person in steamy room: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_steamy_room"),
        QStringLiteral(u"man in steamy room"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_steamy_room_light_skin_tone"),
        QStringLiteral(u"man in steamy room: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_steamy_room_medium_light_skin_tone"),
        QStringLiteral(u"man in steamy room: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_steamy_room_medium_skin_tone"),
        QStringLiteral(u"man in steamy room: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_steamy_room_medium_dark_skin_tone"),
        QStringLiteral(u"man in steamy room: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_steamy_room_dark_skin_tone"),
        QStringLiteral(u"man in steamy room: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_steamy_room"),
        QStringLiteral(u"woman in steamy room"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_steamy_room_light_skin_tone"),
        QStringLiteral(u"woman in steamy room: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_steamy_room_medium_light_skin_tone"),
        QStringLiteral(u"woman in steamy room: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_steamy_room_medium_skin_tone"),
        QStringLiteral(u"woman in steamy room: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_steamy_room_medium_dark_skin_tone"),
        QStringLiteral(u"woman in steamy room: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D6\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_steamy_room_dark_skin_tone"),
        QStringLiteral(u"woman in steamy room: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7"),
        QStringLiteral(u"person_climbing"),
        QStringLiteral(u"person climbing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FB"),
        QStringLiteral(u"person_climbing_light_skin_tone"),
        QStringLiteral(u"person climbing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FC"),
        QStringLiteral(u"person_climbing_medium_light_skin_tone"),
        QStringLiteral(u"person climbing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FD"),
        QStringLiteral(u"person_climbing_medium_skin_tone"),
        QStringLiteral(u"person climbing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FE"),
        QStringLiteral(u"person_climbing_medium_dark_skin_tone"),
        QStringLiteral(u"person climbing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FF"),
        QStringLiteral(u"person_climbing_dark_skin_tone"),
        QStringLiteral(u"person climbing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_climbing"),
        QStringLiteral(u"man climbing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_climbing_light_skin_tone"),
        QStringLiteral(u"man climbing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_climbing_medium_light_skin_tone"),
        QStringLiteral(u"man climbing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_climbing_medium_skin_tone"),
        QStringLiteral(u"man climbing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_climbing_medium_dark_skin_tone"),
        QStringLiteral(u"man climbing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_climbing_dark_skin_tone"),
        QStringLiteral(u"man climbing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_climbing"),
        QStringLiteral(u"woman climbing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_climbing_light_skin_tone"),
        QStringLiteral(u"woman climbing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_climbing_medium_light_skin_tone"),
        QStringLiteral(u"woman climbing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_climbing_medium_skin_tone"),
        QStringLiteral(u"woman climbing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_climbing_medium_dark_skin_tone"),
        QStringLiteral(u"woman climbing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D7\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_climbing_dark_skin_tone"),
        QStringLiteral(u"woman climbing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93A"),
        QStringLiteral(u"person_fencing"),
        QStringLiteral(u"person fencing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C7"),
        QStringLiteral(u"horse_racing"),
        QStringLiteral(u"horse racing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C7\U0001F3FB"),
        QStringLiteral(u"horse_racing_light_skin_tone"),
        QStringLiteral(u"horse racing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C7\U0001F3FC"),
        QStringLiteral(u"horse_racing_medium_light_skin_tone"),
        QStringLiteral(u"horse racing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C7\U0001F3FD"),
        QStringLiteral(u"horse_racing_medium_skin_tone"),
        QStringLiteral(u"horse racing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C7\U0001F3FE"),
        QStringLiteral(u"horse_racing_medium_dark_skin_tone"),
        QStringLiteral(u"horse racing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C7\U0001F3FF"),
        QStringLiteral(u"horse_racing_dark_skin_tone"),
        QStringLiteral(u"horse racing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F7\U0000FE0F"),
        QStringLiteral(u"skier"),
        QStringLiteral(u"skier"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C2"),
        QStringLiteral(u"snowboarder"),
        QStringLiteral(u"snowboarder"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C2\U0001F3FB"),
        QStringLiteral(u"snowboarder_light_skin_tone"),
        QStringLiteral(u"snowboarder: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C2\U0001F3FC"),
        QStringLiteral(u"snowboarder_medium_light_skin_tone"),
        QStringLiteral(u"snowboarder: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C2\U0001F3FD"),
        QStringLiteral(u"snowboarder_medium_skin_tone"),
        QStringLiteral(u"snowboarder: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C2\U0001F3FE"),
        QStringLiteral(u"snowboarder_medium_dark_skin_tone"),
        QStringLiteral(u"snowboarder: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C2\U0001F3FF"),
        QStringLiteral(u"snowboarder_dark_skin_tone"),
        QStringLiteral(u"snowboarder: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0000FE0F"),
        QStringLiteral(u"person_golfing"),
        QStringLiteral(u"person golfing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FB"),
        QStringLiteral(u"person_golfing_light_skin_tone"),
        QStringLiteral(u"person golfing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FC"),
        QStringLiteral(u"person_golfing_medium_light_skin_tone"),
        QStringLiteral(u"person golfing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FD"),
        QStringLiteral(u"person_golfing_medium_skin_tone"),
        QStringLiteral(u"person golfing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FE"),
        QStringLiteral(u"person_golfing_medium_dark_skin_tone"),
        QStringLiteral(u"person golfing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FF"),
        QStringLiteral(u"person_golfing_dark_skin_tone"),
        QStringLiteral(u"person golfing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0000FE0F\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_golfing"),
        QStringLiteral(u"man golfing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_golfing_light_skin_tone"),
        QStringLiteral(u"man golfing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_golfing_medium_light_skin_tone"),
        QStringLiteral(u"man golfing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_golfing_medium_skin_tone"),
        QStringLiteral(u"man golfing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_golfing_medium_dark_skin_tone"),
        QStringLiteral(u"man golfing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_golfing_dark_skin_tone"),
        QStringLiteral(u"man golfing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0000FE0F\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_golfing"),
        QStringLiteral(u"woman golfing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_golfing_light_skin_tone"),
        QStringLiteral(u"woman golfing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_golfing_medium_light_skin_tone"),
        QStringLiteral(u"woman golfing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_golfing_medium_skin_tone"),
        QStringLiteral(u"woman golfing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_golfing_medium_dark_skin_tone"),
        QStringLiteral(u"woman golfing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CC\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_golfing_dark_skin_tone"),
        QStringLiteral(u"woman golfing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4"),
        QStringLiteral(u"person_surfing"),
        QStringLiteral(u"person surfing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FB"),
        QStringLiteral(u"person_surfing_light_skin_tone"),
        QStringLiteral(u"person surfing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FC"),
        QStringLiteral(u"person_surfing_medium_light_skin_tone"),
        QStringLiteral(u"person surfing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FD"),
        QStringLiteral(u"person_surfing_medium_skin_tone"),
        QStringLiteral(u"person surfing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FE"),
        QStringLiteral(u"person_surfing_medium_dark_skin_tone"),
        QStringLiteral(u"person surfing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FF"),
        QStringLiteral(u"person_surfing_dark_skin_tone"),
        QStringLiteral(u"person surfing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_surfing"),
        QStringLiteral(u"man surfing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_surfing_light_skin_tone"),
        QStringLiteral(u"man surfing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_surfing_medium_light_skin_tone"),
        QStringLiteral(u"man surfing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_surfing_medium_skin_tone"),
        QStringLiteral(u"man surfing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_surfing_medium_dark_skin_tone"),
        QStringLiteral(u"man surfing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_surfing_dark_skin_tone"),
        QStringLiteral(u"man surfing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_surfing"),
        QStringLiteral(u"woman surfing"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_surfing_light_skin_tone"),
        QStringLiteral(u"woman surfing: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_surfing_medium_light_skin_tone"),
        QStringLiteral(u"woman surfing: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_surfing_medium_skin_tone"),
        QStringLiteral(u"woman surfing: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_surfing_medium_dark_skin_tone"),
        QStringLiteral(u"woman surfing: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3C4\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_surfing_dark_skin_tone"),
        QStringLiteral(u"woman surfing: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3"),
        QStringLiteral(u"person_rowing_boat"),
        QStringLiteral(u"person rowing boat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FB"),
        QStringLiteral(u"person_rowing_boat_light_skin_tone"),
        QStringLiteral(u"person rowing boat: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FC"),
        QStringLiteral(u"person_rowing_boat_medium_light_skin_tone"),
        QStringLiteral(u"person rowing boat: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FD"),
        QStringLiteral(u"person_rowing_boat_medium_skin_tone"),
        QStringLiteral(u"person rowing boat: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FE"),
        QStringLiteral(u"person_rowing_boat_medium_dark_skin_tone"),
        QStringLiteral(u"person rowing boat: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FF"),
        QStringLiteral(u"person_rowing_boat_dark_skin_tone"),
        QStringLiteral(u"person rowing boat: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_rowing_boat"),
        QStringLiteral(u"man rowing boat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_rowing_boat_light_skin_tone"),
        QStringLiteral(u"man rowing boat: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_rowing_boat_medium_light_skin_tone"),
        QStringLiteral(u"man rowing boat: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_rowing_boat_medium_skin_tone"),
        QStringLiteral(u"man rowing boat: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_rowing_boat_medium_dark_skin_tone"),
        QStringLiteral(u"man rowing boat: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_rowing_boat_dark_skin_tone"),
        QStringLiteral(u"man rowing boat: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_rowing_boat"),
        QStringLiteral(u"woman rowing boat"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_rowing_boat_light_skin_tone"),
        QStringLiteral(u"woman rowing boat: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_rowing_boat_medium_light_skin_tone"),
        QStringLiteral(u"woman rowing boat: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_rowing_boat_medium_skin_tone"),
        QStringLiteral(u"woman rowing boat: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_rowing_boat_medium_dark_skin_tone"),
        QStringLiteral(u"woman rowing boat: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6A3\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_rowing_boat_dark_skin_tone"),
        QStringLiteral(u"woman rowing boat: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA"),
        QStringLiteral(u"person_swimming"),
        QStringLiteral(u"person swimming"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FB"),
        QStringLiteral(u"person_swimming_light_skin_tone"),
        QStringLiteral(u"person swimming: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FC"),
        QStringLiteral(u"person_swimming_medium_light_skin_tone"),
        QStringLiteral(u"person swimming: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FD"),
        QStringLiteral(u"person_swimming_medium_skin_tone"),
        QStringLiteral(u"person swimming: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FE"),
        QStringLiteral(u"person_swimming_medium_dark_skin_tone"),
        QStringLiteral(u"person swimming: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FF"),
        QStringLiteral(u"person_swimming_dark_skin_tone"),
        QStringLiteral(u"person swimming: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_swimming"),
        QStringLiteral(u"man swimming"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_swimming_light_skin_tone"),
        QStringLiteral(u"man swimming: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_swimming_medium_light_skin_tone"),
        QStringLiteral(u"man swimming: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_swimming_medium_skin_tone"),
        QStringLiteral(u"man swimming: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_swimming_medium_dark_skin_tone"),
        QStringLiteral(u"man swimming: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_swimming_dark_skin_tone"),
        QStringLiteral(u"man swimming: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_swimming"),
        QStringLiteral(u"woman swimming"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_swimming_light_skin_tone"),
        QStringLiteral(u"woman swimming: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_swimming_medium_light_skin_tone"),
        QStringLiteral(u"woman swimming: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_swimming_medium_skin_tone"),
        QStringLiteral(u"woman swimming: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_swimming_medium_dark_skin_tone"),
        QStringLiteral(u"woman swimming: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CA\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_swimming_dark_skin_tone"),
        QStringLiteral(u"woman swimming: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0000FE0F"),
        QStringLiteral(u"person_bouncing_ball"),
        QStringLiteral(u"person bouncing ball"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FB"),
        QStringLiteral(u"person_bouncing_ball_light_skin_tone"),
        QStringLiteral(u"person bouncing ball: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FC"),
        QStringLiteral(u"person_bouncing_ball_medium_light_skin_tone"),
        QStringLiteral(u"person bouncing ball: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FD"),
        QStringLiteral(u"person_bouncing_ball_medium_skin_tone"),
        QStringLiteral(u"person bouncing ball: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FE"),
        QStringLiteral(u"person_bouncing_ball_medium_dark_skin_tone"),
        QStringLiteral(u"person bouncing ball: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FF"),
        QStringLiteral(u"person_bouncing_ball_dark_skin_tone"),
        QStringLiteral(u"person bouncing ball: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0000FE0F\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bouncing_ball"),
        QStringLiteral(u"man bouncing ball"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bouncing_ball_light_skin_tone"),
        QStringLiteral(u"man bouncing ball: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bouncing_ball_medium_light_skin_tone"),
        QStringLiteral(u"man bouncing ball: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bouncing_ball_medium_skin_tone"),
        QStringLiteral(u"man bouncing ball: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bouncing_ball_medium_dark_skin_tone"),
        QStringLiteral(u"man bouncing ball: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_bouncing_ball_dark_skin_tone"),
        QStringLiteral(u"man bouncing ball: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0000FE0F\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bouncing_ball"),
        QStringLiteral(u"woman bouncing ball"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bouncing_ball_light_skin_tone"),
        QStringLiteral(u"woman bouncing ball: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bouncing_ball_medium_light_skin_tone"),
        QStringLiteral(u"woman bouncing ball: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bouncing_ball_medium_skin_tone"),
        QStringLiteral(u"woman bouncing ball: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bouncing_ball_medium_dark_skin_tone"),
        QStringLiteral(u"woman bouncing ball: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U000026F9\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_bouncing_ball_dark_skin_tone"),
        QStringLiteral(u"woman bouncing ball: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0000FE0F"),
        QStringLiteral(u"person_lifting_weights"),
        QStringLiteral(u"person lifting weights"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FB"),
        QStringLiteral(u"person_lifting_weights_light_skin_tone"),
        QStringLiteral(u"person lifting weights: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FC"),
        QStringLiteral(u"person_lifting_weights_medium_light_skin_tone"),
        QStringLiteral(u"person lifting weights: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FD"),
        QStringLiteral(u"person_lifting_weights_medium_skin_tone"),
        QStringLiteral(u"person lifting weights: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FE"),
        QStringLiteral(u"person_lifting_weights_medium_dark_skin_tone"),
        QStringLiteral(u"person lifting weights: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FF"),
        QStringLiteral(u"person_lifting_weights_dark_skin_tone"),
        QStringLiteral(u"person lifting weights: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0000FE0F\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_lifting_weights"),
        QStringLiteral(u"man lifting weights"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_lifting_weights_light_skin_tone"),
        QStringLiteral(u"man lifting weights: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_lifting_weights_medium_light_skin_tone"),
        QStringLiteral(u"man lifting weights: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_lifting_weights_medium_skin_tone"),
        QStringLiteral(u"man lifting weights: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_lifting_weights_medium_dark_skin_tone"),
        QStringLiteral(u"man lifting weights: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_lifting_weights_dark_skin_tone"),
        QStringLiteral(u"man lifting weights: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0000FE0F\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_lifting_weights"),
        QStringLiteral(u"woman lifting weights"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_lifting_weights_light_skin_tone"),
        QStringLiteral(u"woman lifting weights: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_lifting_weights_medium_light_skin_tone"),
        QStringLiteral(u"woman lifting weights: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_lifting_weights_medium_skin_tone"),
        QStringLiteral(u"woman lifting weights: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_lifting_weights_medium_dark_skin_tone"),
        QStringLiteral(u"woman lifting weights: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F3CB\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_lifting_weights_dark_skin_tone"),
        QStringLiteral(u"woman lifting weights: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4"),
        QStringLiteral(u"person_biking"),
        QStringLiteral(u"person biking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FB"),
        QStringLiteral(u"person_biking_light_skin_tone"),
        QStringLiteral(u"person biking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FC"),
        QStringLiteral(u"person_biking_medium_light_skin_tone"),
        QStringLiteral(u"person biking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FD"),
        QStringLiteral(u"person_biking_medium_skin_tone"),
        QStringLiteral(u"person biking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FE"),
        QStringLiteral(u"person_biking_medium_dark_skin_tone"),
        QStringLiteral(u"person biking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FF"),
        QStringLiteral(u"person_biking_dark_skin_tone"),
        QStringLiteral(u"person biking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_biking"),
        QStringLiteral(u"man biking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_biking_light_skin_tone"),
        QStringLiteral(u"man biking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_biking_medium_light_skin_tone"),
        QStringLiteral(u"man biking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_biking_medium_skin_tone"),
        QStringLiteral(u"man biking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_biking_medium_dark_skin_tone"),
        QStringLiteral(u"man biking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_biking_dark_skin_tone"),
        QStringLiteral(u"man biking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_biking"),
        QStringLiteral(u"woman biking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_biking_light_skin_tone"),
        QStringLiteral(u"woman biking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_biking_medium_light_skin_tone"),
        QStringLiteral(u"woman biking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_biking_medium_skin_tone"),
        QStringLiteral(u"woman biking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_biking_medium_dark_skin_tone"),
        QStringLiteral(u"woman biking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B4\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_biking_dark_skin_tone"),
        QStringLiteral(u"woman biking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5"),
        QStringLiteral(u"person_mountain_biking"),
        QStringLiteral(u"person mountain biking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FB"),
        QStringLiteral(u"person_mountain_biking_light_skin_tone"),
        QStringLiteral(u"person mountain biking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FC"),
        QStringLiteral(u"person_mountain_biking_medium_light_skin_tone"),
        QStringLiteral(u"person mountain biking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FD"),
        QStringLiteral(u"person_mountain_biking_medium_skin_tone"),
        QStringLiteral(u"person mountain biking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FE"),
        QStringLiteral(u"person_mountain_biking_medium_dark_skin_tone"),
        QStringLiteral(u"person mountain biking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FF"),
        QStringLiteral(u"person_mountain_biking_dark_skin_tone"),
        QStringLiteral(u"person mountain biking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mountain_biking"),
        QStringLiteral(u"man mountain biking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mountain_biking_light_skin_tone"),
        QStringLiteral(u"man mountain biking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mountain_biking_medium_light_skin_tone"),
        QStringLiteral(u"man mountain biking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mountain_biking_medium_skin_tone"),
        QStringLiteral(u"man mountain biking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mountain_biking_medium_dark_skin_tone"),
        QStringLiteral(u"man mountain biking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_mountain_biking_dark_skin_tone"),
        QStringLiteral(u"man mountain biking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mountain_biking"),
        QStringLiteral(u"woman mountain biking"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mountain_biking_light_skin_tone"),
        QStringLiteral(u"woman mountain biking: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mountain_biking_medium_light_skin_tone"),
        QStringLiteral(u"woman mountain biking: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mountain_biking_medium_skin_tone"),
        QStringLiteral(u"woman mountain biking: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mountain_biking_medium_dark_skin_tone"),
        QStringLiteral(u"woman mountain biking: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6B5\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_mountain_biking_dark_skin_tone"),
        QStringLiteral(u"woman mountain biking: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938"),
        QStringLiteral(u"person_cartwheeling"),
        QStringLiteral(u"person cartwheeling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FB"),
        QStringLiteral(u"person_cartwheeling_light_skin_tone"),
        QStringLiteral(u"person cartwheeling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FC"),
        QStringLiteral(u"person_cartwheeling_medium_light_skin_tone"),
        QStringLiteral(u"person cartwheeling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FD"),
        QStringLiteral(u"person_cartwheeling_medium_skin_tone"),
        QStringLiteral(u"person cartwheeling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FE"),
        QStringLiteral(u"person_cartwheeling_medium_dark_skin_tone"),
        QStringLiteral(u"person cartwheeling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FF"),
        QStringLiteral(u"person_cartwheeling_dark_skin_tone"),
        QStringLiteral(u"person cartwheeling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_cartwheeling"),
        QStringLiteral(u"man cartwheeling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_cartwheeling_light_skin_tone"),
        QStringLiteral(u"man cartwheeling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_cartwheeling_medium_light_skin_tone"),
        QStringLiteral(u"man cartwheeling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_cartwheeling_medium_skin_tone"),
        QStringLiteral(u"man cartwheeling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_cartwheeling_medium_dark_skin_tone"),
        QStringLiteral(u"man cartwheeling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_cartwheeling_dark_skin_tone"),
        QStringLiteral(u"man cartwheeling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_cartwheeling"),
        QStringLiteral(u"woman cartwheeling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_cartwheeling_light_skin_tone"),
        QStringLiteral(u"woman cartwheeling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_cartwheeling_medium_light_skin_tone"),
        QStringLiteral(u"woman cartwheeling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_cartwheeling_medium_skin_tone"),
        QStringLiteral(u"woman cartwheeling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_cartwheeling_medium_dark_skin_tone"),
        QStringLiteral(u"woman cartwheeling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F938\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_cartwheeling_dark_skin_tone"),
        QStringLiteral(u"woman cartwheeling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93C"),
        QStringLiteral(u"people_wrestling"),
        QStringLiteral(u"people wrestling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93C\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"men_wrestling"),
        QStringLiteral(u"men wrestling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93C\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"women_wrestling"),
        QStringLiteral(u"women wrestling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D"),
        QStringLiteral(u"person_playing_water_polo"),
        QStringLiteral(u"person playing water polo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FB"),
        QStringLiteral(u"person_playing_water_polo_light_skin_tone"),
        QStringLiteral(u"person playing water polo: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FC"),
        QStringLiteral(u"person_playing_water_polo_medium_light_skin_tone"),
        QStringLiteral(u"person playing water polo: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FD"),
        QStringLiteral(u"person_playing_water_polo_medium_skin_tone"),
        QStringLiteral(u"person playing water polo: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FE"),
        QStringLiteral(u"person_playing_water_polo_medium_dark_skin_tone"),
        QStringLiteral(u"person playing water polo: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FF"),
        QStringLiteral(u"person_playing_water_polo_dark_skin_tone"),
        QStringLiteral(u"person playing water polo: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_water_polo"),
        QStringLiteral(u"man playing water polo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_water_polo_light_skin_tone"),
        QStringLiteral(u"man playing water polo: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_water_polo_medium_light_skin_tone"),
        QStringLiteral(u"man playing water polo: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_water_polo_medium_skin_tone"),
        QStringLiteral(u"man playing water polo: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_water_polo_medium_dark_skin_tone"),
        QStringLiteral(u"man playing water polo: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_water_polo_dark_skin_tone"),
        QStringLiteral(u"man playing water polo: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_water_polo"),
        QStringLiteral(u"woman playing water polo"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_water_polo_light_skin_tone"),
        QStringLiteral(u"woman playing water polo: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_water_polo_medium_light_skin_tone"),
        QStringLiteral(u"woman playing water polo: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_water_polo_medium_skin_tone"),
        QStringLiteral(u"woman playing water polo: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_water_polo_medium_dark_skin_tone"),
        QStringLiteral(u"woman playing water polo: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93D\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_water_polo_dark_skin_tone"),
        QStringLiteral(u"woman playing water polo: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E"),
        QStringLiteral(u"person_playing_handball"),
        QStringLiteral(u"person playing handball"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FB"),
        QStringLiteral(u"person_playing_handball_light_skin_tone"),
        QStringLiteral(u"person playing handball: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FC"),
        QStringLiteral(u"person_playing_handball_medium_light_skin_tone"),
        QStringLiteral(u"person playing handball: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FD"),
        QStringLiteral(u"person_playing_handball_medium_skin_tone"),
        QStringLiteral(u"person playing handball: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FE"),
        QStringLiteral(u"person_playing_handball_medium_dark_skin_tone"),
        QStringLiteral(u"person playing handball: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FF"),
        QStringLiteral(u"person_playing_handball_dark_skin_tone"),
        QStringLiteral(u"person playing handball: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_handball"),
        QStringLiteral(u"man playing handball"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_handball_light_skin_tone"),
        QStringLiteral(u"man playing handball: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_handball_medium_light_skin_tone"),
        QStringLiteral(u"man playing handball: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_handball_medium_skin_tone"),
        QStringLiteral(u"man playing handball: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_handball_medium_dark_skin_tone"),
        QStringLiteral(u"man playing handball: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_playing_handball_dark_skin_tone"),
        QStringLiteral(u"man playing handball: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_handball"),
        QStringLiteral(u"woman playing handball"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_handball_light_skin_tone"),
        QStringLiteral(u"woman playing handball: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_handball_medium_light_skin_tone"),
        QStringLiteral(u"woman playing handball: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_handball_medium_skin_tone"),
        QStringLiteral(u"woman playing handball: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_handball_medium_dark_skin_tone"),
        QStringLiteral(u"woman playing handball: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F93E\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_playing_handball_dark_skin_tone"),
        QStringLiteral(u"woman playing handball: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939"),
        QStringLiteral(u"person_juggling"),
        QStringLiteral(u"person juggling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FB"),
        QStringLiteral(u"person_juggling_light_skin_tone"),
        QStringLiteral(u"person juggling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FC"),
        QStringLiteral(u"person_juggling_medium_light_skin_tone"),
        QStringLiteral(u"person juggling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FD"),
        QStringLiteral(u"person_juggling_medium_skin_tone"),
        QStringLiteral(u"person juggling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FE"),
        QStringLiteral(u"person_juggling_medium_dark_skin_tone"),
        QStringLiteral(u"person juggling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FF"),
        QStringLiteral(u"person_juggling_dark_skin_tone"),
        QStringLiteral(u"person juggling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_juggling"),
        QStringLiteral(u"man juggling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_juggling_light_skin_tone"),
        QStringLiteral(u"man juggling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_juggling_medium_light_skin_tone"),
        QStringLiteral(u"man juggling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_juggling_medium_skin_tone"),
        QStringLiteral(u"man juggling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_juggling_medium_dark_skin_tone"),
        QStringLiteral(u"man juggling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_juggling_dark_skin_tone"),
        QStringLiteral(u"man juggling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_juggling"),
        QStringLiteral(u"woman juggling"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_juggling_light_skin_tone"),
        QStringLiteral(u"woman juggling: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_juggling_medium_light_skin_tone"),
        QStringLiteral(u"woman juggling: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_juggling_medium_skin_tone"),
        QStringLiteral(u"woman juggling: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_juggling_medium_dark_skin_tone"),
        QStringLiteral(u"woman juggling: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F939\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_juggling_dark_skin_tone"),
        QStringLiteral(u"woman juggling: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8"),
        QStringLiteral(u"person_in_lotus_position"),
        QStringLiteral(u"person in lotus position"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FB"),
        QStringLiteral(u"person_in_lotus_position_light_skin_tone"),
        QStringLiteral(u"person in lotus position: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FC"),
        QStringLiteral(u"person_in_lotus_position_medium_light_skin_tone"),
        QStringLiteral(u"person in lotus position: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FD"),
        QStringLiteral(u"person_in_lotus_position_medium_skin_tone"),
        QStringLiteral(u"person in lotus position: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FE"),
        QStringLiteral(u"person_in_lotus_position_medium_dark_skin_tone"),
        QStringLiteral(u"person in lotus position: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FF"),
        QStringLiteral(u"person_in_lotus_position_dark_skin_tone"),
        QStringLiteral(u"person in lotus position: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_lotus_position"),
        QStringLiteral(u"man in lotus position"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FB\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_lotus_position_light_skin_tone"),
        QStringLiteral(u"man in lotus position: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FC\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_lotus_position_medium_light_skin_tone"),
        QStringLiteral(u"man in lotus position: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FD\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_lotus_position_medium_skin_tone"),
        QStringLiteral(u"man in lotus position: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FE\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_lotus_position_medium_dark_skin_tone"),
        QStringLiteral(u"man in lotus position: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FF\U0000200D\U00002642\U0000FE0F"),
        QStringLiteral(u"man_in_lotus_position_dark_skin_tone"),
        QStringLiteral(u"man in lotus position: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_lotus_position"),
        QStringLiteral(u"woman in lotus position"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FB\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_lotus_position_light_skin_tone"),
        QStringLiteral(u"woman in lotus position: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FC\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_lotus_position_medium_light_skin_tone"),
        QStringLiteral(u"woman in lotus position: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FD\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_lotus_position_medium_skin_tone"),
        QStringLiteral(u"woman in lotus position: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FE\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_lotus_position_medium_dark_skin_tone"),
        QStringLiteral(u"woman in lotus position: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D8\U0001F3FF\U0000200D\U00002640\U0000FE0F"),
        QStringLiteral(u"woman_in_lotus_position_dark_skin_tone"),
        QStringLiteral(u"woman in lotus position: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6C0"),
        QStringLiteral(u"person_taking_bath"),
        QStringLiteral(u"person taking bath"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6C0\U0001F3FB"),
        QStringLiteral(u"person_taking_bath_light_skin_tone"),
        QStringLiteral(u"person taking bath: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6C0\U0001F3FC"),
        QStringLiteral(u"person_taking_bath_medium_light_skin_tone"),
        QStringLiteral(u"person taking bath: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6C0\U0001F3FD"),
        QStringLiteral(u"person_taking_bath_medium_skin_tone"),
        QStringLiteral(u"person taking bath: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6C0\U0001F3FE"),
        QStringLiteral(u"person_taking_bath_medium_dark_skin_tone"),
        QStringLiteral(u"person taking bath: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6C0\U0001F3FF"),
        QStringLiteral(u"person_taking_bath_dark_skin_tone"),
        QStringLiteral(u"person taking bath: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6CC"),
        QStringLiteral(u"person_in_bed"),
        QStringLiteral(u"person in bed"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6CC\U0001F3FB"),
        QStringLiteral(u"person_in_bed_light_skin_tone"),
        QStringLiteral(u"person in bed: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6CC\U0001F3FC"),
        QStringLiteral(u"person_in_bed_medium_light_skin_tone"),
        QStringLiteral(u"person in bed: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6CC\U0001F3FD"),
        QStringLiteral(u"person_in_bed_medium_skin_tone"),
        QStringLiteral(u"person in bed: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6CC\U0001F3FE"),
        QStringLiteral(u"person_in_bed_medium_dark_skin_tone"),
        QStringLiteral(u"person in bed: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F6CC\U0001F3FF"),
        QStringLiteral(u"person_in_bed_dark_skin_tone"),
        QStringLiteral(u"person in bed: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0000200D\U0001F91D\U0000200D\U0001F9D1"),
        QStringLiteral(u"people_holding_hands"),
        QStringLiteral(u"people holding hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"people_holding_hands_light_skin_tone"),
        QStringLiteral(u"people holding hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"people_holding_hands_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"people holding hands: light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"people_holding_hands_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"people holding hands: light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"people_holding_hands_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"people holding hands: light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"people_holding_hands_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"people holding hands: light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"people_holding_hands_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"people holding hands: medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"people_holding_hands_medium_light_skin_tone"),
        QStringLiteral(u"people holding hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"people_holding_hands_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"people holding hands: medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"people_holding_hands_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"people holding hands: medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"people_holding_hands_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"people holding hands: medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"people_holding_hands_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"people holding hands: medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"people_holding_hands_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"people holding hands: medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"people_holding_hands_medium_skin_tone"),
        QStringLiteral(u"people holding hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"people_holding_hands_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"people holding hands: medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"people_holding_hands_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"people holding hands: medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"people_holding_hands_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"people holding hands: medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"people_holding_hands_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"people holding hands: medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"people_holding_hands_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"people holding hands: medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"people_holding_hands_medium_dark_skin_tone"),
        QStringLiteral(u"people holding hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"people_holding_hands_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"people holding hands: medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"people_holding_hands_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"people holding hands: dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"people_holding_hands_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"people holding hands: dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"people_holding_hands_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"people holding hands: dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"people_holding_hands_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"people holding hands: dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"people_holding_hands_dark_skin_tone"),
        QStringLiteral(u"people holding hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46D"),
        QStringLiteral(u"women_holding_hands"),
        QStringLiteral(u"women holding hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46D\U0001F3FB"),
        QStringLiteral(u"women_holding_hands_light_skin_tone"),
        QStringLiteral(u"women holding hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"women_holding_hands_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"women holding hands: light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"women_holding_hands_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"women holding hands: light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"women_holding_hands_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"women holding hands: light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"women_holding_hands_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"women holding hands: light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"women_holding_hands_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"women holding hands: medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46D\U0001F3FC"),
        QStringLiteral(u"women_holding_hands_medium_light_skin_tone"),
        QStringLiteral(u"women holding hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"women_holding_hands_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"women holding hands: medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"women_holding_hands_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"women holding hands: medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"women_holding_hands_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"women holding hands: medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"women_holding_hands_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"women holding hands: medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"women_holding_hands_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"women holding hands: medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46D\U0001F3FD"),
        QStringLiteral(u"women_holding_hands_medium_skin_tone"),
        QStringLiteral(u"women holding hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"women_holding_hands_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"women holding hands: medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"women_holding_hands_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"women holding hands: medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"women_holding_hands_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"women holding hands: medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"women_holding_hands_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"women holding hands: medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"women_holding_hands_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"women holding hands: medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46D\U0001F3FE"),
        QStringLiteral(u"women_holding_hands_medium_dark_skin_tone"),
        QStringLiteral(u"women holding hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"women_holding_hands_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"women holding hands: medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"women_holding_hands_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"women holding hands: dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"women_holding_hands_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"women holding hands: dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"women_holding_hands_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"women holding hands: dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"women_holding_hands_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"women holding hands: dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46D\U0001F3FF"),
        QStringLiteral(u"women_holding_hands_dark_skin_tone"),
        QStringLiteral(u"women holding hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46B"),
        QStringLiteral(u"woman_and_man_holding_hands"),
        QStringLiteral(u"woman and man holding hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46B\U0001F3FB"),
        QStringLiteral(u"woman_and_man_holding_hands_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"woman_and_man_holding_hands_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"woman_and_man_holding_hands_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"woman and man holding hands: light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"woman_and_man_holding_hands_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"woman_and_man_holding_hands_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46B\U0001F3FC"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
    QStringLiteral(u"woman_and_man_holding_hands_medium_light_skin_tone_medium_dark_skin_tone"),
    QStringLiteral(u"woman and man holding hands: medium-light skin tone, medium-dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46B\U0001F3FD"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
    QStringLiteral(u"woman_and_man_holding_hands_medium_dark_skin_tone_medium_light_skin_tone"),
    QStringLiteral(u"woman and man holding hands: medium-dark skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46B\U0001F3FE"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"woman_and_man_holding_hands_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"woman_and_man_holding_hands_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"woman_and_man_holding_hands_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"woman and man holding hands: dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"woman_and_man_holding_hands_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"woman and man holding hands: dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"woman_and_man_holding_hands_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46B\U0001F3FF"),
        QStringLiteral(u"woman_and_man_holding_hands_dark_skin_tone"),
        QStringLiteral(u"woman and man holding hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46C"),
        QStringLiteral(u"men_holding_hands"),
        QStringLiteral(u"men holding hands"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46C\U0001F3FB"),
        QStringLiteral(u"men_holding_hands_light_skin_tone"),
        QStringLiteral(u"men holding hands: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"men_holding_hands_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"men holding hands: light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"men_holding_hands_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"men holding hands: light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"men_holding_hands_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"men holding hands: light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"men_holding_hands_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"men holding hands: light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"men_holding_hands_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"men holding hands: medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46C\U0001F3FC"),
        QStringLiteral(u"men_holding_hands_medium_light_skin_tone"),
        QStringLiteral(u"men holding hands: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"men_holding_hands_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"men holding hands: medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"men_holding_hands_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"men holding hands: medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"men_holding_hands_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"men holding hands: medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"men_holding_hands_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"men holding hands: medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"men_holding_hands_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"men holding hands: medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46C\U0001F3FD"),
        QStringLiteral(u"men_holding_hands_medium_skin_tone"),
        QStringLiteral(u"men holding hands: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"men_holding_hands_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"men holding hands: medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"men_holding_hands_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"men holding hands: medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"men_holding_hands_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"men holding hands: medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"men_holding_hands_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"men holding hands: medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"men_holding_hands_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"men holding hands: medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46C\U0001F3FE"),
        QStringLiteral(u"men_holding_hands_medium_dark_skin_tone"),
        QStringLiteral(u"men holding hands: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"men_holding_hands_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"men holding hands: medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"men_holding_hands_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"men holding hands: dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"men_holding_hands_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"men holding hands: dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"men_holding_hands_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"men holding hands: dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U0001F91D\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"men_holding_hands_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"men holding hands: dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46C\U0001F3FF"),
        QStringLiteral(u"men_holding_hands_dark_skin_tone"),
        QStringLiteral(u"men holding hands: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48F"),
        QStringLiteral(u"kiss"),
        QStringLiteral(u"kiss"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48F\U0001F3FB"),
        QStringLiteral(u"kiss_light_skin_tone"),
        QStringLiteral(u"kiss: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48F\U0001F3FC"),
        QStringLiteral(u"kiss_medium_light_skin_tone"),
        QStringLiteral(u"kiss: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48F\U0001F3FD"),
        QStringLiteral(u"kiss_medium_skin_tone"),
        QStringLiteral(u"kiss: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48F\U0001F3FE"),
        QStringLiteral(u"kiss_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F48F\U0001F3FF"),
        QStringLiteral(u"kiss_dark_skin_tone"),
        QStringLiteral(u"kiss: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"kiss_person_person_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"kiss_person_person_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: person, person, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"kiss_person_person_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"kiss_person_person_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"kiss_person_person_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"kiss_person_person_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"kiss_person_person_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"kiss_person_person_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"kiss_person_person_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"kiss_person_person_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"kiss_person_person_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"kiss_person_person_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"kiss_person_person_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"kiss_person_person_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"kiss_person_person_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"kiss_person_person_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"kiss_person_person_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FC"),
        QStringLiteral(u"kiss_person_person_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: person, person, dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"kiss_person_person_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: person, person, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"kiss_person_person_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: person, person, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B\U0000200D\U0001F468"),
        QStringLiteral(u"kiss_woman_man"),
        QStringLiteral(u"kiss: woman, man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_woman_man_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_woman_man_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_woman_man_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, man, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_woman_man_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_woman_man_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_woman_man_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_woman_man_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_woman_man_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_woman_man_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_woman_man_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_woman_man_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_woman_man_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_woman_man_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_woman_man_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_woman_man_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_woman_man_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_woman_man_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_woman_man_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_woman_man_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_woman_man_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_woman_man_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_woman_man_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, man, dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_woman_man_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, man, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_woman_man_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_woman_man_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, man, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B\U0000200D\U0001F468"),
        QStringLiteral(u"kiss_man_man"),
        QStringLiteral(u"kiss: man, man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_man_man_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_man_man_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_man_man_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: man, man, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_man_man_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_man_man_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_man_man_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_man_man_medium_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_man_man_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_man_man_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_man_man_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_man_man_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_man_man_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_man_man_medium_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_man_man_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_man_man_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_man_man_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_man_man_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_man_man_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_man_man_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_man_man_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"kiss_man_man_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"kiss_man_man_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: man, man, dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"kiss_man_man_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: man, man, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"kiss_man_man_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"kiss_man_man_dark_skin_tone"),
        QStringLiteral(u"kiss: man, man, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B\U0000200D\U0001F469"),
        QStringLiteral(u"kiss_woman_woman"),
        QStringLiteral(u"kiss: woman, woman"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"kiss_woman_woman_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"kiss_woman_woman_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"kiss_woman_woman_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"kiss_woman_woman_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"kiss_woman_woman_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"kiss_woman_woman_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"kiss_woman_woman_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"kiss_woman_woman_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"kiss_woman_woman_medium_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"kiss_woman_woman_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"kiss_woman_woman_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"kiss_woman_woman_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"kiss_woman_woman_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"kiss_woman_woman_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"kiss_woman_woman_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"kiss_woman_woman_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"kiss_woman_woman_medium_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"kiss_woman_woman_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"kiss_woman_woman_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"kiss_woman_woman_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"kiss_woman_woman_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"kiss_woman_woman_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"kiss_woman_woman_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"kiss_woman_woman_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F48B"
                       u"\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"kiss_woman_woman_dark_skin_tone"),
        QStringLiteral(u"kiss: woman, woman, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F491"),
        QStringLiteral(u"couple_with_heart"),
        QStringLiteral(u"couple with heart"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F491\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_light_skin_tone"),
        QStringLiteral(u"couple with heart: light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F491\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F491\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_medium_skin_tone"),
        QStringLiteral(u"couple with heart: medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F491\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F491\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_dark_skin_tone"),
        QStringLiteral(u"couple with heart: dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_person_person_light_skin_tone_medium_light_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, light skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_person_person_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FE"),
    QStringLiteral(u"couple_with_heart_person_person_light_skin_tone_medium_dark_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, light skin tone, medium-dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_person_person_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FB"),
    QStringLiteral(u"couple_with_heart_person_person_medium_light_skin_tone_light_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, medium-light skin tone, light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FD"),
    QStringLiteral(u"couple_with_heart_person_person_medium_light_skin_tone_medium_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, medium-light skin tone, medium skin tone"),
    emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FE"),
    QStringLiteral(u"couple_with_heart_person_person_medium_light_skin_tone_medium_dark_skin_tone"),
    QStringLiteral(
      u"couple with heart: person, person, medium-light skin tone, medium-dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FF"),
    QStringLiteral(u"couple_with_heart_person_person_medium_light_skin_tone_dark_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, medium-light skin tone, dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_person_person_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_person_person_medium_skin_tone_medium_light_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, medium skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FE"),
    QStringLiteral(u"couple_with_heart_person_person_medium_skin_tone_medium_dark_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, medium skin tone, medium-dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_person_person_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FB"),
    QStringLiteral(u"couple_with_heart_person_person_medium_dark_skin_tone_light_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, medium-dark skin tone, light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_person_person_medium_dark_skin_tone_medium_light_skin_tone"),
    QStringLiteral(
      u"couple with heart: person, person, medium-dark skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FD"),
    QStringLiteral(u"couple_with_heart_person_person_medium_dark_skin_tone_medium_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, medium-dark skin tone, medium skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_person_person_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_person_person_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_person_person_dark_skin_tone_medium_light_skin_tone"),
    QStringLiteral(u"couple with heart: person, person, dark skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_person_person_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F9D1\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F9D1\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_person_person_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: person, person, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468"),
        QStringLiteral(u"couple_with_heart_woman_man"),
        QStringLiteral(u"couple with heart: woman, man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_man_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_woman_man_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_man_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_man_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_man_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
    QStringLiteral(u"couple_with_heart_woman_man_medium_light_skin_tone_medium_dark_skin_tone"),
    QStringLiteral(u"couple with heart: woman, man, medium-light skin tone, medium-dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_woman_man_medium_dark_skin_tone_medium_light_skin_tone"),
    QStringLiteral(u"couple with heart: woman, man, medium-dark skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_man_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_man_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_woman_man_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_man_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_man_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_man_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, man, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468"),
        QStringLiteral(u"couple_with_heart_man_man"),
        QStringLiteral(u"couple with heart: man, man"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_man_man_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_man_man_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_man_man_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_man_man_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_man_man_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_man_man_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_man_man_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_man_man_medium_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
    QStringLiteral(u"couple_with_heart_man_man_medium_light_skin_tone_medium_dark_skin_tone"),
    QStringLiteral(u"couple with heart: man, man, medium-light skin tone, medium-dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_man_man_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_man_man_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_man_man_medium_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_man_man_medium_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_man_man_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_man_man_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_man_man_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_man_man_medium_dark_skin_tone_medium_light_skin_tone"),
    QStringLiteral(u"couple with heart: man, man, medium-dark skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_man_man_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_man_man_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_man_man_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_man_man_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_man_man_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_man_man_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_man_man_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F468\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F468\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_man_man_dark_skin_tone"),
        QStringLiteral(u"couple with heart: man, man, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469"),
        QStringLiteral(u"couple_with_heart_woman_woman"),
        QStringLiteral(u"couple with heart: woman, woman"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_woman_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_woman_woman_light_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, light skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_woman_light_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, light skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_woman_light_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, light skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FB\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_woman_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_light_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium-light skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FD"),
    QStringLiteral(u"couple_with_heart_woman_woman_medium_light_skin_tone_medium_skin_tone"),
    QStringLiteral(u"couple with heart: woman, woman, medium-light skin tone, medium skin tone"),
    emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FE"),
    QStringLiteral(u"couple_with_heart_woman_woman_medium_light_skin_tone_medium_dark_skin_tone"),
    QStringLiteral(
      u"couple with heart: woman, woman, medium-light skin tone, medium-dark skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FC\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_light_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium-light skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_woman_woman_medium_skin_tone_medium_light_skin_tone"),
    QStringLiteral(u"couple with heart: woman, woman, medium skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FD\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium-dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{
    QStringLiteral(
      u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FC"),
    QStringLiteral(u"couple_with_heart_woman_woman_medium_dark_skin_tone_medium_light_skin_tone"),
    QStringLiteral(
      u"couple with heart: woman, woman, medium-dark skin tone, medium-light skin tone"),
    emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium-dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FE\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_woman_medium_dark_skin_tone_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, medium-dark skin tone, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FB"),
        QStringLiteral(u"couple_with_heart_woman_woman_dark_skin_tone_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, dark skin tone, light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FC"),
        QStringLiteral(u"couple_with_heart_woman_woman_dark_skin_tone_medium_light_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, dark skin tone, medium-light skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FD"),
        QStringLiteral(u"couple_with_heart_woman_woman_dark_skin_tone_medium_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, dark skin tone, medium skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FE"),
        QStringLiteral(u"couple_with_heart_woman_woman_dark_skin_tone_medium_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, dark skin tone, medium-dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(
          u"\U0001F469\U0001F3FF\U0000200D\U00002764\U0000FE0F\U0000200D\U0001F469\U0001F3FF"),
        QStringLiteral(u"couple_with_heart_woman_woman_dark_skin_tone"),
        QStringLiteral(u"couple with heart: woman, woman, dark skin tone"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F46A"),
        QStringLiteral(u"family"),
        QStringLiteral(u"family"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F469\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_woman_boy"),
        QStringLiteral(u"family: man, woman, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F469\U0000200D\U0001F467"),
        QStringLiteral(u"family_man_woman_girl"),
        QStringLiteral(u"family: man, woman, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_woman_girl_boy"),
        QStringLiteral(u"family: man, woman, girl, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F469\U0000200D\U0001F466\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_woman_boy_boy"),
        QStringLiteral(u"family: man, woman, boy, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F467"),
        QStringLiteral(u"family_man_woman_girl_girl"),
        QStringLiteral(u"family: man, woman, girl, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F468\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_man_boy"),
        QStringLiteral(u"family: man, man, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F468\U0000200D\U0001F467"),
        QStringLiteral(u"family_man_man_girl"),
        QStringLiteral(u"family: man, man, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F468\U0000200D\U0001F467\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_man_girl_boy"),
        QStringLiteral(u"family: man, man, girl, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F468\U0000200D\U0001F466\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_man_boy_boy"),
        QStringLiteral(u"family: man, man, boy, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F468\U0000200D\U0001F467\U0000200D\U0001F467"),
        QStringLiteral(u"family_man_man_girl_girl"),
        QStringLiteral(u"family: man, man, girl, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F469\U0000200D\U0001F466"),
        QStringLiteral(u"family_woman_woman_boy"),
        QStringLiteral(u"family: woman, woman, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F469\U0000200D\U0001F467"),
        QStringLiteral(u"family_woman_woman_girl"),
        QStringLiteral(u"family: woman, woman, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F466"),
        QStringLiteral(u"family_woman_woman_girl_boy"),
        QStringLiteral(u"family: woman, woman, girl, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F469\U0000200D\U0001F466\U0000200D\U0001F466"),
        QStringLiteral(u"family_woman_woman_boy_boy"),
        QStringLiteral(u"family: woman, woman, boy, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F469\U0000200D\U0001F467\U0000200D\U0001F467"),
        QStringLiteral(u"family_woman_woman_girl_girl"),
        QStringLiteral(u"family: woman, woman, girl, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_boy"),
        QStringLiteral(u"family: man, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F466\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_boy_boy"),
        QStringLiteral(u"family: man, boy, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F467"),
        QStringLiteral(u"family_man_girl"),
        QStringLiteral(u"family: man, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F467\U0000200D\U0001F466"),
        QStringLiteral(u"family_man_girl_boy"),
        QStringLiteral(u"family: man, girl, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F468\U0000200D\U0001F467\U0000200D\U0001F467"),
        QStringLiteral(u"family_man_girl_girl"),
        QStringLiteral(u"family: man, girl, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F466"),
        QStringLiteral(u"family_woman_boy"),
        QStringLiteral(u"family: woman, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F466\U0000200D\U0001F466"),
        QStringLiteral(u"family_woman_boy_boy"),
        QStringLiteral(u"family: woman, boy, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F467"),
        QStringLiteral(u"family_woman_girl"),
        QStringLiteral(u"family: woman, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F467\U0000200D\U0001F466"),
        QStringLiteral(u"family_woman_girl_boy"),
        QStringLiteral(u"family: woman, girl, boy"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F469\U0000200D\U0001F467\U0000200D\U0001F467"),
        QStringLiteral(u"family_woman_girl_girl"),
        QStringLiteral(u"family: woman, girl, girl"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F5E3\U0000FE0F"),
        QStringLiteral(u"speaking_head"),
        QStringLiteral(u"speaking head"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F464"),
        QStringLiteral(u"bust_in_silhouette"),
        QStringLiteral(u"bust in silhouette"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F465"),
        QStringLiteral(u"busts_in_silhouette"),
        QStringLiteral(u"busts in silhouette"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001FAC2"),
        QStringLiteral(u"people_hugging"),
        QStringLiteral(u"people hugging"),
        emoji::Emoji::Category::People},
  Emoji{QStringLiteral(u"\U0001F463"),
        QStringLiteral(u"footprints"),
        QStringLiteral(u"footprints"),
        emoji::Emoji::Category::People},
  // Nature
  Emoji{QStringLiteral(u"\U0001F435"),
        QStringLiteral(u"monkey"),
        QStringLiteral(u"monkey face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F412"),
        QStringLiteral(u"monkey"),
        QStringLiteral(u"monkey"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F98D"),
        QStringLiteral(u"gorilla"),
        QStringLiteral(u"gorilla"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A7"),
        QStringLiteral(u"orangutan"),
        QStringLiteral(u"orangutan"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F436"),
        QStringLiteral(u"dog"),
        QStringLiteral(u"dog face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F415"),
        QStringLiteral(u"dog"),
        QStringLiteral(u"dog"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9AE"),
        QStringLiteral(u"guide_dog"),
        QStringLiteral(u"guide dog"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F415\U0000200D\U0001F9BA"),
        QStringLiteral(u"service_dog"),
        QStringLiteral(u"service dog"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F429"),
        QStringLiteral(u"poodle"),
        QStringLiteral(u"poodle"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F43A"),
        QStringLiteral(u"wolf"),
        QStringLiteral(u"wolf"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F98A"),
        QStringLiteral(u"fox"),
        QStringLiteral(u"fox"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F99D"),
        QStringLiteral(u"raccoon"),
        QStringLiteral(u"raccoon"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F431"),
        QStringLiteral(u"cat"),
        QStringLiteral(u"cat face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F408"),
        QStringLiteral(u"cat"),
        QStringLiteral(u"cat"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F408\U0000200D\U00002B1B"),
        QStringLiteral(u"black_cat"),
        QStringLiteral(u"black cat"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F981"),
        QStringLiteral(u"lion"),
        QStringLiteral(u"lion"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F42F"),
        QStringLiteral(u"tiger"),
        QStringLiteral(u"tiger face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F405"),
        QStringLiteral(u"tiger"),
        QStringLiteral(u"tiger"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F406"),
        QStringLiteral(u"leopard"),
        QStringLiteral(u"leopard"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F434"),
        QStringLiteral(u"horse"),
        QStringLiteral(u"horse face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FACE"),
        QStringLiteral(u"moose"),
        QStringLiteral(u"moose"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FACF"),
        QStringLiteral(u"donkey"),
        QStringLiteral(u"donkey"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F40E"),
        QStringLiteral(u"horse"),
        QStringLiteral(u"horse"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F984"),
        QStringLiteral(u"unicorn"),
        QStringLiteral(u"unicorn"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F993"),
        QStringLiteral(u"zebra"),
        QStringLiteral(u"zebra"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F98C"),
        QStringLiteral(u"deer"),
        QStringLiteral(u"deer"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9AC"),
        QStringLiteral(u"bison"),
        QStringLiteral(u"bison"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F42E"),
        QStringLiteral(u"cow"),
        QStringLiteral(u"cow face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F402"),
        QStringLiteral(u"ox"),
        QStringLiteral(u"ox"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F403"),
        QStringLiteral(u"water_buffalo"),
        QStringLiteral(u"water buffalo"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F404"),
        QStringLiteral(u"cow"),
        QStringLiteral(u"cow"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F437"),
        QStringLiteral(u"pig"),
        QStringLiteral(u"pig face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F416"),
        QStringLiteral(u"pig"),
        QStringLiteral(u"pig"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F417"),
        QStringLiteral(u"boar"),
        QStringLiteral(u"boar"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F43D"),
        QStringLiteral(u"pig_nose"),
        QStringLiteral(u"pig nose"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F40F"),
        QStringLiteral(u"ram"),
        QStringLiteral(u"ram"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F411"),
        QStringLiteral(u"ewe"),
        QStringLiteral(u"ewe"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F410"),
        QStringLiteral(u"goat"),
        QStringLiteral(u"goat"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F42A"),
        QStringLiteral(u"camel"),
        QStringLiteral(u"camel"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F42B"),
        QStringLiteral(u"two_hump_camel"),
        QStringLiteral(u"two-hump camel"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F999"),
        QStringLiteral(u"llama"),
        QStringLiteral(u"llama"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F992"),
        QStringLiteral(u"giraffe"),
        QStringLiteral(u"giraffe"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F418"),
        QStringLiteral(u"elephant"),
        QStringLiteral(u"elephant"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A3"),
        QStringLiteral(u"mammoth"),
        QStringLiteral(u"mammoth"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F98F"),
        QStringLiteral(u"rhinoceros"),
        QStringLiteral(u"rhinoceros"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F99B"),
        QStringLiteral(u"hippopotamus"),
        QStringLiteral(u"hippopotamus"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F42D"),
        QStringLiteral(u"mouse"),
        QStringLiteral(u"mouse face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F401"),
        QStringLiteral(u"mouse"),
        QStringLiteral(u"mouse"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F400"),
        QStringLiteral(u"rat"),
        QStringLiteral(u"rat"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F439"),
        QStringLiteral(u"hamster"),
        QStringLiteral(u"hamster"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F430"),
        QStringLiteral(u"rabbit"),
        QStringLiteral(u"rabbit face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F407"),
        QStringLiteral(u"rabbit"),
        QStringLiteral(u"rabbit"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F43F\U0000FE0F"),
        QStringLiteral(u"chipmunk"),
        QStringLiteral(u"chipmunk"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9AB"),
        QStringLiteral(u"beaver"),
        QStringLiteral(u"beaver"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F994"),
        QStringLiteral(u"hedgehog"),
        QStringLiteral(u"hedgehog"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F987"),
        QStringLiteral(u"bat"),
        QStringLiteral(u"bat"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F43B"),
        QStringLiteral(u"bear"),
        QStringLiteral(u"bear"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F43B\U0000200D\U00002744\U0000FE0F"),
        QStringLiteral(u"polar_bear"),
        QStringLiteral(u"polar bear"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F428"),
        QStringLiteral(u"koala"),
        QStringLiteral(u"koala"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F43C"),
        QStringLiteral(u"panda"),
        QStringLiteral(u"panda"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A5"),
        QStringLiteral(u"sloth"),
        QStringLiteral(u"sloth"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A6"),
        QStringLiteral(u"otter"),
        QStringLiteral(u"otter"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A8"),
        QStringLiteral(u"skunk"),
        QStringLiteral(u"skunk"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F998"),
        QStringLiteral(u"kangaroo"),
        QStringLiteral(u"kangaroo"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A1"),
        QStringLiteral(u"badger"),
        QStringLiteral(u"badger"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F43E"),
        QStringLiteral(u"paw_prints"),
        QStringLiteral(u"paw prints"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F983"),
        QStringLiteral(u"turkey"),
        QStringLiteral(u"turkey"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F414"),
        QStringLiteral(u"chicken"),
        QStringLiteral(u"chicken"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F413"),
        QStringLiteral(u"rooster"),
        QStringLiteral(u"rooster"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F423"),
        QStringLiteral(u"hatching_chick"),
        QStringLiteral(u"hatching chick"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F424"),
        QStringLiteral(u"baby_chick"),
        QStringLiteral(u"baby chick"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F425"),
        QStringLiteral(u"front_facing_baby_chick"),
        QStringLiteral(u"front-facing baby chick"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F426"),
        QStringLiteral(u"bird"),
        QStringLiteral(u"bird"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F427"),
        QStringLiteral(u"penguin"),
        QStringLiteral(u"penguin"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F54A\U0000FE0F"),
        QStringLiteral(u"dove"),
        QStringLiteral(u"dove"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F985"),
        QStringLiteral(u"eagle"),
        QStringLiteral(u"eagle"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F986"),
        QStringLiteral(u"duck"),
        QStringLiteral(u"duck"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A2"),
        QStringLiteral(u"swan"),
        QStringLiteral(u"swan"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F989"),
        QStringLiteral(u"owl"),
        QStringLiteral(u"owl"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A4"),
        QStringLiteral(u"dodo"),
        QStringLiteral(u"dodo"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB6"),
        QStringLiteral(u"feather"),
        QStringLiteral(u"feather"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A9"),
        QStringLiteral(u"flamingo"),
        QStringLiteral(u"flamingo"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F99A"),
        QStringLiteral(u"peacock"),
        QStringLiteral(u"peacock"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F99C"),
        QStringLiteral(u"parrot"),
        QStringLiteral(u"parrot"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FABD"),
        QStringLiteral(u"wing"),
        QStringLiteral(u"wing"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F426\U0000200D\U00002B1B"),
        QStringLiteral(u"black_bird"),
        QStringLiteral(u"black bird"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FABF"),
        QStringLiteral(u"goose"),
        QStringLiteral(u"goose"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F438"),
        QStringLiteral(u"frog"),
        QStringLiteral(u"frog"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F40A"),
        QStringLiteral(u"crocodile"),
        QStringLiteral(u"crocodile"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F422"),
        QStringLiteral(u"turtle"),
        QStringLiteral(u"turtle"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F98E"),
        QStringLiteral(u"lizard"),
        QStringLiteral(u"lizard"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F40D"),
        QStringLiteral(u"snake"),
        QStringLiteral(u"snake"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F432"),
        QStringLiteral(u"dragon"),
        QStringLiteral(u"dragon face"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F409"),
        QStringLiteral(u"dragon"),
        QStringLiteral(u"dragon"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F995"),
        QStringLiteral(u"sauropod"),
        QStringLiteral(u"sauropod"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F996"),
        QStringLiteral(u"t_rex"),
        QStringLiteral(u"T-Rex"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F433"),
        QStringLiteral(u"spouting_whale"),
        QStringLiteral(u"spouting whale"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F40B"),
        QStringLiteral(u"whale"),
        QStringLiteral(u"whale"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F42C"),
        QStringLiteral(u"dolphin"),
        QStringLiteral(u"dolphin"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9AD"),
        QStringLiteral(u"seal"),
        QStringLiteral(u"seal"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F41F"),
        QStringLiteral(u"fish"),
        QStringLiteral(u"fish"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F420"),
        QStringLiteral(u"tropical_fish"),
        QStringLiteral(u"tropical fish"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F421"),
        QStringLiteral(u"blowfish"),
        QStringLiteral(u"blowfish"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F988"),
        QStringLiteral(u"shark"),
        QStringLiteral(u"shark"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F419"),
        QStringLiteral(u"octopus"),
        QStringLiteral(u"octopus"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F41A"),
        QStringLiteral(u"spiral_shell"),
        QStringLiteral(u"spiral shell"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB8"),
        QStringLiteral(u"coral"),
        QStringLiteral(u"coral"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FABC"),
        QStringLiteral(u"jellyfish"),
        QStringLiteral(u"jellyfish"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F40C"),
        QStringLiteral(u"snail"),
        QStringLiteral(u"snail"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F98B"),
        QStringLiteral(u"butterfly"),
        QStringLiteral(u"butterfly"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F41B"),
        QStringLiteral(u"bug"),
        QStringLiteral(u"bug"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F41C"),
        QStringLiteral(u"ant"),
        QStringLiteral(u"ant"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F41D"),
        QStringLiteral(u"honeybee"),
        QStringLiteral(u"honeybee"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB2"),
        QStringLiteral(u"beetle"),
        QStringLiteral(u"beetle"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F41E"),
        QStringLiteral(u"lady_beetle"),
        QStringLiteral(u"lady beetle"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F997"),
        QStringLiteral(u"cricket"),
        QStringLiteral(u"cricket"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB3"),
        QStringLiteral(u"cockroach"),
        QStringLiteral(u"cockroach"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F577\U0000FE0F"),
        QStringLiteral(u"spider"),
        QStringLiteral(u"spider"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F578\U0000FE0F"),
        QStringLiteral(u"spider_web"),
        QStringLiteral(u"spider web"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F982"),
        QStringLiteral(u"scorpion"),
        QStringLiteral(u"scorpion"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F99F"),
        QStringLiteral(u"mosquito"),
        QStringLiteral(u"mosquito"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB0"),
        QStringLiteral(u"fly"),
        QStringLiteral(u"fly"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB1"),
        QStringLiteral(u"worm"),
        QStringLiteral(u"worm"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F9A0"),
        QStringLiteral(u"microbe"),
        QStringLiteral(u"microbe"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F490"),
        QStringLiteral(u"bouquet"),
        QStringLiteral(u"bouquet"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F338"),
        QStringLiteral(u"cherry_blossom"),
        QStringLiteral(u"cherry blossom"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F4AE"),
        QStringLiteral(u"white_flower"),
        QStringLiteral(u"white flower"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB7"),
        QStringLiteral(u"lotus"),
        QStringLiteral(u"lotus"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F3F5\U0000FE0F"),
        QStringLiteral(u"rosette"),
        QStringLiteral(u"rosette"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F339"),
        QStringLiteral(u"rose"),
        QStringLiteral(u"rose"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F940"),
        QStringLiteral(u"wilted_flower"),
        QStringLiteral(u"wilted flower"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F33A"),
        QStringLiteral(u"hibiscus"),
        QStringLiteral(u"hibiscus"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F33B"),
        QStringLiteral(u"sunflower"),
        QStringLiteral(u"sunflower"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F33C"),
        QStringLiteral(u"blossom"),
        QStringLiteral(u"blossom"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F337"),
        QStringLiteral(u"tulip"),
        QStringLiteral(u"tulip"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FABB"),
        QStringLiteral(u"hyacinth"),
        QStringLiteral(u"hyacinth"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F331"),
        QStringLiteral(u"seedling"),
        QStringLiteral(u"seedling"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB4"),
        QStringLiteral(u"potted_plant"),
        QStringLiteral(u"potted plant"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F332"),
        QStringLiteral(u"evergreen_tree"),
        QStringLiteral(u"evergreen tree"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F333"),
        QStringLiteral(u"deciduous_tree"),
        QStringLiteral(u"deciduous tree"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F334"),
        QStringLiteral(u"palm_tree"),
        QStringLiteral(u"palm tree"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F335"),
        QStringLiteral(u"cactus"),
        QStringLiteral(u"cactus"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F33E"),
        QStringLiteral(u"sheaf_of_rice"),
        QStringLiteral(u"sheaf of rice"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F33F"),
        QStringLiteral(u"herb"),
        QStringLiteral(u"herb"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U00002618\U0000FE0F"),
        QStringLiteral(u"shamrock"),
        QStringLiteral(u"shamrock"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F340"),
        QStringLiteral(u"four_leaf_clover"),
        QStringLiteral(u"four leaf clover"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F341"),
        QStringLiteral(u"maple_leaf"),
        QStringLiteral(u"maple leaf"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F342"),
        QStringLiteral(u"fallen_leaf"),
        QStringLiteral(u"fallen leaf"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F343"),
        QStringLiteral(u"leaf_fluttering_in_wind"),
        QStringLiteral(u"leaf fluttering in wind"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FAB9"),
        QStringLiteral(u"empty_nest"),
        QStringLiteral(u"empty nest"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001FABA"),
        QStringLiteral(u"nest_with_eggs"),
        QStringLiteral(u"nest with eggs"),
        emoji::Emoji::Category::Nature},
  Emoji{QStringLiteral(u"\U0001F344"),
        QStringLiteral(u"mushroom"),
        QStringLiteral(u"mushroom"),
        emoji::Emoji::Category::Nature},
  // Food
  Emoji{QStringLiteral(u"\U0001F347"),
        QStringLiteral(u"grapes"),
        QStringLiteral(u"grapes"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F348"),
        QStringLiteral(u"melon"),
        QStringLiteral(u"melon"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F349"),
        QStringLiteral(u"watermelon"),
        QStringLiteral(u"watermelon"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F34A"),
        QStringLiteral(u"tangerine"),
        QStringLiteral(u"tangerine"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F34B"),
        QStringLiteral(u"lemon"),
        QStringLiteral(u"lemon"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F34C"),
        QStringLiteral(u"banana"),
        QStringLiteral(u"banana"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F34D"),
        QStringLiteral(u"pineapple"),
        QStringLiteral(u"pineapple"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F96D"),
        QStringLiteral(u"mango"),
        QStringLiteral(u"mango"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F34E"),
        QStringLiteral(u"red_apple"),
        QStringLiteral(u"red apple"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F34F"),
        QStringLiteral(u"green_apple"),
        QStringLiteral(u"green apple"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F350"),
        QStringLiteral(u"pear"),
        QStringLiteral(u"pear"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F351"),
        QStringLiteral(u"peach"),
        QStringLiteral(u"peach"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F352"),
        QStringLiteral(u"cherries"),
        QStringLiteral(u"cherries"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F353"),
        QStringLiteral(u"strawberry"),
        QStringLiteral(u"strawberry"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD0"),
        QStringLiteral(u"blueberries"),
        QStringLiteral(u"blueberries"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F95D"),
        QStringLiteral(u"kiwi_fruit"),
        QStringLiteral(u"kiwi fruit"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F345"),
        QStringLiteral(u"tomato"),
        QStringLiteral(u"tomato"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD2"),
        QStringLiteral(u"olive"),
        QStringLiteral(u"olive"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F965"),
        QStringLiteral(u"coconut"),
        QStringLiteral(u"coconut"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F951"),
        QStringLiteral(u"avocado"),
        QStringLiteral(u"avocado"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F346"),
        QStringLiteral(u"eggplant"),
        QStringLiteral(u"eggplant"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F954"),
        QStringLiteral(u"potato"),
        QStringLiteral(u"potato"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F955"),
        QStringLiteral(u"carrot"),
        QStringLiteral(u"carrot"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F33D"),
        QStringLiteral(u"ear_of_corn"),
        QStringLiteral(u"ear of corn"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F336\U0000FE0F"),
        QStringLiteral(u"hot_pepper"),
        QStringLiteral(u"hot pepper"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD1"),
        QStringLiteral(u"bell_pepper"),
        QStringLiteral(u"bell pepper"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F952"),
        QStringLiteral(u"cucumber"),
        QStringLiteral(u"cucumber"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F96C"),
        QStringLiteral(u"leafy_green"),
        QStringLiteral(u"leafy green"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F966"),
        QStringLiteral(u"broccoli"),
        QStringLiteral(u"broccoli"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C4"),
        QStringLiteral(u"garlic"),
        QStringLiteral(u"garlic"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C5"),
        QStringLiteral(u"onion"),
        QStringLiteral(u"onion"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F95C"),
        QStringLiteral(u"peanuts"),
        QStringLiteral(u"peanuts"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD8"),
        QStringLiteral(u"beans"),
        QStringLiteral(u"beans"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F330"),
        QStringLiteral(u"chestnut"),
        QStringLiteral(u"chestnut"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FADA"),
        QStringLiteral(u"ginger_root"),
        QStringLiteral(u"ginger root"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FADB"),
        QStringLiteral(u"pea_pod"),
        QStringLiteral(u"pea pod"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F35E"),
        QStringLiteral(u"bread"),
        QStringLiteral(u"bread"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F950"),
        QStringLiteral(u"croissant"),
        QStringLiteral(u"croissant"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F956"),
        QStringLiteral(u"baguette_bread"),
        QStringLiteral(u"baguette bread"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD3"),
        QStringLiteral(u"flatbread"),
        QStringLiteral(u"flatbread"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F968"),
        QStringLiteral(u"pretzel"),
        QStringLiteral(u"pretzel"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F96F"),
        QStringLiteral(u"bagel"),
        QStringLiteral(u"bagel"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F95E"),
        QStringLiteral(u"pancakes"),
        QStringLiteral(u"pancakes"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C7"),
        QStringLiteral(u"waffle"),
        QStringLiteral(u"waffle"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C0"),
        QStringLiteral(u"cheese_wedge"),
        QStringLiteral(u"cheese wedge"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F356"),
        QStringLiteral(u"meat_on_bone"),
        QStringLiteral(u"meat on bone"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F357"),
        QStringLiteral(u"poultry_leg"),
        QStringLiteral(u"poultry leg"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F969"),
        QStringLiteral(u"cut_of_meat"),
        QStringLiteral(u"cut of meat"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F953"),
        QStringLiteral(u"bacon"),
        QStringLiteral(u"bacon"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F354"),
        QStringLiteral(u"hamburger"),
        QStringLiteral(u"hamburger"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F35F"),
        QStringLiteral(u"french_fries"),
        QStringLiteral(u"french fries"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F355"),
        QStringLiteral(u"pizza"),
        QStringLiteral(u"pizza"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F32D"),
        QStringLiteral(u"hot_dog"),
        QStringLiteral(u"hot dog"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F96A"),
        QStringLiteral(u"sandwich"),
        QStringLiteral(u"sandwich"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F32E"),
        QStringLiteral(u"taco"),
        QStringLiteral(u"taco"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F32F"),
        QStringLiteral(u"burrito"),
        QStringLiteral(u"burrito"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD4"),
        QStringLiteral(u"tamale"),
        QStringLiteral(u"tamale"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F959"),
        QStringLiteral(u"stuffed_flatbread"),
        QStringLiteral(u"stuffed flatbread"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C6"),
        QStringLiteral(u"falafel"),
        QStringLiteral(u"falafel"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F95A"),
        QStringLiteral(u"egg"),
        QStringLiteral(u"egg"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F373"),
        QStringLiteral(u"cooking"),
        QStringLiteral(u"cooking"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F958"),
        QStringLiteral(u"shallow_pan_of_food"),
        QStringLiteral(u"shallow pan of food"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F372"),
        QStringLiteral(u"pot_of_food"),
        QStringLiteral(u"pot of food"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD5"),
        QStringLiteral(u"fondue"),
        QStringLiteral(u"fondue"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F963"),
        QStringLiteral(u"bowl_with_spoon"),
        QStringLiteral(u"bowl with spoon"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F957"),
        QStringLiteral(u"green_salad"),
        QStringLiteral(u"green salad"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F37F"),
        QStringLiteral(u"popcorn"),
        QStringLiteral(u"popcorn"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C8"),
        QStringLiteral(u"butter"),
        QStringLiteral(u"butter"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C2"),
        QStringLiteral(u"salt"),
        QStringLiteral(u"salt"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F96B"),
        QStringLiteral(u"canned_food"),
        QStringLiteral(u"canned food"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F371"),
        QStringLiteral(u"bento_box"),
        QStringLiteral(u"bento box"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F358"),
        QStringLiteral(u"rice_cracker"),
        QStringLiteral(u"rice cracker"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F359"),
        QStringLiteral(u"rice_ball"),
        QStringLiteral(u"rice ball"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F35A"),
        QStringLiteral(u"cooked_rice"),
        QStringLiteral(u"cooked rice"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F35B"),
        QStringLiteral(u"curry_rice"),
        QStringLiteral(u"curry rice"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F35C"),
        QStringLiteral(u"steaming_bowl"),
        QStringLiteral(u"steaming bowl"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F35D"),
        QStringLiteral(u"spaghetti"),
        QStringLiteral(u"spaghetti"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F360"),
        QStringLiteral(u"roasted_sweet_potato"),
        QStringLiteral(u"roasted sweet potato"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F362"),
        QStringLiteral(u"oden"),
        QStringLiteral(u"oden"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F363"),
        QStringLiteral(u"sushi"),
        QStringLiteral(u"sushi"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F364"),
        QStringLiteral(u"fried_shrimp"),
        QStringLiteral(u"fried shrimp"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F365"),
        QStringLiteral(u"fish_cake_with_swirl"),
        QStringLiteral(u"fish cake with swirl"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F96E"),
        QStringLiteral(u"moon_cake"),
        QStringLiteral(u"moon cake"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F361"),
        QStringLiteral(u"dango"),
        QStringLiteral(u"dango"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F95F"),
        QStringLiteral(u"dumpling"),
        QStringLiteral(u"dumpling"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F960"),
        QStringLiteral(u"fortune_cookie"),
        QStringLiteral(u"fortune cookie"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F961"),
        QStringLiteral(u"takeout_box"),
        QStringLiteral(u"takeout box"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F980"),
        QStringLiteral(u"crab"),
        QStringLiteral(u"crab"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F99E"),
        QStringLiteral(u"lobster"),
        QStringLiteral(u"lobster"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F990"),
        QStringLiteral(u"shrimp"),
        QStringLiteral(u"shrimp"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F991"),
        QStringLiteral(u"squid"),
        QStringLiteral(u"squid"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9AA"),
        QStringLiteral(u"oyster"),
        QStringLiteral(u"oyster"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F366"),
        QStringLiteral(u"soft_ice_cream"),
        QStringLiteral(u"soft ice cream"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F367"),
        QStringLiteral(u"shaved_ice"),
        QStringLiteral(u"shaved ice"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F368"),
        QStringLiteral(u"ice_cream"),
        QStringLiteral(u"ice cream"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F369"),
        QStringLiteral(u"doughnut"),
        QStringLiteral(u"doughnut"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F36A"),
        QStringLiteral(u"cookie"),
        QStringLiteral(u"cookie"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F382"),
        QStringLiteral(u"birthday_cake"),
        QStringLiteral(u"birthday cake"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F370"),
        QStringLiteral(u"shortcake"),
        QStringLiteral(u"shortcake"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C1"),
        QStringLiteral(u"cupcake"),
        QStringLiteral(u"cupcake"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F967"),
        QStringLiteral(u"pie"),
        QStringLiteral(u"pie"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F36B"),
        QStringLiteral(u"chocolate_bar"),
        QStringLiteral(u"chocolate bar"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F36C"),
        QStringLiteral(u"candy"),
        QStringLiteral(u"candy"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F36D"),
        QStringLiteral(u"lollipop"),
        QStringLiteral(u"lollipop"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F36E"),
        QStringLiteral(u"custard"),
        QStringLiteral(u"custard"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F36F"),
        QStringLiteral(u"honey_pot"),
        QStringLiteral(u"honey pot"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F37C"),
        QStringLiteral(u"baby_bottle"),
        QStringLiteral(u"baby bottle"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F95B"),
        QStringLiteral(u"glass_of_milk"),
        QStringLiteral(u"glass of milk"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U00002615"),
        QStringLiteral(u"hot_beverage"),
        QStringLiteral(u"hot beverage"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD6"),
        QStringLiteral(u"teapot"),
        QStringLiteral(u"teapot"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F375"),
        QStringLiteral(u"teacup_without_handle"),
        QStringLiteral(u"teacup without handle"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F376"),
        QStringLiteral(u"sake"),
        QStringLiteral(u"sake"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F37E"),
        QStringLiteral(u"bottle_with_popping_cork"),
        QStringLiteral(u"bottle with popping cork"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F377"),
        QStringLiteral(u"wine_glass"),
        QStringLiteral(u"wine glass"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F378"),
        QStringLiteral(u"cocktail_glass"),
        QStringLiteral(u"cocktail glass"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F379"),
        QStringLiteral(u"tropical_drink"),
        QStringLiteral(u"tropical drink"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F37A"),
        QStringLiteral(u"beer_mug"),
        QStringLiteral(u"beer mug"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F37B"),
        QStringLiteral(u"clinking_beer_mugs"),
        QStringLiteral(u"clinking beer mugs"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F942"),
        QStringLiteral(u"clinking_glasses"),
        QStringLiteral(u"clinking glasses"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F943"),
        QStringLiteral(u"tumbler_glass"),
        QStringLiteral(u"tumbler glass"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD7"),
        QStringLiteral(u"pouring_liquid"),
        QStringLiteral(u"pouring liquid"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F964"),
        QStringLiteral(u"cup_with_straw"),
        QStringLiteral(u"cup with straw"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9CB"),
        QStringLiteral(u"bubble_tea"),
        QStringLiteral(u"bubble tea"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C3"),
        QStringLiteral(u"beverage_box"),
        QStringLiteral(u"beverage box"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9C9"),
        QStringLiteral(u"mate"),
        QStringLiteral(u"mate"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F9CA"),
        QStringLiteral(u"ice"),
        QStringLiteral(u"ice"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F962"),
        QStringLiteral(u"chopsticks"),
        QStringLiteral(u"chopsticks"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F37D\U0000FE0F"),
        QStringLiteral(u"fork_and_knife_with_plate"),
        QStringLiteral(u"fork and knife with plate"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F374"),
        QStringLiteral(u"fork_and_knife"),
        QStringLiteral(u"fork and knife"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F944"),
        QStringLiteral(u"spoon"),
        QStringLiteral(u"spoon"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F52A"),
        QStringLiteral(u"kitchen_knife"),
        QStringLiteral(u"kitchen knife"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001FAD9"),
        QStringLiteral(u"jar"),
        QStringLiteral(u"jar"),
        emoji::Emoji::Category::Food},
  Emoji{QStringLiteral(u"\U0001F3FA"),
        QStringLiteral(u"amphora"),
        QStringLiteral(u"amphora"),
        emoji::Emoji::Category::Food},
  // Activity
  Emoji{QStringLiteral(u"\U0001F383"),
        QStringLiteral(u"jack_o_lantern"),
        QStringLiteral(u"jack-o-lantern"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F384"),
        QStringLiteral(u"christmas_tree"),
        QStringLiteral(u"Christmas tree"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F386"),
        QStringLiteral(u"fireworks"),
        QStringLiteral(u"fireworks"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F387"),
        QStringLiteral(u"sparkler"),
        QStringLiteral(u"sparkler"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F9E8"),
        QStringLiteral(u"firecracker"),
        QStringLiteral(u"firecracker"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U00002728"),
        QStringLiteral(u"sparkles"),
        QStringLiteral(u"sparkles"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F388"),
        QStringLiteral(u"balloon"),
        QStringLiteral(u"balloon"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F389"),
        QStringLiteral(u"tada"),
        QStringLiteral(u"party popper"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F38A"),
        QStringLiteral(u"confetti_ball"),
        QStringLiteral(u"confetti ball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F38B"),
        QStringLiteral(u"tanabata_tree"),
        QStringLiteral(u"tanabata tree"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F38D"),
        QStringLiteral(u"pine_decoration"),
        QStringLiteral(u"pine decoration"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F38E"),
        QStringLiteral(u"japanese_dolls"),
        QStringLiteral(u"Japanese dolls"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F38F"),
        QStringLiteral(u"carp_streamer"),
        QStringLiteral(u"carp streamer"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F390"),
        QStringLiteral(u"wind_chime"),
        QStringLiteral(u"wind chime"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F391"),
        QStringLiteral(u"moon_viewing_ceremony"),
        QStringLiteral(u"moon viewing ceremony"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F9E7"),
        QStringLiteral(u"red_envelope"),
        QStringLiteral(u"red envelope"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F380"),
        QStringLiteral(u"ribbon"),
        QStringLiteral(u"ribbon"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F381"),
        QStringLiteral(u"wrapped_gift"),
        QStringLiteral(u"wrapped gift"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F397\U0000FE0F"),
        QStringLiteral(u"reminder_ribbon"),
        QStringLiteral(u"reminder ribbon"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F39F\U0000FE0F"),
        QStringLiteral(u"admission_tickets"),
        QStringLiteral(u"admission tickets"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3AB"),
        QStringLiteral(u"ticket"),
        QStringLiteral(u"ticket"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F396\U0000FE0F"),
        QStringLiteral(u"military_medal"),
        QStringLiteral(u"military medal"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3C6"),
        QStringLiteral(u"trophy"),
        QStringLiteral(u"trophy"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3C5"),
        QStringLiteral(u"sports_medal"),
        QStringLiteral(u"sports medal"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F947"),
        QStringLiteral(u"1st_place_medal"),
        QStringLiteral(u"1st place medal"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F948"),
        QStringLiteral(u"2nd_place_medal"),
        QStringLiteral(u"2nd place medal"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F949"),
        QStringLiteral(u"3rd_place_medal"),
        QStringLiteral(u"3rd place medal"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U000026BD"),
        QStringLiteral(u"soccer_ball"),
        QStringLiteral(u"soccer ball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U000026BE"),
        QStringLiteral(u"baseball"),
        QStringLiteral(u"baseball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F94E"),
        QStringLiteral(u"softball"),
        QStringLiteral(u"softball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3C0"),
        QStringLiteral(u"basketball"),
        QStringLiteral(u"basketball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3D0"),
        QStringLiteral(u"volleyball"),
        QStringLiteral(u"volleyball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3C8"),
        QStringLiteral(u"american_football"),
        QStringLiteral(u"american football"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3C9"),
        QStringLiteral(u"rugby_football"),
        QStringLiteral(u"rugby football"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3BE"),
        QStringLiteral(u"tennis"),
        QStringLiteral(u"tennis"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F94F"),
        QStringLiteral(u"flying_disc"),
        QStringLiteral(u"flying disc"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3B3"),
        QStringLiteral(u"bowling"),
        QStringLiteral(u"bowling"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3CF"),
        QStringLiteral(u"cricket_game"),
        QStringLiteral(u"cricket game"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3D1"),
        QStringLiteral(u"field_hockey"),
        QStringLiteral(u"field hockey"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3D2"),
        QStringLiteral(u"ice_hockey"),
        QStringLiteral(u"ice hockey"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F94D"),
        QStringLiteral(u"lacrosse"),
        QStringLiteral(u"lacrosse"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3D3"),
        QStringLiteral(u"ping_pong"),
        QStringLiteral(u"ping pong"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3F8"),
        QStringLiteral(u"badminton"),
        QStringLiteral(u"badminton"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F94A"),
        QStringLiteral(u"boxing_glove"),
        QStringLiteral(u"boxing glove"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F94B"),
        QStringLiteral(u"martial_arts_uniform"),
        QStringLiteral(u"martial arts uniform"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F945"),
        QStringLiteral(u"goal_net"),
        QStringLiteral(u"goal net"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U000026F3"),
        QStringLiteral(u"flag_in_hole"),
        QStringLiteral(u"flag in hole"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U000026F8\U0000FE0F"),
        QStringLiteral(u"ice_skate"),
        QStringLiteral(u"ice skate"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3A3"),
        QStringLiteral(u"fishing_pole"),
        QStringLiteral(u"fishing pole"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F93F"),
        QStringLiteral(u"diving_mask"),
        QStringLiteral(u"diving mask"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3BD"),
        QStringLiteral(u"running_shirt"),
        QStringLiteral(u"running shirt"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3BF"),
        QStringLiteral(u"skis"),
        QStringLiteral(u"skis"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F6F7"),
        QStringLiteral(u"sled"),
        QStringLiteral(u"sled"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F94C"),
        QStringLiteral(u"curling_stone"),
        QStringLiteral(u"curling stone"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3AF"),
        QStringLiteral(u"bullseye"),
        QStringLiteral(u"bullseye"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FA80"),
        QStringLiteral(u"yo_yo"),
        QStringLiteral(u"yo-yo"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FA81"),
        QStringLiteral(u"kite"),
        QStringLiteral(u"kite"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F52B"),
        QStringLiteral(u"water_pistol"),
        QStringLiteral(u"water pistol"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3B1"),
        QStringLiteral(u"pool_8_ball"),
        QStringLiteral(u"pool 8 ball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F52E"),
        QStringLiteral(u"crystal_ball"),
        QStringLiteral(u"crystal ball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FA84"),
        QStringLiteral(u"magic_wand"),
        QStringLiteral(u"magic wand"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3AE"),
        QStringLiteral(u"video_game"),
        QStringLiteral(u"video game"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F579\U0000FE0F"),
        QStringLiteral(u"joystick"),
        QStringLiteral(u"joystick"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3B0"),
        QStringLiteral(u"slot_machine"),
        QStringLiteral(u"slot machine"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3B2"),
        QStringLiteral(u"game_die"),
        QStringLiteral(u"game die"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F9E9"),
        QStringLiteral(u"puzzle_piece"),
        QStringLiteral(u"puzzle piece"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F9F8"),
        QStringLiteral(u"teddy_bear"),
        QStringLiteral(u"teddy bear"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FA85"),
        QStringLiteral(u"pinata"),
        QStringLiteral(u"piñata"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FAA9"),
        QStringLiteral(u"mirror_ball"),
        QStringLiteral(u"mirror ball"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FA86"),
        QStringLiteral(u"nesting_dolls"),
        QStringLiteral(u"nesting dolls"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U00002660\U0000FE0F"),
        QStringLiteral(u"spade_suit"),
        QStringLiteral(u"spade suit"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U00002665\U0000FE0F"),
        QStringLiteral(u"heart_suit"),
        QStringLiteral(u"heart suit"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U00002666\U0000FE0F"),
        QStringLiteral(u"diamond_suit"),
        QStringLiteral(u"diamond suit"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U00002663\U0000FE0F"),
        QStringLiteral(u"club_suit"),
        QStringLiteral(u"club suit"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0000265F\U0000FE0F"),
        QStringLiteral(u"chess_pawn"),
        QStringLiteral(u"chess pawn"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F0CF"),
        QStringLiteral(u"joker"),
        QStringLiteral(u"joker"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F004"),
        QStringLiteral(u"mahjong_red_dragon"),
        QStringLiteral(u"mahjong red dragon"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3B4"),
        QStringLiteral(u"flower_playing_cards"),
        QStringLiteral(u"flower playing cards"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3AD"),
        QStringLiteral(u"performing_arts"),
        QStringLiteral(u"performing arts"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F5BC\U0000FE0F"),
        QStringLiteral(u"framed_picture"),
        QStringLiteral(u"framed picture"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F3A8"),
        QStringLiteral(u"artist_palette"),
        QStringLiteral(u"artist palette"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F9F5"),
        QStringLiteral(u"thread"),
        QStringLiteral(u"thread"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FAA1"),
        QStringLiteral(u"sewing_needle"),
        QStringLiteral(u"sewing needle"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001F9F6"),
        QStringLiteral(u"yarn"),
        QStringLiteral(u"yarn"),
        emoji::Emoji::Category::Activity},
  Emoji{QStringLiteral(u"\U0001FAA2"),
        QStringLiteral(u"knot"),
        QStringLiteral(u"knot"),
        emoji::Emoji::Category::Activity},
  // Travel
  Emoji{QStringLiteral(u"\U0001F30D"),
        QStringLiteral(u"globe_showing_europe_africa"),
        QStringLiteral(u"globe showing Europe-Africa"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F30E"),
        QStringLiteral(u"globe_showing_americas"),
        QStringLiteral(u"globe showing Americas"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F30F"),
        QStringLiteral(u"globe_showing_asia_australia"),
        QStringLiteral(u"globe showing Asia-Australia"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F310"),
        QStringLiteral(u"globe_with_meridians"),
        QStringLiteral(u"globe with meridians"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F5FA\U0000FE0F"),
        QStringLiteral(u"world_map"),
        QStringLiteral(u"world map"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F5FE"),
        QStringLiteral(u"map_of_japan"),
        QStringLiteral(u"map of Japan"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F9ED"),
        QStringLiteral(u"compass"),
        QStringLiteral(u"compass"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3D4\U0000FE0F"),
        QStringLiteral(u"snow_capped_mountain"),
        QStringLiteral(u"snow-capped mountain"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026F0\U0000FE0F"),
        QStringLiteral(u"mountain"),
        QStringLiteral(u"mountain"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F30B"),
        QStringLiteral(u"volcano"),
        QStringLiteral(u"volcano"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F5FB"),
        QStringLiteral(u"mount_fuji"),
        QStringLiteral(u"mount fuji"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3D5\U0000FE0F"),
        QStringLiteral(u"camping"),
        QStringLiteral(u"camping"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3D6\U0000FE0F"),
        QStringLiteral(u"beach_with_umbrella"),
        QStringLiteral(u"beach with umbrella"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3DC\U0000FE0F"),
        QStringLiteral(u"desert"),
        QStringLiteral(u"desert"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3DD\U0000FE0F"),
        QStringLiteral(u"desert_island"),
        QStringLiteral(u"desert island"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3DE\U0000FE0F"),
        QStringLiteral(u"national_park"),
        QStringLiteral(u"national park"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3DF\U0000FE0F"),
        QStringLiteral(u"stadium"),
        QStringLiteral(u"stadium"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3DB\U0000FE0F"),
        QStringLiteral(u"classical_building"),
        QStringLiteral(u"classical building"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3D7\U0000FE0F"),
        QStringLiteral(u"building_construction"),
        QStringLiteral(u"building construction"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F9F1"),
        QStringLiteral(u"brick"),
        QStringLiteral(u"brick"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001FAA8"),
        QStringLiteral(u"rock"),
        QStringLiteral(u"rock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001FAB5"),
        QStringLiteral(u"wood"),
        QStringLiteral(u"wood"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6D6"),
        QStringLiteral(u"hut"),
        QStringLiteral(u"hut"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3D8\U0000FE0F"),
        QStringLiteral(u"houses"),
        QStringLiteral(u"houses"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3DA\U0000FE0F"),
        QStringLiteral(u"derelict_house"),
        QStringLiteral(u"derelict house"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E0"),
        QStringLiteral(u"house"),
        QStringLiteral(u"house"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E1"),
        QStringLiteral(u"house_with_garden"),
        QStringLiteral(u"house with garden"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E2"),
        QStringLiteral(u"office_building"),
        QStringLiteral(u"office building"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E3"),
        QStringLiteral(u"japanese_post_office"),
        QStringLiteral(u"Japanese post office"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E4"),
        QStringLiteral(u"post_office"),
        QStringLiteral(u"post office"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E5"),
        QStringLiteral(u"hospital"),
        QStringLiteral(u"hospital"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E6"),
        QStringLiteral(u"bank"),
        QStringLiteral(u"bank"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E8"),
        QStringLiteral(u"hotel"),
        QStringLiteral(u"hotel"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3E9"),
        QStringLiteral(u"love_hotel"),
        QStringLiteral(u"love hotel"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3EA"),
        QStringLiteral(u"convenience_store"),
        QStringLiteral(u"convenience store"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3EB"),
        QStringLiteral(u"school"),
        QStringLiteral(u"school"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3EC"),
        QStringLiteral(u"department_store"),
        QStringLiteral(u"department store"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3ED"),
        QStringLiteral(u"factory"),
        QStringLiteral(u"factory"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3EF"),
        QStringLiteral(u"japanese_castle"),
        QStringLiteral(u"Japanese castle"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3F0"),
        QStringLiteral(u"castle"),
        QStringLiteral(u"castle"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F492"),
        QStringLiteral(u"wedding"),
        QStringLiteral(u"wedding"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F5FC"),
        QStringLiteral(u"tokyo_tower"),
        QStringLiteral(u"Tokyo tower"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F5FD"),
        QStringLiteral(u"statue_of_liberty"),
        QStringLiteral(u"Statue of Liberty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026EA"),
        QStringLiteral(u"church"),
        QStringLiteral(u"church"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F54C"),
        QStringLiteral(u"mosque"),
        QStringLiteral(u"mosque"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6D5"),
        QStringLiteral(u"hindu_temple"),
        QStringLiteral(u"hindu temple"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F54D"),
        QStringLiteral(u"synagogue"),
        QStringLiteral(u"synagogue"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026E9\U0000FE0F"),
        QStringLiteral(u"shinto_shrine"),
        QStringLiteral(u"shinto shrine"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F54B"),
        QStringLiteral(u"kaaba"),
        QStringLiteral(u"kaaba"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026F2"),
        QStringLiteral(u"fountain"),
        QStringLiteral(u"fountain"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026FA"),
        QStringLiteral(u"tent"),
        QStringLiteral(u"tent"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F301"),
        QStringLiteral(u"foggy"),
        QStringLiteral(u"foggy"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F303"),
        QStringLiteral(u"night_with_stars"),
        QStringLiteral(u"night with stars"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3D9\U0000FE0F"),
        QStringLiteral(u"cityscape"),
        QStringLiteral(u"cityscape"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F304"),
        QStringLiteral(u"sunrise_over_mountains"),
        QStringLiteral(u"sunrise over mountains"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F305"),
        QStringLiteral(u"sunrise"),
        QStringLiteral(u"sunrise"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F306"),
        QStringLiteral(u"cityscape_at_dusk"),
        QStringLiteral(u"cityscape at dusk"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F307"),
        QStringLiteral(u"sunset"),
        QStringLiteral(u"sunset"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F309"),
        QStringLiteral(u"bridge_at_night"),
        QStringLiteral(u"bridge at night"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002668\U0000FE0F"),
        QStringLiteral(u"hot_springs"),
        QStringLiteral(u"hot springs"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3A0"),
        QStringLiteral(u"carousel_horse"),
        QStringLiteral(u"carousel horse"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6DD"),
        QStringLiteral(u"playground_slide"),
        QStringLiteral(u"playground slide"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3A1"),
        QStringLiteral(u"ferris_wheel"),
        QStringLiteral(u"ferris wheel"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3A2"),
        QStringLiteral(u"roller_coaster"),
        QStringLiteral(u"roller coaster"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F488"),
        QStringLiteral(u"barber_pole"),
        QStringLiteral(u"barber pole"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3AA"),
        QStringLiteral(u"circus_tent"),
        QStringLiteral(u"circus tent"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F682"),
        QStringLiteral(u"locomotive"),
        QStringLiteral(u"locomotive"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F683"),
        QStringLiteral(u"railway_car"),
        QStringLiteral(u"railway car"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F684"),
        QStringLiteral(u"high_speed_train"),
        QStringLiteral(u"high-speed train"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F685"),
        QStringLiteral(u"bullet_train"),
        QStringLiteral(u"bullet train"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F686"),
        QStringLiteral(u"train"),
        QStringLiteral(u"train"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F687"),
        QStringLiteral(u"metro"),
        QStringLiteral(u"metro"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F688"),
        QStringLiteral(u"light_rail"),
        QStringLiteral(u"light rail"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F689"),
        QStringLiteral(u"station"),
        QStringLiteral(u"station"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F68A"),
        QStringLiteral(u"tram"),
        QStringLiteral(u"tram"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F69D"),
        QStringLiteral(u"monorail"),
        QStringLiteral(u"monorail"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F69E"),
        QStringLiteral(u"mountain_railway"),
        QStringLiteral(u"mountain railway"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F68B"),
        QStringLiteral(u"tram_car"),
        QStringLiteral(u"tram car"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F68C"),
        QStringLiteral(u"bus"),
        QStringLiteral(u"bus"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F68D"),
        QStringLiteral(u"oncoming_bus"),
        QStringLiteral(u"oncoming bus"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F68E"),
        QStringLiteral(u"trolleybus"),
        QStringLiteral(u"trolleybus"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F690"),
        QStringLiteral(u"minibus"),
        QStringLiteral(u"minibus"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F691"),
        QStringLiteral(u"ambulance"),
        QStringLiteral(u"ambulance"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F692"),
        QStringLiteral(u"fire_engine"),
        QStringLiteral(u"fire engine"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F693"),
        QStringLiteral(u"police_car"),
        QStringLiteral(u"police car"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F694"),
        QStringLiteral(u"oncoming_police_car"),
        QStringLiteral(u"oncoming police car"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F695"),
        QStringLiteral(u"taxi"),
        QStringLiteral(u"taxi"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F696"),
        QStringLiteral(u"oncoming_taxi"),
        QStringLiteral(u"oncoming taxi"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F697"),
        QStringLiteral(u"automobile"),
        QStringLiteral(u"automobile"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F698"),
        QStringLiteral(u"oncoming_automobile"),
        QStringLiteral(u"oncoming automobile"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F699"),
        QStringLiteral(u"sport_utility_vehicle"),
        QStringLiteral(u"sport utility vehicle"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6FB"),
        QStringLiteral(u"pickup_truck"),
        QStringLiteral(u"pickup truck"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F69A"),
        QStringLiteral(u"delivery_truck"),
        QStringLiteral(u"delivery truck"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F69B"),
        QStringLiteral(u"articulated_lorry"),
        QStringLiteral(u"articulated lorry"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F69C"),
        QStringLiteral(u"tractor"),
        QStringLiteral(u"tractor"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3CE\U0000FE0F"),
        QStringLiteral(u"racing_car"),
        QStringLiteral(u"racing car"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F3CD\U0000FE0F"),
        QStringLiteral(u"motorcycle"),
        QStringLiteral(u"motorcycle"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6F5"),
        QStringLiteral(u"motor_scooter"),
        QStringLiteral(u"motor scooter"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F9BD"),
        QStringLiteral(u"manual_wheelchair"),
        QStringLiteral(u"manual wheelchair"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F9BC"),
        QStringLiteral(u"motorized_wheelchair"),
        QStringLiteral(u"motorized wheelchair"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6FA"),
        QStringLiteral(u"auto_rickshaw"),
        QStringLiteral(u"auto rickshaw"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6B2"),
        QStringLiteral(u"bicycle"),
        QStringLiteral(u"bicycle"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6F4"),
        QStringLiteral(u"kick_scooter"),
        QStringLiteral(u"kick scooter"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6F9"),
        QStringLiteral(u"skateboard"),
        QStringLiteral(u"skateboard"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6FC"),
        QStringLiteral(u"roller_skate"),
        QStringLiteral(u"roller skate"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F68F"),
        QStringLiteral(u"bus_stop"),
        QStringLiteral(u"bus stop"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6E3\U0000FE0F"),
        QStringLiteral(u"motorway"),
        QStringLiteral(u"motorway"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6E4\U0000FE0F"),
        QStringLiteral(u"railway_track"),
        QStringLiteral(u"railway track"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6E2\U0000FE0F"),
        QStringLiteral(u"oil_drum"),
        QStringLiteral(u"oil drum"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026FD"),
        QStringLiteral(u"fuel_pump"),
        QStringLiteral(u"fuel pump"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6DE"),
        QStringLiteral(u"wheel"),
        QStringLiteral(u"wheel"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A8"),
        QStringLiteral(u"police_car_light"),
        QStringLiteral(u"police car light"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A5"),
        QStringLiteral(u"horizontal_traffic_light"),
        QStringLiteral(u"horizontal traffic light"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A6"),
        QStringLiteral(u"vertical_traffic_light"),
        QStringLiteral(u"vertical traffic light"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6D1"),
        QStringLiteral(u"stop_sign"),
        QStringLiteral(u"stop sign"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A7"),
        QStringLiteral(u"construction"),
        QStringLiteral(u"construction"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002693"),
        QStringLiteral(u"anchor"),
        QStringLiteral(u"anchor"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6DF"),
        QStringLiteral(u"ring_buoy"),
        QStringLiteral(u"ring buoy"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026F5"),
        QStringLiteral(u"sailboat"),
        QStringLiteral(u"sailboat"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6F6"),
        QStringLiteral(u"canoe"),
        QStringLiteral(u"canoe"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A4"),
        QStringLiteral(u"speedboat"),
        QStringLiteral(u"speedboat"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6F3\U0000FE0F"),
        QStringLiteral(u"passenger_ship"),
        QStringLiteral(u"passenger ship"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026F4\U0000FE0F"),
        QStringLiteral(u"ferry"),
        QStringLiteral(u"ferry"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6E5\U0000FE0F"),
        QStringLiteral(u"motor_boat"),
        QStringLiteral(u"motor boat"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A2"),
        QStringLiteral(u"ship"),
        QStringLiteral(u"ship"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002708\U0000FE0F"),
        QStringLiteral(u"airplane"),
        QStringLiteral(u"airplane"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6E9\U0000FE0F"),
        QStringLiteral(u"small_airplane"),
        QStringLiteral(u"small airplane"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6EB"),
        QStringLiteral(u"airplane_departure"),
        QStringLiteral(u"airplane departure"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6EC"),
        QStringLiteral(u"airplane_arrival"),
        QStringLiteral(u"airplane arrival"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001FA82"),
        QStringLiteral(u"parachute"),
        QStringLiteral(u"parachute"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F4BA"),
        QStringLiteral(u"seat"),
        QStringLiteral(u"seat"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F681"),
        QStringLiteral(u"helicopter"),
        QStringLiteral(u"helicopter"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F69F"),
        QStringLiteral(u"suspension_railway"),
        QStringLiteral(u"suspension railway"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A0"),
        QStringLiteral(u"mountain_cableway"),
        QStringLiteral(u"mountain cableway"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6A1"),
        QStringLiteral(u"aerial_tramway"),
        QStringLiteral(u"aerial tramway"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6F0\U0000FE0F"),
        QStringLiteral(u"satellite"),
        QStringLiteral(u"satellite"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F680"),
        QStringLiteral(u"rocket"),
        QStringLiteral(u"rocket"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6F8"),
        QStringLiteral(u"flying_saucer"),
        QStringLiteral(u"flying saucer"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F6CE\U0000FE0F"),
        QStringLiteral(u"bellhop_bell"),
        QStringLiteral(u"bellhop bell"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F9F3"),
        QStringLiteral(u"luggage"),
        QStringLiteral(u"luggage"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0000231B"),
        QStringLiteral(u"hourglass_done"),
        QStringLiteral(u"hourglass done"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000023F3"),
        QStringLiteral(u"hourglass_not_done"),
        QStringLiteral(u"hourglass not done"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0000231A"),
        QStringLiteral(u"watch"),
        QStringLiteral(u"watch"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000023F0"),
        QStringLiteral(u"alarm_clock"),
        QStringLiteral(u"alarm clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000023F1\U0000FE0F"),
        QStringLiteral(u"stopwatch"),
        QStringLiteral(u"stopwatch"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000023F2\U0000FE0F"),
        QStringLiteral(u"timer_clock"),
        QStringLiteral(u"timer clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F570\U0000FE0F"),
        QStringLiteral(u"mantelpiece_clock"),
        QStringLiteral(u"mantelpiece clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F55B"),
        QStringLiteral(u"twelve_o_clock"),
        QStringLiteral(u"twelve o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F567"),
        QStringLiteral(u"twelve_thirty"),
        QStringLiteral(u"twelve-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F550"),
        QStringLiteral(u"one_o_clock"),
        QStringLiteral(u"one o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F55C"),
        QStringLiteral(u"one_thirty"),
        QStringLiteral(u"one-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F551"),
        QStringLiteral(u"two_o_clock"),
        QStringLiteral(u"two o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F55D"),
        QStringLiteral(u"two_thirty"),
        QStringLiteral(u"two-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F552"),
        QStringLiteral(u"three_o_clock"),
        QStringLiteral(u"three o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F55E"),
        QStringLiteral(u"three_thirty"),
        QStringLiteral(u"three-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F553"),
        QStringLiteral(u"four_o_clock"),
        QStringLiteral(u"four o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F55F"),
        QStringLiteral(u"four_thirty"),
        QStringLiteral(u"four-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F554"),
        QStringLiteral(u"five_o_clock"),
        QStringLiteral(u"five o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F560"),
        QStringLiteral(u"five_thirty"),
        QStringLiteral(u"five-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F555"),
        QStringLiteral(u"six_o_clock"),
        QStringLiteral(u"six o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F561"),
        QStringLiteral(u"six_thirty"),
        QStringLiteral(u"six-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F556"),
        QStringLiteral(u"seven_o_clock"),
        QStringLiteral(u"seven o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F562"),
        QStringLiteral(u"seven_thirty"),
        QStringLiteral(u"seven-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F557"),
        QStringLiteral(u"eight_o_clock"),
        QStringLiteral(u"eight o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F563"),
        QStringLiteral(u"eight_thirty"),
        QStringLiteral(u"eight-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F558"),
        QStringLiteral(u"nine_o_clock"),
        QStringLiteral(u"nine o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F564"),
        QStringLiteral(u"nine_thirty"),
        QStringLiteral(u"nine-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F559"),
        QStringLiteral(u"ten_o_clock"),
        QStringLiteral(u"ten o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F565"),
        QStringLiteral(u"ten_thirty"),
        QStringLiteral(u"ten-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F55A"),
        QStringLiteral(u"eleven_o_clock"),
        QStringLiteral(u"eleven o’clock"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F566"),
        QStringLiteral(u"eleven_thirty"),
        QStringLiteral(u"eleven-thirty"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F311"),
        QStringLiteral(u"new_moon"),
        QStringLiteral(u"new moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F312"),
        QStringLiteral(u"waxing_crescent_moon"),
        QStringLiteral(u"waxing crescent moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F313"),
        QStringLiteral(u"first_quarter_moon"),
        QStringLiteral(u"first quarter moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F314"),
        QStringLiteral(u"waxing_gibbous_moon"),
        QStringLiteral(u"waxing gibbous moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F315"),
        QStringLiteral(u"full_moon"),
        QStringLiteral(u"full moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F316"),
        QStringLiteral(u"waning_gibbous_moon"),
        QStringLiteral(u"waning gibbous moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F317"),
        QStringLiteral(u"last_quarter_moon"),
        QStringLiteral(u"last quarter moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F318"),
        QStringLiteral(u"waning_crescent_moon"),
        QStringLiteral(u"waning crescent moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F319"),
        QStringLiteral(u"crescent_moon"),
        QStringLiteral(u"crescent moon"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F31A"),
        QStringLiteral(u"new_moon"),
        QStringLiteral(u"new moon face"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F31B"),
        QStringLiteral(u"first_quarter_moon"),
        QStringLiteral(u"first quarter moon face"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F31C"),
        QStringLiteral(u"last_quarter_moon"),
        QStringLiteral(u"last quarter moon face"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F321\U0000FE0F"),
        QStringLiteral(u"thermometer"),
        QStringLiteral(u"thermometer"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002600\U0000FE0F"),
        QStringLiteral(u"sun"),
        QStringLiteral(u"sun"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F31D"),
        QStringLiteral(u"full_moon"),
        QStringLiteral(u"full moon face"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F31E"),
        QStringLiteral(u"sun_with"),
        QStringLiteral(u"sun with face"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001FA90"),
        QStringLiteral(u"ringed_planet"),
        QStringLiteral(u"ringed planet"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002B50"),
        QStringLiteral(u"star"),
        QStringLiteral(u"star"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F31F"),
        QStringLiteral(u"glowing_star"),
        QStringLiteral(u"glowing star"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F320"),
        QStringLiteral(u"shooting_star"),
        QStringLiteral(u"shooting star"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F30C"),
        QStringLiteral(u"milky_way"),
        QStringLiteral(u"milky way"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002601\U0000FE0F"),
        QStringLiteral(u"cloud"),
        QStringLiteral(u"cloud"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026C5"),
        QStringLiteral(u"sun_behind_cloud"),
        QStringLiteral(u"sun behind cloud"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026C8\U0000FE0F"),
        QStringLiteral(u"cloud_with_lightning_and_rain"),
        QStringLiteral(u"cloud with lightning and rain"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F324\U0000FE0F"),
        QStringLiteral(u"sun_behind_small_cloud"),
        QStringLiteral(u"sun behind small cloud"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F325\U0000FE0F"),
        QStringLiteral(u"sun_behind_large_cloud"),
        QStringLiteral(u"sun behind large cloud"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F326\U0000FE0F"),
        QStringLiteral(u"sun_behind_rain_cloud"),
        QStringLiteral(u"sun behind rain cloud"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F327\U0000FE0F"),
        QStringLiteral(u"cloud_with_rain"),
        QStringLiteral(u"cloud with rain"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F328\U0000FE0F"),
        QStringLiteral(u"cloud_with_snow"),
        QStringLiteral(u"cloud with snow"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F329\U0000FE0F"),
        QStringLiteral(u"cloud_with_lightning"),
        QStringLiteral(u"cloud with lightning"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F32A\U0000FE0F"),
        QStringLiteral(u"tornado"),
        QStringLiteral(u"tornado"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F32B\U0000FE0F"),
        QStringLiteral(u"fog"),
        QStringLiteral(u"fog"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F32C\U0000FE0F"),
        QStringLiteral(u"wind"),
        QStringLiteral(u"wind face"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F300"),
        QStringLiteral(u"cyclone"),
        QStringLiteral(u"cyclone"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F308"),
        QStringLiteral(u"rainbow"),
        QStringLiteral(u"rainbow"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F302"),
        QStringLiteral(u"closed_umbrella"),
        QStringLiteral(u"closed umbrella"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002602\U0000FE0F"),
        QStringLiteral(u"umbrella"),
        QStringLiteral(u"umbrella"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002614"),
        QStringLiteral(u"umbrella_with_rain_drops"),
        QStringLiteral(u"umbrella with rain drops"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026F1\U0000FE0F"),
        QStringLiteral(u"umbrella_on_ground"),
        QStringLiteral(u"umbrella on ground"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026A1"),
        QStringLiteral(u"zap"),
        QStringLiteral(u"high voltage"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002744\U0000FE0F"),
        QStringLiteral(u"snowflake"),
        QStringLiteral(u"snowflake"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002603\U0000FE0F"),
        QStringLiteral(u"snowman"),
        QStringLiteral(u"snowman"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U000026C4"),
        QStringLiteral(u"snowman_without_snow"),
        QStringLiteral(u"snowman without snow"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U00002604\U0000FE0F"),
        QStringLiteral(u"comet"),
        QStringLiteral(u"comet"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F525"),
        QStringLiteral(u"fire"),
        QStringLiteral(u"fire"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F4A7"),
        QStringLiteral(u"droplet"),
        QStringLiteral(u"droplet"),
        emoji::Emoji::Category::Travel},
  Emoji{QStringLiteral(u"\U0001F30A"),
        QStringLiteral(u"water_wave"),
        QStringLiteral(u"water wave"),
        emoji::Emoji::Category::Travel},
  // Objects
  Emoji{QStringLiteral(u"\U0001F453"),
        QStringLiteral(u"glasses"),
        QStringLiteral(u"glasses"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F576\U0000FE0F"),
        QStringLiteral(u"sunglasses"),
        QStringLiteral(u"sunglasses"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F97D"),
        QStringLiteral(u"goggles"),
        QStringLiteral(u"goggles"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F97C"),
        QStringLiteral(u"lab_coat"),
        QStringLiteral(u"lab coat"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9BA"),
        QStringLiteral(u"safety_vest"),
        QStringLiteral(u"safety vest"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F454"),
        QStringLiteral(u"necktie"),
        QStringLiteral(u"necktie"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F455"),
        QStringLiteral(u"t_shirt"),
        QStringLiteral(u"t-shirt"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F456"),
        QStringLiteral(u"jeans"),
        QStringLiteral(u"jeans"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9E3"),
        QStringLiteral(u"scarf"),
        QStringLiteral(u"scarf"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9E4"),
        QStringLiteral(u"gloves"),
        QStringLiteral(u"gloves"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9E5"),
        QStringLiteral(u"coat"),
        QStringLiteral(u"coat"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9E6"),
        QStringLiteral(u"socks"),
        QStringLiteral(u"socks"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F457"),
        QStringLiteral(u"dress"),
        QStringLiteral(u"dress"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F458"),
        QStringLiteral(u"kimono"),
        QStringLiteral(u"kimono"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F97B"),
        QStringLiteral(u"sari"),
        QStringLiteral(u"sari"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA71"),
        QStringLiteral(u"one_piece_swimsuit"),
        QStringLiteral(u"one-piece swimsuit"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA72"),
        QStringLiteral(u"briefs"),
        QStringLiteral(u"briefs"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA73"),
        QStringLiteral(u"shorts"),
        QStringLiteral(u"shorts"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F459"),
        QStringLiteral(u"bikini"),
        QStringLiteral(u"bikini"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F45A"),
        QStringLiteral(u"woman_s_clothes"),
        QStringLiteral(u"woman’s clothes"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAAD"),
        QStringLiteral(u"folding_hand_fan"),
        QStringLiteral(u"folding hand fan"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F45B"),
        QStringLiteral(u"purse"),
        QStringLiteral(u"purse"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F45C"),
        QStringLiteral(u"handbag"),
        QStringLiteral(u"handbag"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F45D"),
        QStringLiteral(u"clutch_bag"),
        QStringLiteral(u"clutch bag"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6CD\U0000FE0F"),
        QStringLiteral(u"shopping_bags"),
        QStringLiteral(u"shopping bags"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F392"),
        QStringLiteral(u"backpack"),
        QStringLiteral(u"backpack"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA74"),
        QStringLiteral(u"thong_sandal"),
        QStringLiteral(u"thong sandal"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F45E"),
        QStringLiteral(u"man_s_shoe"),
        QStringLiteral(u"man’s shoe"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F45F"),
        QStringLiteral(u"running_shoe"),
        QStringLiteral(u"running shoe"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F97E"),
        QStringLiteral(u"hiking_boot"),
        QStringLiteral(u"hiking boot"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F97F"),
        QStringLiteral(u"flat_shoe"),
        QStringLiteral(u"flat shoe"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F460"),
        QStringLiteral(u"high_heeled_shoe"),
        QStringLiteral(u"high-heeled shoe"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F461"),
        QStringLiteral(u"woman_s_sandal"),
        QStringLiteral(u"woman’s sandal"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA70"),
        QStringLiteral(u"ballet_shoes"),
        QStringLiteral(u"ballet shoes"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F462"),
        QStringLiteral(u"woman_s_boot"),
        QStringLiteral(u"woman’s boot"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAAE"),
        QStringLiteral(u"hair_pick"),
        QStringLiteral(u"hair pick"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F451"),
        QStringLiteral(u"crown"),
        QStringLiteral(u"crown"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F452"),
        QStringLiteral(u"woman_s_hat"),
        QStringLiteral(u"woman’s hat"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3A9"),
        QStringLiteral(u"top_hat"),
        QStringLiteral(u"top hat"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F393"),
        QStringLiteral(u"graduation_cap"),
        QStringLiteral(u"graduation cap"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9E2"),
        QStringLiteral(u"billed_cap"),
        QStringLiteral(u"billed cap"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA96"),
        QStringLiteral(u"military_helmet"),
        QStringLiteral(u"military helmet"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U000026D1\U0000FE0F"),
        QStringLiteral(u"rescue_worker_s_helmet"),
        QStringLiteral(u"rescue worker’s helmet"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4FF"),
        QStringLiteral(u"prayer_beads"),
        QStringLiteral(u"prayer beads"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F484"),
        QStringLiteral(u"lipstick"),
        QStringLiteral(u"lipstick"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F48D"),
        QStringLiteral(u"ring"),
        QStringLiteral(u"ring"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F48E"),
        QStringLiteral(u"gem_stone"),
        QStringLiteral(u"gem stone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F507"),
        QStringLiteral(u"muted_speaker"),
        QStringLiteral(u"muted speaker"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F508"),
        QStringLiteral(u"speaker_low_volume"),
        QStringLiteral(u"speaker low volume"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F509"),
        QStringLiteral(u"speaker_medium_volume"),
        QStringLiteral(u"speaker medium volume"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F50A"),
        QStringLiteral(u"speaker_high_volume"),
        QStringLiteral(u"speaker high volume"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E2"),
        QStringLiteral(u"loudspeaker"),
        QStringLiteral(u"loudspeaker"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E3"),
        QStringLiteral(u"megaphone"),
        QStringLiteral(u"megaphone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4EF"),
        QStringLiteral(u"postal_horn"),
        QStringLiteral(u"postal horn"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F514"),
        QStringLiteral(u"bell"),
        QStringLiteral(u"bell"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F515"),
        QStringLiteral(u"bell_with_slash"),
        QStringLiteral(u"bell with slash"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3BC"),
        QStringLiteral(u"musical_score"),
        QStringLiteral(u"musical score"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3B5"),
        QStringLiteral(u"musical_note"),
        QStringLiteral(u"musical note"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3B6"),
        QStringLiteral(u"musical_notes"),
        QStringLiteral(u"musical notes"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F399\U0000FE0F"),
        QStringLiteral(u"studio_microphone"),
        QStringLiteral(u"studio microphone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F39A\U0000FE0F"),
        QStringLiteral(u"level_slider"),
        QStringLiteral(u"level slider"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F39B\U0000FE0F"),
        QStringLiteral(u"control_knobs"),
        QStringLiteral(u"control knobs"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3A4"),
        QStringLiteral(u"microphone"),
        QStringLiteral(u"microphone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3A7"),
        QStringLiteral(u"headphone"),
        QStringLiteral(u"headphone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4FB"),
        QStringLiteral(u"radio"),
        QStringLiteral(u"radio"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3B7"),
        QStringLiteral(u"saxophone"),
        QStringLiteral(u"saxophone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA97"),
        QStringLiteral(u"accordion"),
        QStringLiteral(u"accordion"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3B8"),
        QStringLiteral(u"guitar"),
        QStringLiteral(u"guitar"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3B9"),
        QStringLiteral(u"musical_keyboard"),
        QStringLiteral(u"musical keyboard"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3BA"),
        QStringLiteral(u"trumpet"),
        QStringLiteral(u"trumpet"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3BB"),
        QStringLiteral(u"violin"),
        QStringLiteral(u"violin"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA95"),
        QStringLiteral(u"banjo"),
        QStringLiteral(u"banjo"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F941"),
        QStringLiteral(u"drum"),
        QStringLiteral(u"drum"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA98"),
        QStringLiteral(u"long_drum"),
        QStringLiteral(u"long drum"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA87"),
        QStringLiteral(u"maracas"),
        QStringLiteral(u"maracas"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA88"),
        QStringLiteral(u"flute"),
        QStringLiteral(u"flute"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4F1"),
        QStringLiteral(u"mobile_phone"),
        QStringLiteral(u"mobile phone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4F2"),
        QStringLiteral(u"mobile_phone_with_arrow"),
        QStringLiteral(u"mobile phone with arrow"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0000260E\U0000FE0F"),
        QStringLiteral(u"telephone"),
        QStringLiteral(u"telephone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4DE"),
        QStringLiteral(u"telephone_receiver"),
        QStringLiteral(u"telephone receiver"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4DF"),
        QStringLiteral(u"pager"),
        QStringLiteral(u"pager"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E0"),
        QStringLiteral(u"fax_machine"),
        QStringLiteral(u"fax machine"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F50B"),
        QStringLiteral(u"battery"),
        QStringLiteral(u"battery"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAAB"),
        QStringLiteral(u"low_battery"),
        QStringLiteral(u"low battery"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F50C"),
        QStringLiteral(u"electric_plug"),
        QStringLiteral(u"electric plug"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4BB"),
        QStringLiteral(u"laptop"),
        QStringLiteral(u"laptop"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5A5\U0000FE0F"),
        QStringLiteral(u"desktop_computer"),
        QStringLiteral(u"desktop computer"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5A8\U0000FE0F"),
        QStringLiteral(u"printer"),
        QStringLiteral(u"printer"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002328\U0000FE0F"),
        QStringLiteral(u"keyboard"),
        QStringLiteral(u"keyboard"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5B1\U0000FE0F"),
        QStringLiteral(u"computer_mouse"),
        QStringLiteral(u"computer mouse"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5B2\U0000FE0F"),
        QStringLiteral(u"trackball"),
        QStringLiteral(u"trackball"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4BD"),
        QStringLiteral(u"computer_disk"),
        QStringLiteral(u"computer disk"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4BE"),
        QStringLiteral(u"floppy_disk"),
        QStringLiteral(u"floppy disk"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4BF"),
        QStringLiteral(u"optical_disk"),
        QStringLiteral(u"optical disk"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C0"),
        QStringLiteral(u"dvd"),
        QStringLiteral(u"dvd"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9EE"),
        QStringLiteral(u"abacus"),
        QStringLiteral(u"abacus"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3A5"),
        QStringLiteral(u"movie_camera"),
        QStringLiteral(u"movie camera"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F39E\U0000FE0F"),
        QStringLiteral(u"film_frames"),
        QStringLiteral(u"film frames"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4FD\U0000FE0F"),
        QStringLiteral(u"film_projector"),
        QStringLiteral(u"film projector"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3AC"),
        QStringLiteral(u"clapper_board"),
        QStringLiteral(u"clapper board"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4FA"),
        QStringLiteral(u"television"),
        QStringLiteral(u"television"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4F7"),
        QStringLiteral(u"camera"),
        QStringLiteral(u"camera"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4F8"),
        QStringLiteral(u"camera_with_flash"),
        QStringLiteral(u"camera with flash"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4F9"),
        QStringLiteral(u"video_camera"),
        QStringLiteral(u"video camera"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4FC"),
        QStringLiteral(u"videocassette"),
        QStringLiteral(u"videocassette"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F50D"),
        QStringLiteral(u"magnifying_glass_tilted_left"),
        QStringLiteral(u"magnifying glass tilted left"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F50E"),
        QStringLiteral(u"magnifying_glass_tilted_right"),
        QStringLiteral(u"magnifying glass tilted right"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F56F\U0000FE0F"),
        QStringLiteral(u"candle"),
        QStringLiteral(u"candle"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4A1"),
        QStringLiteral(u"light_bulb"),
        QStringLiteral(u"light bulb"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F526"),
        QStringLiteral(u"flashlight"),
        QStringLiteral(u"flashlight"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3EE"),
        QStringLiteral(u"red_paper_lantern"),
        QStringLiteral(u"red paper lantern"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA94"),
        QStringLiteral(u"diya_lamp"),
        QStringLiteral(u"diya lamp"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D4"),
        QStringLiteral(u"notebook_with_decorative_cover"),
        QStringLiteral(u"notebook with decorative cover"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D5"),
        QStringLiteral(u"closed_book"),
        QStringLiteral(u"closed book"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D6"),
        QStringLiteral(u"open_book"),
        QStringLiteral(u"open book"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D7"),
        QStringLiteral(u"green_book"),
        QStringLiteral(u"green book"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D8"),
        QStringLiteral(u"blue_book"),
        QStringLiteral(u"blue book"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D9"),
        QStringLiteral(u"orange_book"),
        QStringLiteral(u"orange book"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4DA"),
        QStringLiteral(u"books"),
        QStringLiteral(u"books"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D3"),
        QStringLiteral(u"notebook"),
        QStringLiteral(u"notebook"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D2"),
        QStringLiteral(u"ledger"),
        QStringLiteral(u"ledger"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C3"),
        QStringLiteral(u"page_with_curl"),
        QStringLiteral(u"page with curl"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4DC"),
        QStringLiteral(u"scroll"),
        QStringLiteral(u"scroll"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C4"),
        QStringLiteral(u"page_facing_up"),
        QStringLiteral(u"page facing up"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4F0"),
        QStringLiteral(u"newspaper"),
        QStringLiteral(u"newspaper"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5DE\U0000FE0F"),
        QStringLiteral(u"rolled_up_newspaper"),
        QStringLiteral(u"rolled-up newspaper"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D1"),
        QStringLiteral(u"bookmark_tabs"),
        QStringLiteral(u"bookmark tabs"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F516"),
        QStringLiteral(u"bookmark"),
        QStringLiteral(u"bookmark"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3F7\U0000FE0F"),
        QStringLiteral(u"label"),
        QStringLiteral(u"label"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B0"),
        QStringLiteral(u"money_bag"),
        QStringLiteral(u"money bag"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA99"),
        QStringLiteral(u"coin"),
        QStringLiteral(u"coin"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B4"),
        QStringLiteral(u"yen"),
        QStringLiteral(u"yen banknote"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B5"),
        QStringLiteral(u"dollar"),
        QStringLiteral(u"dollar banknote"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B6"),
        QStringLiteral(u"euro"),
        QStringLiteral(u"euro banknote"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B7"),
        QStringLiteral(u"pound"),
        QStringLiteral(u"pound banknote"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B8"),
        QStringLiteral(u"money_with_wings"),
        QStringLiteral(u"money with wings"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B3"),
        QStringLiteral(u"credit_card"),
        QStringLiteral(u"credit card"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9FE"),
        QStringLiteral(u"receipt"),
        QStringLiteral(u"receipt"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4B9"),
        QStringLiteral(u"chart_increasing_with_yen"),
        QStringLiteral(u"chart increasing with yen"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002709\U0000FE0F"),
        QStringLiteral(u"envelope"),
        QStringLiteral(u"envelope"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E7"),
        QStringLiteral(u"e_mail"),
        QStringLiteral(u"e-mail"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E8"),
        QStringLiteral(u"incoming_envelope"),
        QStringLiteral(u"incoming envelope"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E9"),
        QStringLiteral(u"envelope_with_arrow"),
        QStringLiteral(u"envelope with arrow"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E4"),
        QStringLiteral(u"outbox_tray"),
        QStringLiteral(u"outbox tray"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E5"),
        QStringLiteral(u"inbox_tray"),
        QStringLiteral(u"inbox tray"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E6"),
        QStringLiteral(u"package"),
        QStringLiteral(u"package"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4EB"),
        QStringLiteral(u"closed_mailbox_with_raised_flag"),
        QStringLiteral(u"closed mailbox with raised flag"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4EA"),
        QStringLiteral(u"closed_mailbox_with_lowered_flag"),
        QStringLiteral(u"closed mailbox with lowered flag"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4EC"),
        QStringLiteral(u"open_mailbox_with_raised_flag"),
        QStringLiteral(u"open mailbox with raised flag"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4ED"),
        QStringLiteral(u"open_mailbox_with_lowered_flag"),
        QStringLiteral(u"open mailbox with lowered flag"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4EE"),
        QStringLiteral(u"postbox"),
        QStringLiteral(u"postbox"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5F3\U0000FE0F"),
        QStringLiteral(u"ballot_box_with_ballot"),
        QStringLiteral(u"ballot box with ballot"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0000270F\U0000FE0F"),
        QStringLiteral(u"pencil"),
        QStringLiteral(u"pencil"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002712\U0000FE0F"),
        QStringLiteral(u"black_nib"),
        QStringLiteral(u"black nib"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F58B\U0000FE0F"),
        QStringLiteral(u"fountain_pen"),
        QStringLiteral(u"fountain pen"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F58A\U0000FE0F"),
        QStringLiteral(u"pen"),
        QStringLiteral(u"pen"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F58C\U0000FE0F"),
        QStringLiteral(u"paintbrush"),
        QStringLiteral(u"paintbrush"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F58D\U0000FE0F"),
        QStringLiteral(u"crayon"),
        QStringLiteral(u"crayon"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4DD"),
        QStringLiteral(u"memo"),
        QStringLiteral(u"memo"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4BC"),
        QStringLiteral(u"briefcase"),
        QStringLiteral(u"briefcase"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C1"),
        QStringLiteral(u"file_folder"),
        QStringLiteral(u"file folder"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C2"),
        QStringLiteral(u"open_file_folder"),
        QStringLiteral(u"open file folder"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5C2\U0000FE0F"),
        QStringLiteral(u"card_index_dividers"),
        QStringLiteral(u"card index dividers"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C5"),
        QStringLiteral(u"calendar"),
        QStringLiteral(u"calendar"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C6"),
        QStringLiteral(u"tear_off_calendar"),
        QStringLiteral(u"tear-off calendar"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5D2\U0000FE0F"),
        QStringLiteral(u"spiral_notepad"),
        QStringLiteral(u"spiral notepad"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5D3\U0000FE0F"),
        QStringLiteral(u"spiral_calendar"),
        QStringLiteral(u"spiral calendar"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C7"),
        QStringLiteral(u"card_index"),
        QStringLiteral(u"card index"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C8"),
        QStringLiteral(u"chart_increasing"),
        QStringLiteral(u"chart increasing"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4C9"),
        QStringLiteral(u"chart_decreasing"),
        QStringLiteral(u"chart decreasing"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4CA"),
        QStringLiteral(u"bar_chart"),
        QStringLiteral(u"bar chart"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4CB"),
        QStringLiteral(u"clipboard"),
        QStringLiteral(u"clipboard"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4CC"),
        QStringLiteral(u"pushpin"),
        QStringLiteral(u"pushpin"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4CD"),
        QStringLiteral(u"round_pushpin"),
        QStringLiteral(u"round pushpin"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4CE"),
        QStringLiteral(u"paperclip"),
        QStringLiteral(u"paperclip"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F587\U0000FE0F"),
        QStringLiteral(u"linked_paperclips"),
        QStringLiteral(u"linked paperclips"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4CF"),
        QStringLiteral(u"straight_ruler"),
        QStringLiteral(u"straight ruler"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4D0"),
        QStringLiteral(u"triangular_ruler"),
        QStringLiteral(u"triangular ruler"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002702\U0000FE0F"),
        QStringLiteral(u"scissors"),
        QStringLiteral(u"scissors"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5C3\U0000FE0F"),
        QStringLiteral(u"card_file_box"),
        QStringLiteral(u"card file box"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5C4\U0000FE0F"),
        QStringLiteral(u"file_cabinet"),
        QStringLiteral(u"file cabinet"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5D1\U0000FE0F"),
        QStringLiteral(u"wastebasket"),
        QStringLiteral(u"wastebasket"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F512"),
        QStringLiteral(u"locked"),
        QStringLiteral(u"locked"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F513"),
        QStringLiteral(u"unlocked"),
        QStringLiteral(u"unlocked"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F50F"),
        QStringLiteral(u"locked_with_pen"),
        QStringLiteral(u"locked with pen"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F510"),
        QStringLiteral(u"locked_with_key"),
        QStringLiteral(u"locked with key"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F511"),
        QStringLiteral(u"key"),
        QStringLiteral(u"key"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5DD\U0000FE0F"),
        QStringLiteral(u"old_key"),
        QStringLiteral(u"old key"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F528"),
        QStringLiteral(u"hammer"),
        QStringLiteral(u"hammer"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA93"),
        QStringLiteral(u"axe"),
        QStringLiteral(u"axe"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U000026CF\U0000FE0F"),
        QStringLiteral(u"pick"),
        QStringLiteral(u"pick"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002692\U0000FE0F"),
        QStringLiteral(u"hammer_and_pick"),
        QStringLiteral(u"hammer and pick"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6E0\U0000FE0F"),
        QStringLiteral(u"hammer_and_wrench"),
        QStringLiteral(u"hammer and wrench"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5E1\U0000FE0F"),
        QStringLiteral(u"dagger"),
        QStringLiteral(u"dagger"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002694\U0000FE0F"),
        QStringLiteral(u"crossed_swords"),
        QStringLiteral(u"crossed swords"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4A3"),
        QStringLiteral(u"bomb"),
        QStringLiteral(u"bomb"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA83"),
        QStringLiteral(u"boomerang"),
        QStringLiteral(u"boomerang"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F3F9"),
        QStringLiteral(u"bow_and_arrow"),
        QStringLiteral(u"bow and arrow"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6E1\U0000FE0F"),
        QStringLiteral(u"shield"),
        QStringLiteral(u"shield"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA9A"),
        QStringLiteral(u"carpentry_saw"),
        QStringLiteral(u"carpentry saw"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F527"),
        QStringLiteral(u"wrench"),
        QStringLiteral(u"wrench"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA9B"),
        QStringLiteral(u"screwdriver"),
        QStringLiteral(u"screwdriver"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F529"),
        QStringLiteral(u"nut_and_bolt"),
        QStringLiteral(u"nut and bolt"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002699\U0000FE0F"),
        QStringLiteral(u"gear"),
        QStringLiteral(u"gear"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5DC\U0000FE0F"),
        QStringLiteral(u"clamp"),
        QStringLiteral(u"clamp"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002696\U0000FE0F"),
        QStringLiteral(u"balance_scale"),
        QStringLiteral(u"balance scale"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9AF"),
        QStringLiteral(u"white_cane"),
        QStringLiteral(u"white cane"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F517"),
        QStringLiteral(u"link"),
        QStringLiteral(u"link"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U000026D3\U0000FE0F"),
        QStringLiteral(u"chains"),
        QStringLiteral(u"chains"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA9D"),
        QStringLiteral(u"hook"),
        QStringLiteral(u"hook"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9F0"),
        QStringLiteral(u"toolbox"),
        QStringLiteral(u"toolbox"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9F2"),
        QStringLiteral(u"magnet"),
        QStringLiteral(u"magnet"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA9C"),
        QStringLiteral(u"ladder"),
        QStringLiteral(u"ladder"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U00002697\U0000FE0F"),
        QStringLiteral(u"alembic"),
        QStringLiteral(u"alembic"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9EA"),
        QStringLiteral(u"test_tube"),
        QStringLiteral(u"test tube"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9EB"),
        QStringLiteral(u"petri_dish"),
        QStringLiteral(u"petri dish"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9EC"),
        QStringLiteral(u"dna"),
        QStringLiteral(u"dna"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F52C"),
        QStringLiteral(u"microscope"),
        QStringLiteral(u"microscope"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F52D"),
        QStringLiteral(u"telescope"),
        QStringLiteral(u"telescope"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F4E1"),
        QStringLiteral(u"satellite_antenna"),
        QStringLiteral(u"satellite antenna"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F489"),
        QStringLiteral(u"syringe"),
        QStringLiteral(u"syringe"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA78"),
        QStringLiteral(u"drop_of_blood"),
        QStringLiteral(u"drop of blood"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F48A"),
        QStringLiteral(u"pill"),
        QStringLiteral(u"pill"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA79"),
        QStringLiteral(u"adhesive_bandage"),
        QStringLiteral(u"adhesive bandage"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA7C"),
        QStringLiteral(u"crutch"),
        QStringLiteral(u"crutch"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA7A"),
        QStringLiteral(u"stethoscope"),
        QStringLiteral(u"stethoscope"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA7B"),
        QStringLiteral(u"x_ray"),
        QStringLiteral(u"x-ray"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6AA"),
        QStringLiteral(u"door"),
        QStringLiteral(u"door"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6D7"),
        QStringLiteral(u"elevator"),
        QStringLiteral(u"elevator"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA9E"),
        QStringLiteral(u"mirror"),
        QStringLiteral(u"mirror"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA9F"),
        QStringLiteral(u"window"),
        QStringLiteral(u"window"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6CF\U0000FE0F"),
        QStringLiteral(u"bed"),
        QStringLiteral(u"bed"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6CB\U0000FE0F"),
        QStringLiteral(u"couch_and_lamp"),
        QStringLiteral(u"couch and lamp"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA91"),
        QStringLiteral(u"chair"),
        QStringLiteral(u"chair"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6BD"),
        QStringLiteral(u"toilet"),
        QStringLiteral(u"toilet"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAA0"),
        QStringLiteral(u"plunger"),
        QStringLiteral(u"plunger"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6BF"),
        QStringLiteral(u"shower"),
        QStringLiteral(u"shower"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6C1"),
        QStringLiteral(u"bathtub"),
        QStringLiteral(u"bathtub"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAA4"),
        QStringLiteral(u"mouse_trap"),
        QStringLiteral(u"mouse trap"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FA92"),
        QStringLiteral(u"razor"),
        QStringLiteral(u"razor"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9F4"),
        QStringLiteral(u"lotion_bottle"),
        QStringLiteral(u"lotion bottle"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9F7"),
        QStringLiteral(u"safety_pin"),
        QStringLiteral(u"safety pin"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9F9"),
        QStringLiteral(u"broom"),
        QStringLiteral(u"broom"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9FA"),
        QStringLiteral(u"basket"),
        QStringLiteral(u"basket"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9FB"),
        QStringLiteral(u"roll_of_paper"),
        QStringLiteral(u"roll of paper"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAA3"),
        QStringLiteral(u"bucket"),
        QStringLiteral(u"bucket"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9FC"),
        QStringLiteral(u"soap"),
        QStringLiteral(u"soap"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAE7"),
        QStringLiteral(u"bubbles"),
        QStringLiteral(u"bubbles"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAA5"),
        QStringLiteral(u"toothbrush"),
        QStringLiteral(u"toothbrush"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9FD"),
        QStringLiteral(u"sponge"),
        QStringLiteral(u"sponge"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9EF"),
        QStringLiteral(u"fire_extinguisher"),
        QStringLiteral(u"fire extinguisher"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6D2"),
        QStringLiteral(u"shopping_cart"),
        QStringLiteral(u"shopping cart"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F6AC"),
        QStringLiteral(u"cigarette"),
        QStringLiteral(u"cigarette"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U000026B0\U0000FE0F"),
        QStringLiteral(u"coffin"),
        QStringLiteral(u"coffin"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAA6"),
        QStringLiteral(u"headstone"),
        QStringLiteral(u"headstone"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U000026B1\U0000FE0F"),
        QStringLiteral(u"funeral_urn"),
        QStringLiteral(u"funeral urn"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F9FF"),
        QStringLiteral(u"nazar_amulet"),
        QStringLiteral(u"nazar amulet"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAAC"),
        QStringLiteral(u"hamsa"),
        QStringLiteral(u"hamsa"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001F5FF"),
        QStringLiteral(u"moai"),
        QStringLiteral(u"moai"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAA7"),
        QStringLiteral(u"placard"),
        QStringLiteral(u"placard"),
        emoji::Emoji::Category::Objects},
  Emoji{QStringLiteral(u"\U0001FAAA"),
        QStringLiteral(u"identification_card"),
        QStringLiteral(u"identification card"),
        emoji::Emoji::Category::Objects},
  // Symbols
  Emoji{QStringLiteral(u"\U0001F3E7"),
        QStringLiteral(u"atm_sign"),
        QStringLiteral(u"ATM sign"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6AE"),
        QStringLiteral(u"litter_in_bin_sign"),
        QStringLiteral(u"litter in bin sign"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6B0"),
        QStringLiteral(u"potable_water"),
        QStringLiteral(u"potable water"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000267F"),
        QStringLiteral(u"wheelchair_symbol"),
        QStringLiteral(u"wheelchair symbol"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6B9"),
        QStringLiteral(u"men_s_room"),
        QStringLiteral(u"men’s room"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6BA"),
        QStringLiteral(u"women_s_room"),
        QStringLiteral(u"women’s room"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6BB"),
        QStringLiteral(u"restroom"),
        QStringLiteral(u"restroom"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6BC"),
        QStringLiteral(u"baby_symbol"),
        QStringLiteral(u"baby symbol"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6BE"),
        QStringLiteral(u"water_closet"),
        QStringLiteral(u"water closet"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6C2"),
        QStringLiteral(u"passport_control"),
        QStringLiteral(u"passport control"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6C3"),
        QStringLiteral(u"customs"),
        QStringLiteral(u"customs"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6C4"),
        QStringLiteral(u"baggage_claim"),
        QStringLiteral(u"baggage claim"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6C5"),
        QStringLiteral(u"left_luggage"),
        QStringLiteral(u"left luggage"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000026A0\U0000FE0F"),
        QStringLiteral(u"warning"),
        QStringLiteral(u"warning"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6B8"),
        QStringLiteral(u"children_crossing"),
        QStringLiteral(u"children crossing"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000026D4"),
        QStringLiteral(u"no_entry"),
        QStringLiteral(u"no entry"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6AB"),
        QStringLiteral(u"prohibited"),
        QStringLiteral(u"prohibited"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6B3"),
        QStringLiteral(u"no_bicycles"),
        QStringLiteral(u"no bicycles"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6AD"),
        QStringLiteral(u"no_smoking"),
        QStringLiteral(u"no smoking"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6AF"),
        QStringLiteral(u"no_littering"),
        QStringLiteral(u"no littering"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6B1"),
        QStringLiteral(u"non_potable_water"),
        QStringLiteral(u"non-potable water"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6B7"),
        QStringLiteral(u"no_pedestrians"),
        QStringLiteral(u"no pedestrians"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4F5"),
        QStringLiteral(u"no_mobile_phones"),
        QStringLiteral(u"no mobile phones"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F51E"),
        QStringLiteral(u"no_one_under_eighteen"),
        QStringLiteral(u"no one under eighteen"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002622\U0000FE0F"),
        QStringLiteral(u"radioactive"),
        QStringLiteral(u"radioactive"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002623\U0000FE0F"),
        QStringLiteral(u"biohazard"),
        QStringLiteral(u"biohazard"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002B06\U0000FE0F"),
        QStringLiteral(u"up_arrow"),
        QStringLiteral(u"up arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002197\U0000FE0F"),
        QStringLiteral(u"up_right_arrow"),
        QStringLiteral(u"up-right arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000027A1\U0000FE0F"),
        QStringLiteral(u"right_arrow"),
        QStringLiteral(u"right arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002198\U0000FE0F"),
        QStringLiteral(u"down_right_arrow"),
        QStringLiteral(u"down-right arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002B07\U0000FE0F"),
        QStringLiteral(u"down_arrow"),
        QStringLiteral(u"down arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002199\U0000FE0F"),
        QStringLiteral(u"down_left_arrow"),
        QStringLiteral(u"down-left arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002B05\U0000FE0F"),
        QStringLiteral(u"left_arrow"),
        QStringLiteral(u"left arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002196\U0000FE0F"),
        QStringLiteral(u"up_left_arrow"),
        QStringLiteral(u"up-left arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002195\U0000FE0F"),
        QStringLiteral(u"up_down_arrow"),
        QStringLiteral(u"up-down arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002194\U0000FE0F"),
        QStringLiteral(u"left_right_arrow"),
        QStringLiteral(u"left-right arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000021A9\U0000FE0F"),
        QStringLiteral(u"right_arrow_curving_left"),
        QStringLiteral(u"right arrow curving left"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000021AA\U0000FE0F"),
        QStringLiteral(u"left_arrow_curving_right"),
        QStringLiteral(u"left arrow curving right"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002934\U0000FE0F"),
        QStringLiteral(u"right_arrow_curving_up"),
        QStringLiteral(u"right arrow curving up"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002935\U0000FE0F"),
        QStringLiteral(u"right_arrow_curving_down"),
        QStringLiteral(u"right arrow curving down"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F503"),
        QStringLiteral(u"clockwise_vertical_arrows"),
        QStringLiteral(u"clockwise vertical arrows"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F504"),
        QStringLiteral(u"counterclockwise_arrows"),
        QStringLiteral(u"counterclockwise arrows button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F519"),
        QStringLiteral(u"back_arrow"),
        QStringLiteral(u"BACK arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F51A"),
        QStringLiteral(u"end_arrow"),
        QStringLiteral(u"END arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F51B"),
        QStringLiteral(u"on_arrow"),
        QStringLiteral(u"ON! arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F51C"),
        QStringLiteral(u"soon_arrow"),
        QStringLiteral(u"SOON arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F51D"),
        QStringLiteral(u"top_arrow"),
        QStringLiteral(u"TOP arrow"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6D0"),
        QStringLiteral(u"place_of_worship"),
        QStringLiteral(u"place of worship"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000269B\U0000FE0F"),
        QStringLiteral(u"atom_symbol"),
        QStringLiteral(u"atom symbol"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F549\U0000FE0F"),
        QStringLiteral(u"om"),
        QStringLiteral(u"om"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002721\U0000FE0F"),
        QStringLiteral(u"star_of_david"),
        QStringLiteral(u"star of David"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002638\U0000FE0F"),
        QStringLiteral(u"wheel_of_dharma"),
        QStringLiteral(u"wheel of dharma"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000262F\U0000FE0F"),
        QStringLiteral(u"yin_yang"),
        QStringLiteral(u"yin yang"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000271D\U0000FE0F"),
        QStringLiteral(u"latin_cross"),
        QStringLiteral(u"latin cross"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002626\U0000FE0F"),
        QStringLiteral(u"orthodox_cross"),
        QStringLiteral(u"orthodox cross"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000262A\U0000FE0F"),
        QStringLiteral(u"star_and_crescent"),
        QStringLiteral(u"star and crescent"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000262E\U0000FE0F"),
        QStringLiteral(u"peace_symbol"),
        QStringLiteral(u"peace symbol"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F54E"),
        QStringLiteral(u"menorah"),
        QStringLiteral(u"menorah"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F52F"),
        QStringLiteral(u"dotted_six_pointed_star"),
        QStringLiteral(u"dotted six-pointed star"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001FAAF"),
        QStringLiteral(u"khanda"),
        QStringLiteral(u"khanda"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002648"),
        QStringLiteral(u"aries"),
        QStringLiteral(u"Aries"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002649"),
        QStringLiteral(u"taurus"),
        QStringLiteral(u"Taurus"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000264A"),
        QStringLiteral(u"gemini"),
        QStringLiteral(u"Gemini"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000264B"),
        QStringLiteral(u"cancer"),
        QStringLiteral(u"Cancer"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000264C"),
        QStringLiteral(u"leo"),
        QStringLiteral(u"Leo"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000264D"),
        QStringLiteral(u"virgo"),
        QStringLiteral(u"Virgo"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000264E"),
        QStringLiteral(u"libra"),
        QStringLiteral(u"Libra"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000264F"),
        QStringLiteral(u"scorpio"),
        QStringLiteral(u"Scorpio"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002650"),
        QStringLiteral(u"sagittarius"),
        QStringLiteral(u"Sagittarius"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002651"),
        QStringLiteral(u"capricorn"),
        QStringLiteral(u"Capricorn"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002652"),
        QStringLiteral(u"aquarius"),
        QStringLiteral(u"Aquarius"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002653"),
        QStringLiteral(u"pisces"),
        QStringLiteral(u"Pisces"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000026CE"),
        QStringLiteral(u"ophiuchus"),
        QStringLiteral(u"Ophiuchus"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F500"),
        QStringLiteral(u"shuffle_tracks"),
        QStringLiteral(u"shuffle tracks button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F501"),
        QStringLiteral(u"repeat"),
        QStringLiteral(u"repeat button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F502"),
        QStringLiteral(u"repeat_single"),
        QStringLiteral(u"repeat single button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025B6\U0000FE0F"),
        QStringLiteral(u"play"),
        QStringLiteral(u"play button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023E9"),
        QStringLiteral(u"fast_forward"),
        QStringLiteral(u"fast-forward button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023ED\U0000FE0F"),
        QStringLiteral(u"next_track"),
        QStringLiteral(u"next track button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023EF\U0000FE0F"),
        QStringLiteral(u"play_or_pause"),
        QStringLiteral(u"play or pause button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025C0\U0000FE0F"),
        QStringLiteral(u"reverse"),
        QStringLiteral(u"reverse button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023EA"),
        QStringLiteral(u"fast_reverse"),
        QStringLiteral(u"fast reverse button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023EE\U0000FE0F"),
        QStringLiteral(u"last_track"),
        QStringLiteral(u"last track button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F53C"),
        QStringLiteral(u"upwards"),
        QStringLiteral(u"upwards button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023EB"),
        QStringLiteral(u"fast_up"),
        QStringLiteral(u"fast up button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F53D"),
        QStringLiteral(u"downwards"),
        QStringLiteral(u"downwards button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023EC"),
        QStringLiteral(u"fast_down"),
        QStringLiteral(u"fast down button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023F8\U0000FE0F"),
        QStringLiteral(u"pause"),
        QStringLiteral(u"pause button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023F9\U0000FE0F"),
        QStringLiteral(u"stop"),
        QStringLiteral(u"stop button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023FA\U0000FE0F"),
        QStringLiteral(u"record"),
        QStringLiteral(u"record button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000023CF\U0000FE0F"),
        QStringLiteral(u"eject"),
        QStringLiteral(u"eject button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F3A6"),
        QStringLiteral(u"cinema"),
        QStringLiteral(u"cinema"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F505"),
        QStringLiteral(u"dim"),
        QStringLiteral(u"dim button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F506"),
        QStringLiteral(u"bright"),
        QStringLiteral(u"bright button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4F6"),
        QStringLiteral(u"antenna_bars"),
        QStringLiteral(u"antenna bars"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F6DC"),
        QStringLiteral(u"wireless"),
        QStringLiteral(u"wireless"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4F3"),
        QStringLiteral(u"vibration_mode"),
        QStringLiteral(u"vibration mode"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4F4"),
        QStringLiteral(u"mobile_phone_off"),
        QStringLiteral(u"mobile phone off"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002640\U0000FE0F"),
        QStringLiteral(u"female_sign"),
        QStringLiteral(u"female sign"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002642\U0000FE0F"),
        QStringLiteral(u"male_sign"),
        QStringLiteral(u"male sign"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000026A7\U0000FE0F"),
        QStringLiteral(u"transgender_symbol"),
        QStringLiteral(u"transgender symbol"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002716\U0000FE0F"),
        QStringLiteral(u"multiply"),
        QStringLiteral(u"multiply"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002795"),
        QStringLiteral(u"plus"),
        QStringLiteral(u"plus"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002796"),
        QStringLiteral(u"minus"),
        QStringLiteral(u"minus"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002797"),
        QStringLiteral(u"divide"),
        QStringLiteral(u"divide"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7F0"),
        QStringLiteral(u"heavy_equals_sign"),
        QStringLiteral(u"heavy equals sign"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000267E\U0000FE0F"),
        QStringLiteral(u"infinity"),
        QStringLiteral(u"infinity"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000203C\U0000FE0F"),
        QStringLiteral(u"bangbang"),
        QStringLiteral(u"double exclamation mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002049\U0000FE0F"),
        QStringLiteral(u"interrobang"),
        QStringLiteral(u"exclamation question mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002753"),
        QStringLiteral(u"question"),
        QStringLiteral(u"red question mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002754"),
        QStringLiteral(u"white_question"),
        QStringLiteral(u"white question mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002755"),
        QStringLiteral(u"white_exclamation"),
        QStringLiteral(u"white exclamation mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002757"),
        QStringLiteral(u"exclamation"),
        QStringLiteral(u"red exclamation mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00003030\U0000FE0F"),
        QStringLiteral(u"wavy_dash"),
        QStringLiteral(u"wavy dash"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4B1"),
        QStringLiteral(u"currency_exchange"),
        QStringLiteral(u"currency exchange"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4B2"),
        QStringLiteral(u"heavy_dollar_sign"),
        QStringLiteral(u"heavy dollar sign"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002695\U0000FE0F"),
        QStringLiteral(u"medical_symbol"),
        QStringLiteral(u"medical symbol"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000267B\U0000FE0F"),
        QStringLiteral(u"recycling_symbol"),
        QStringLiteral(u"recycling symbol"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000269C\U0000FE0F"),
        QStringLiteral(u"fleur_de_lis"),
        QStringLiteral(u"fleur-de-lis"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F531"),
        QStringLiteral(u"trident_emblem"),
        QStringLiteral(u"trident emblem"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4DB"),
        QStringLiteral(u"name_badge"),
        QStringLiteral(u"name badge"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F530"),
        QStringLiteral(u"japanese_symbol_for_beginner"),
        QStringLiteral(u"Japanese symbol for beginner"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002B55"),
        QStringLiteral(u"hollow_red_circle"),
        QStringLiteral(u"hollow red circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002705"),
        QStringLiteral(u"check_mark"),
        QStringLiteral(u"check mark button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002611\U0000FE0F"),
        QStringLiteral(u"check_box_with_check"),
        QStringLiteral(u"check box with check"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002714\U0000FE0F"),
        QStringLiteral(u"check_mark"),
        QStringLiteral(u"check mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000274C"),
        QStringLiteral(u"cross_mark"),
        QStringLiteral(u"cross mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000274E"),
        QStringLiteral(u"cross_mark"),
        QStringLiteral(u"cross mark button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000027B0"),
        QStringLiteral(u"curly_loop"),
        QStringLiteral(u"curly loop"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000027BF"),
        QStringLiteral(u"double_curly_loop"),
        QStringLiteral(u"double curly loop"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000303D\U0000FE0F"),
        QStringLiteral(u"part_alternation_mark"),
        QStringLiteral(u"part alternation mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002733\U0000FE0F"),
        QStringLiteral(u"eight_spoked_asterisk"),
        QStringLiteral(u"eight-spoked asterisk"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002734\U0000FE0F"),
        QStringLiteral(u"eight_pointed_star"),
        QStringLiteral(u"eight-pointed star"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002747\U0000FE0F"),
        QStringLiteral(u"sparkle"),
        QStringLiteral(u"sparkle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000000A9\U0000FE0F"),
        QStringLiteral(u"copyright"),
        QStringLiteral(u"copyright"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000000AE\U0000FE0F"),
        QStringLiteral(u"registered"),
        QStringLiteral(u"registered"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002122\U0000FE0F"),
        QStringLiteral(u"trade_mark"),
        QStringLiteral(u"trade mark"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000023\U0000FE0F\U000020E3"),
        QStringLiteral(u"hash"),
        QStringLiteral(u"keycap: #"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0000002A\U0000FE0F\U000020E3"),
        QStringLiteral(u"asterisk"),
        QStringLiteral(u"keycap: *"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000030\U0000FE0F\U000020E3"),
        QStringLiteral(u"zero"),
        QStringLiteral(u"keycap: 0"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000031\U0000FE0F\U000020E3"),
        QStringLiteral(u"one"),
        QStringLiteral(u"keycap: 1"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000032\U0000FE0F\U000020E3"),
        QStringLiteral(u"two"),
        QStringLiteral(u"keycap: 2"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000033\U0000FE0F\U000020E3"),
        QStringLiteral(u"three"),
        QStringLiteral(u"keycap: 3"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000034\U0000FE0F\U000020E3"),
        QStringLiteral(u"four"),
        QStringLiteral(u"keycap: 4"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000035\U0000FE0F\U000020E3"),
        QStringLiteral(u"five"),
        QStringLiteral(u"keycap: 5"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000036\U0000FE0F\U000020E3"),
        QStringLiteral(u"six"),
        QStringLiteral(u"keycap: 6"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000037\U0000FE0F\U000020E3"),
        QStringLiteral(u"seven"),
        QStringLiteral(u"keycap: 7"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000038\U0000FE0F\U000020E3"),
        QStringLiteral(u"eight"),
        QStringLiteral(u"keycap: 8"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00000039\U0000FE0F\U000020E3"),
        QStringLiteral(u"nine"),
        QStringLiteral(u"keycap: 9"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F51F"),
        QStringLiteral(u"ten"),
        QStringLiteral(u"keycap: 10"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F520"),
        QStringLiteral(u"big_abcd"),
        QStringLiteral(u"input latin uppercase"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F521"),
        QStringLiteral(u"abcd"),
        QStringLiteral(u"input latin lowercase"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F522"),
        QStringLiteral(u"1234"),
        QStringLiteral(u"input numbers"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F523"),
        QStringLiteral(u"symbols"),
        QStringLiteral(u"input symbols"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F524"),
        QStringLiteral(u"abc"),
        QStringLiteral(u"input latin letters"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F170\U0000FE0F"),
        QStringLiteral(u"a"),
        QStringLiteral(u"A button (blood type)"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F18E"),
        QStringLiteral(u"ab"),
        QStringLiteral(u"AB button (blood type)"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F171\U0000FE0F"),
        QStringLiteral(u"b"),
        QStringLiteral(u"B button (blood type)"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F191"),
        QStringLiteral(u"cl"),
        QStringLiteral(u"CL button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F192"),
        QStringLiteral(u"cool"),
        QStringLiteral(u"COOL button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F193"),
        QStringLiteral(u"free"),
        QStringLiteral(u"FREE button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002139\U0000FE0F"),
        QStringLiteral(u"information"),
        QStringLiteral(u"information"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F194"),
        QStringLiteral(u"id"),
        QStringLiteral(u"ID button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000024C2\U0000FE0F"),
        QStringLiteral(u"circled_m"),
        QStringLiteral(u"circled M"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F195"),
        QStringLiteral(u"new"),
        QStringLiteral(u"NEW button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F196"),
        QStringLiteral(u"ng"),
        QStringLiteral(u"NG button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F17E\U0000FE0F"),
        QStringLiteral(u"o"),
        QStringLiteral(u"O button (blood type)"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F197"),
        QStringLiteral(u"ok"),
        QStringLiteral(u"OK button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F17F\U0000FE0F"),
        QStringLiteral(u"p"),
        QStringLiteral(u"P button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F198"),
        QStringLiteral(u"sos"),
        QStringLiteral(u"SOS button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F199"),
        QStringLiteral(u"up_"),
        QStringLiteral(u"UP! button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F19A"),
        QStringLiteral(u"vs"),
        QStringLiteral(u"VS button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F201"),
        QStringLiteral(u"japanese_here_"),
        QStringLiteral(u"Japanese “here” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F202\U0000FE0F"),
        QStringLiteral(u"japanese_service_charge_"),
        QStringLiteral(u"Japanese “service charge” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F237\U0000FE0F"),
        QStringLiteral(u"japanese_monthly_amount_"),
        QStringLiteral(u"Japanese “monthly amount” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F236"),
        QStringLiteral(u"japanese_not_free_of_charge_"),
        QStringLiteral(u"Japanese “not free of charge” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F22F"),
        QStringLiteral(u"japanese_reserved_"),
        QStringLiteral(u"Japanese “reserved” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F250"),
        QStringLiteral(u"japanese_bargain_"),
        QStringLiteral(u"Japanese “bargain” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F239"),
        QStringLiteral(u"japanese_discount_"),
        QStringLiteral(u"Japanese “discount” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F21A"),
        QStringLiteral(u"japanese_free_of_charge_"),
        QStringLiteral(u"Japanese “free of charge” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F232"),
        QStringLiteral(u"japanese_prohibited_"),
        QStringLiteral(u"Japanese “prohibited” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F251"),
        QStringLiteral(u"japanese_acceptable_"),
        QStringLiteral(u"Japanese “acceptable” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F238"),
        QStringLiteral(u"japanese_application_"),
        QStringLiteral(u"Japanese “application” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F234"),
        QStringLiteral(u"japanese_passing_grade_"),
        QStringLiteral(u"Japanese “passing grade” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F233"),
        QStringLiteral(u"japanese_vacancy_"),
        QStringLiteral(u"Japanese “vacancy” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00003297\U0000FE0F"),
        QStringLiteral(u"japanese_congratulations_"),
        QStringLiteral(u"Japanese “congratulations” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00003299\U0000FE0F"),
        QStringLiteral(u"japanese_secret_"),
        QStringLiteral(u"Japanese “secret” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F23A"),
        QStringLiteral(u"japanese_open_for_business_"),
        QStringLiteral(u"Japanese “open for business” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F235"),
        QStringLiteral(u"japanese_no_vacancy_"),
        QStringLiteral(u"Japanese “no vacancy” button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F534"),
        QStringLiteral(u"red_circle"),
        QStringLiteral(u"red circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E0"),
        QStringLiteral(u"orange_circle"),
        QStringLiteral(u"orange circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E1"),
        QStringLiteral(u"yellow_circle"),
        QStringLiteral(u"yellow circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E2"),
        QStringLiteral(u"green_circle"),
        QStringLiteral(u"green circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F535"),
        QStringLiteral(u"blue_circle"),
        QStringLiteral(u"blue circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E3"),
        QStringLiteral(u"purple_circle"),
        QStringLiteral(u"purple circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E4"),
        QStringLiteral(u"brown_circle"),
        QStringLiteral(u"brown circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000026AB"),
        QStringLiteral(u"black_circle"),
        QStringLiteral(u"black circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000026AA"),
        QStringLiteral(u"white_circle"),
        QStringLiteral(u"white circle"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E5"),
        QStringLiteral(u"red_square"),
        QStringLiteral(u"red square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E7"),
        QStringLiteral(u"orange_square"),
        QStringLiteral(u"orange square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E8"),
        QStringLiteral(u"yellow_square"),
        QStringLiteral(u"yellow square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E9"),
        QStringLiteral(u"green_square"),
        QStringLiteral(u"green square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7E6"),
        QStringLiteral(u"blue_square"),
        QStringLiteral(u"blue square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7EA"),
        QStringLiteral(u"purple_square"),
        QStringLiteral(u"purple square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F7EB"),
        QStringLiteral(u"brown_square"),
        QStringLiteral(u"brown square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002B1B"),
        QStringLiteral(u"black_large_square"),
        QStringLiteral(u"black large square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U00002B1C"),
        QStringLiteral(u"white_large_square"),
        QStringLiteral(u"white large square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025FC\U0000FE0F"),
        QStringLiteral(u"black_medium_square"),
        QStringLiteral(u"black medium square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025FB\U0000FE0F"),
        QStringLiteral(u"white_medium_square"),
        QStringLiteral(u"white medium square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025FE"),
        QStringLiteral(u"black_medium_small_square"),
        QStringLiteral(u"black medium-small square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025FD"),
        QStringLiteral(u"white_medium_small_square"),
        QStringLiteral(u"white medium-small square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025AA\U0000FE0F"),
        QStringLiteral(u"black_small_square"),
        QStringLiteral(u"black small square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U000025AB\U0000FE0F"),
        QStringLiteral(u"white_small_square"),
        QStringLiteral(u"white small square"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F536"),
        QStringLiteral(u"large_orange_diamond"),
        QStringLiteral(u"large orange diamond"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F537"),
        QStringLiteral(u"large_blue_diamond"),
        QStringLiteral(u"large blue diamond"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F538"),
        QStringLiteral(u"small_orange_diamond"),
        QStringLiteral(u"small orange diamond"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F539"),
        QStringLiteral(u"small_blue_diamond"),
        QStringLiteral(u"small blue diamond"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F53A"),
        QStringLiteral(u"red_triangle_pointed_up"),
        QStringLiteral(u"red triangle pointed up"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F53B"),
        QStringLiteral(u"red_triangle_pointed_down"),
        QStringLiteral(u"red triangle pointed down"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F4A0"),
        QStringLiteral(u"diamond_with_a_dot"),
        QStringLiteral(u"diamond with a dot"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F518"),
        QStringLiteral(u"radio"),
        QStringLiteral(u"radio button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F533"),
        QStringLiteral(u"white_square"),
        QStringLiteral(u"white square button"),
        emoji::Emoji::Category::Symbols},
  Emoji{QStringLiteral(u"\U0001F532"),
        QStringLiteral(u"black_square"),
        QStringLiteral(u"black square button"),
        emoji::Emoji::Category::Symbols},
  // Flags
  Emoji{QStringLiteral(u"\U0001F3C1"),
        QStringLiteral(u"chequered_flag"),
        QStringLiteral(u"chequered flag"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F6A9"),
        QStringLiteral(u"triangular_flag"),
        QStringLiteral(u"triangular flag"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F38C"),
        QStringLiteral(u"crossed_flags"),
        QStringLiteral(u"crossed flags"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F4"),
        QStringLiteral(u"black_flag"),
        QStringLiteral(u"black flag"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F3\U0000FE0F"),
        QStringLiteral(u"white_flag"),
        QStringLiteral(u"white flag"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F3\U0000FE0F\U0000200D\U0001F308"),
        QStringLiteral(u"rainbow_flag"),
        QStringLiteral(u"rainbow flag"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F3\U0000FE0F\U0000200D\U000026A7\U0000FE0F"),
        QStringLiteral(u"transgender_flag"),
        QStringLiteral(u"transgender flag"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F4\U0000200D\U00002620\U0000FE0F"),
        QStringLiteral(u"pirate_flag"),
        QStringLiteral(u"pirate flag"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1E8"),
        QStringLiteral(u"ascension_island_flag"),
        QStringLiteral(u"flag: Ascension Island"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1E9"),
        QStringLiteral(u"andorra_flag"),
        QStringLiteral(u"flag: Andorra"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1EA"),
        QStringLiteral(u"united_arab_emirates_flag"),
        QStringLiteral(u"flag: United Arab Emirates"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1EB"),
        QStringLiteral(u"afghanistan_flag"),
        QStringLiteral(u"flag: Afghanistan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1EC"),
        QStringLiteral(u"antigua_and_barbuda_flag"),
        QStringLiteral(u"flag: Antigua & Barbuda"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1EE"),
        QStringLiteral(u"anguilla_flag"),
        QStringLiteral(u"flag: Anguilla"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1F1"),
        QStringLiteral(u"albania_flag"),
        QStringLiteral(u"flag: Albania"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1F2"),
        QStringLiteral(u"armenia_flag"),
        QStringLiteral(u"flag: Armenia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1F4"),
        QStringLiteral(u"angola_flag"),
        QStringLiteral(u"flag: Angola"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1F6"),
        QStringLiteral(u"antarctica_flag"),
        QStringLiteral(u"flag: Antarctica"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1F7"),
        QStringLiteral(u"argentina_flag"),
        QStringLiteral(u"flag: Argentina"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1F8"),
        QStringLiteral(u"american_samoa_flag"),
        QStringLiteral(u"flag: American Samoa"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1F9"),
        QStringLiteral(u"austria_flag"),
        QStringLiteral(u"flag: Austria"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1FA"),
        QStringLiteral(u"australia_flag"),
        QStringLiteral(u"flag: Australia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1FC"),
        QStringLiteral(u"aruba_flag"),
        QStringLiteral(u"flag: Aruba"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1FD"),
        QStringLiteral(u"aland_islands_flag"),
        QStringLiteral(u"flag: Åland Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E6\U0001F1FF"),
        QStringLiteral(u"azerbaijan_flag"),
        QStringLiteral(u"flag: Azerbaijan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1E6"),
        QStringLiteral(u"bosnia_and_herzegovina_flag"),
        QStringLiteral(u"flag: Bosnia & Herzegovina"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1E7"),
        QStringLiteral(u"barbados_flag"),
        QStringLiteral(u"flag: Barbados"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1E9"),
        QStringLiteral(u"bangladesh_flag"),
        QStringLiteral(u"flag: Bangladesh"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1EA"),
        QStringLiteral(u"belgium_flag"),
        QStringLiteral(u"flag: Belgium"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1EB"),
        QStringLiteral(u"burkina_faso_flag"),
        QStringLiteral(u"flag: Burkina Faso"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1EC"),
        QStringLiteral(u"bulgaria_flag"),
        QStringLiteral(u"flag: Bulgaria"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1ED"),
        QStringLiteral(u"bahrain_flag"),
        QStringLiteral(u"flag: Bahrain"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1EE"),
        QStringLiteral(u"burundi_flag"),
        QStringLiteral(u"flag: Burundi"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1EF"),
        QStringLiteral(u"benin_flag"),
        QStringLiteral(u"flag: Benin"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F1"),
        QStringLiteral(u"st_barthelemy_flag"),
        QStringLiteral(u"flag: St. Barthélemy"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F2"),
        QStringLiteral(u"bermuda_flag"),
        QStringLiteral(u"flag: Bermuda"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F3"),
        QStringLiteral(u"brunei_flag"),
        QStringLiteral(u"flag: Brunei"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F4"),
        QStringLiteral(u"bolivia_flag"),
        QStringLiteral(u"flag: Bolivia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F6"),
        QStringLiteral(u"caribbean_netherlands_flag"),
        QStringLiteral(u"flag: Caribbean Netherlands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F7"),
        QStringLiteral(u"brazil_flag"),
        QStringLiteral(u"flag: Brazil"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F8"),
        QStringLiteral(u"bahamas_flag"),
        QStringLiteral(u"flag: Bahamas"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1F9"),
        QStringLiteral(u"bhutan_flag"),
        QStringLiteral(u"flag: Bhutan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1FB"),
        QStringLiteral(u"bouvet_island_flag"),
        QStringLiteral(u"flag: Bouvet Island"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1FC"),
        QStringLiteral(u"botswana_flag"),
        QStringLiteral(u"flag: Botswana"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1FE"),
        QStringLiteral(u"belarus_flag"),
        QStringLiteral(u"flag: Belarus"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E7\U0001F1FF"),
        QStringLiteral(u"belize_flag"),
        QStringLiteral(u"flag: Belize"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1E6"),
        QStringLiteral(u"canada_flag"),
        QStringLiteral(u"flag: Canada"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1E8"),
        QStringLiteral(u"cocos_keeling_islands_flag"),
        QStringLiteral(u"flag: Cocos (Keeling) Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1E9"),
        QStringLiteral(u"congo_kinshasa_flag"),
        QStringLiteral(u"flag: Congo - Kinshasa"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1EB"),
        QStringLiteral(u"central_african_republic_flag"),
        QStringLiteral(u"flag: Central African Republic"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1EC"),
        QStringLiteral(u"congo_brazzaville_flag"),
        QStringLiteral(u"flag: Congo - Brazzaville"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1ED"),
        QStringLiteral(u"switzerland_flag"),
        QStringLiteral(u"flag: Switzerland"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1EE"),
        QStringLiteral(u"cote_d_ivoire_flag"),
        QStringLiteral(u"flag: Côte d’Ivoire"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1F0"),
        QStringLiteral(u"cook_islands_flag"),
        QStringLiteral(u"flag: Cook Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1F1"),
        QStringLiteral(u"chile_flag"),
        QStringLiteral(u"flag: Chile"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1F2"),
        QStringLiteral(u"cameroon_flag"),
        QStringLiteral(u"flag: Cameroon"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1F3"),
        QStringLiteral(u"china_flag"),
        QStringLiteral(u"flag: China"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1F4"),
        QStringLiteral(u"colombia_flag"),
        QStringLiteral(u"flag: Colombia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1F5"),
        QStringLiteral(u"clipperton_island_flag"),
        QStringLiteral(u"flag: Clipperton Island"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1F7"),
        QStringLiteral(u"costa_rica_flag"),
        QStringLiteral(u"flag: Costa Rica"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1FA"),
        QStringLiteral(u"cuba_flag"),
        QStringLiteral(u"flag: Cuba"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1FB"),
        QStringLiteral(u"cape_verde_flag"),
        QStringLiteral(u"flag: Cape Verde"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1FC"),
        QStringLiteral(u"curacao_flag"),
        QStringLiteral(u"flag: Curaçao"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1FD"),
        QStringLiteral(u"christmas_island_flag"),
        QStringLiteral(u"flag: Christmas Island"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1FE"),
        QStringLiteral(u"cyprus_flag"),
        QStringLiteral(u"flag: Cyprus"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E8\U0001F1FF"),
        QStringLiteral(u"czechia_flag"),
        QStringLiteral(u"flag: Czechia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E9\U0001F1EA"),
        QStringLiteral(u"germany_flag"),
        QStringLiteral(u"flag: Germany"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E9\U0001F1EC"),
        QStringLiteral(u"diego_garcia_flag"),
        QStringLiteral(u"flag: Diego Garcia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E9\U0001F1EF"),
        QStringLiteral(u"djibouti_flag"),
        QStringLiteral(u"flag: Djibouti"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E9\U0001F1F0"),
        QStringLiteral(u"denmark_flag"),
        QStringLiteral(u"flag: Denmark"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E9\U0001F1F2"),
        QStringLiteral(u"dominica_flag"),
        QStringLiteral(u"flag: Dominica"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E9\U0001F1F4"),
        QStringLiteral(u"dominican_republic_flag"),
        QStringLiteral(u"flag: Dominican Republic"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1E9\U0001F1FF"),
        QStringLiteral(u"algeria_flag"),
        QStringLiteral(u"flag: Algeria"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1E6"),
        QStringLiteral(u"ceuta_and_melilla_flag"),
        QStringLiteral(u"flag: Ceuta & Melilla"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1E8"),
        QStringLiteral(u"ecuador_flag"),
        QStringLiteral(u"flag: Ecuador"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1EA"),
        QStringLiteral(u"estonia_flag"),
        QStringLiteral(u"flag: Estonia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1EC"),
        QStringLiteral(u"egypt_flag"),
        QStringLiteral(u"flag: Egypt"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1ED"),
        QStringLiteral(u"western_sahara_flag"),
        QStringLiteral(u"flag: Western Sahara"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1F7"),
        QStringLiteral(u"eritrea_flag"),
        QStringLiteral(u"flag: Eritrea"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1F8"),
        QStringLiteral(u"spain_flag"),
        QStringLiteral(u"flag: Spain"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1F9"),
        QStringLiteral(u"ethiopia_flag"),
        QStringLiteral(u"flag: Ethiopia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EA\U0001F1FA"),
        QStringLiteral(u"european_union_flag"),
        QStringLiteral(u"flag: European Union"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EB\U0001F1EE"),
        QStringLiteral(u"finland_flag"),
        QStringLiteral(u"flag: Finland"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EB\U0001F1EF"),
        QStringLiteral(u"fiji_flag"),
        QStringLiteral(u"flag: Fiji"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EB\U0001F1F0"),
        QStringLiteral(u"falkland_islands_flag"),
        QStringLiteral(u"flag: Falkland Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EB\U0001F1F2"),
        QStringLiteral(u"micronesia_flag"),
        QStringLiteral(u"flag: Micronesia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EB\U0001F1F4"),
        QStringLiteral(u"faroe_islands_flag"),
        QStringLiteral(u"flag: Faroe Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EB\U0001F1F7"),
        QStringLiteral(u"france_flag"),
        QStringLiteral(u"flag: France"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1E6"),
        QStringLiteral(u"gabon_flag"),
        QStringLiteral(u"flag: Gabon"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1E7"),
        QStringLiteral(u"united_kingdom_flag"),
        QStringLiteral(u"flag: United Kingdom"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1E9"),
        QStringLiteral(u"grenada_flag"),
        QStringLiteral(u"flag: Grenada"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1EA"),
        QStringLiteral(u"georgia_flag"),
        QStringLiteral(u"flag: Georgia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1EB"),
        QStringLiteral(u"french_guiana_flag"),
        QStringLiteral(u"flag: French Guiana"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1EC"),
        QStringLiteral(u"guernsey_flag"),
        QStringLiteral(u"flag: Guernsey"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1ED"),
        QStringLiteral(u"ghana_flag"),
        QStringLiteral(u"flag: Ghana"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1EE"),
        QStringLiteral(u"gibraltar_flag"),
        QStringLiteral(u"flag: Gibraltar"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F1"),
        QStringLiteral(u"greenland_flag"),
        QStringLiteral(u"flag: Greenland"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F2"),
        QStringLiteral(u"gambia_flag"),
        QStringLiteral(u"flag: Gambia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F3"),
        QStringLiteral(u"guinea_flag"),
        QStringLiteral(u"flag: Guinea"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F5"),
        QStringLiteral(u"guadeloupe_flag"),
        QStringLiteral(u"flag: Guadeloupe"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F6"),
        QStringLiteral(u"equatorial_guinea_flag"),
        QStringLiteral(u"flag: Equatorial Guinea"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F7"),
        QStringLiteral(u"greece_flag"),
        QStringLiteral(u"flag: Greece"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F8"),
        QStringLiteral(u"south_georgia_and_south_sandwich_islands_flag"),
        QStringLiteral(u"flag: South Georgia & South Sandwich Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1F9"),
        QStringLiteral(u"guatemala_flag"),
        QStringLiteral(u"flag: Guatemala"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1FA"),
        QStringLiteral(u"guam_flag"),
        QStringLiteral(u"flag: Guam"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1FC"),
        QStringLiteral(u"guinea_bissau_flag"),
        QStringLiteral(u"flag: Guinea-Bissau"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EC\U0001F1FE"),
        QStringLiteral(u"guyana_flag"),
        QStringLiteral(u"flag: Guyana"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1ED\U0001F1F0"),
        QStringLiteral(u"hong_kong_sar_china_flag"),
        QStringLiteral(u"flag: Hong Kong SAR China"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1ED\U0001F1F2"),
        QStringLiteral(u"heard_and_mcdonald_islands_flag"),
        QStringLiteral(u"flag: Heard & McDonald Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1ED\U0001F1F3"),
        QStringLiteral(u"honduras_flag"),
        QStringLiteral(u"flag: Honduras"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1ED\U0001F1F7"),
        QStringLiteral(u"croatia_flag"),
        QStringLiteral(u"flag: Croatia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1ED\U0001F1F9"),
        QStringLiteral(u"haiti_flag"),
        QStringLiteral(u"flag: Haiti"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1ED\U0001F1FA"),
        QStringLiteral(u"hungary_flag"),
        QStringLiteral(u"flag: Hungary"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1E8"),
        QStringLiteral(u"canary_islands_flag"),
        QStringLiteral(u"flag: Canary Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1E9"),
        QStringLiteral(u"indonesia_flag"),
        QStringLiteral(u"flag: Indonesia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1EA"),
        QStringLiteral(u"ireland_flag"),
        QStringLiteral(u"flag: Ireland"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F1"),
        QStringLiteral(u"israel_flag"),
        QStringLiteral(u"flag: Israel"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F2"),
        QStringLiteral(u"isle_of_man_flag"),
        QStringLiteral(u"flag: Isle of Man"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F3"),
        QStringLiteral(u"india_flag"),
        QStringLiteral(u"flag: India"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F4"),
        QStringLiteral(u"british_indian_ocean_territory_flag"),
        QStringLiteral(u"flag: British Indian Ocean Territory"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F6"),
        QStringLiteral(u"iraq_flag"),
        QStringLiteral(u"flag: Iraq"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F7"),
        QStringLiteral(u"iran_flag"),
        QStringLiteral(u"flag: Iran"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F8"),
        QStringLiteral(u"iceland_flag"),
        QStringLiteral(u"flag: Iceland"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EE\U0001F1F9"),
        QStringLiteral(u"italy_flag"),
        QStringLiteral(u"flag: Italy"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EF\U0001F1EA"),
        QStringLiteral(u"jersey_flag"),
        QStringLiteral(u"flag: Jersey"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EF\U0001F1F2"),
        QStringLiteral(u"jamaica_flag"),
        QStringLiteral(u"flag: Jamaica"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EF\U0001F1F4"),
        QStringLiteral(u"jordan_flag"),
        QStringLiteral(u"flag: Jordan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1EF\U0001F1F5"),
        QStringLiteral(u"japan_flag"),
        QStringLiteral(u"flag: Japan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1EA"),
        QStringLiteral(u"kenya_flag"),
        QStringLiteral(u"flag: Kenya"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1EC"),
        QStringLiteral(u"kyrgyzstan_flag"),
        QStringLiteral(u"flag: Kyrgyzstan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1ED"),
        QStringLiteral(u"cambodia_flag"),
        QStringLiteral(u"flag: Cambodia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1EE"),
        QStringLiteral(u"kiribati_flag"),
        QStringLiteral(u"flag: Kiribati"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1F2"),
        QStringLiteral(u"comoros_flag"),
        QStringLiteral(u"flag: Comoros"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1F3"),
        QStringLiteral(u"st_kitts_and_nevis_flag"),
        QStringLiteral(u"flag: St. Kitts & Nevis"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1F5"),
        QStringLiteral(u"north_korea_flag"),
        QStringLiteral(u"flag: North Korea"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1F7"),
        QStringLiteral(u"south_korea_flag"),
        QStringLiteral(u"flag: South Korea"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1FC"),
        QStringLiteral(u"kuwait_flag"),
        QStringLiteral(u"flag: Kuwait"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1FE"),
        QStringLiteral(u"cayman_islands_flag"),
        QStringLiteral(u"flag: Cayman Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F0\U0001F1FF"),
        QStringLiteral(u"kazakhstan_flag"),
        QStringLiteral(u"flag: Kazakhstan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1E6"),
        QStringLiteral(u"laos_flag"),
        QStringLiteral(u"flag: Laos"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1E7"),
        QStringLiteral(u"lebanon_flag"),
        QStringLiteral(u"flag: Lebanon"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1E8"),
        QStringLiteral(u"st_lucia_flag"),
        QStringLiteral(u"flag: St. Lucia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1EE"),
        QStringLiteral(u"liechtenstein_flag"),
        QStringLiteral(u"flag: Liechtenstein"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1F0"),
        QStringLiteral(u"sri_lanka_flag"),
        QStringLiteral(u"flag: Sri Lanka"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1F7"),
        QStringLiteral(u"liberia_flag"),
        QStringLiteral(u"flag: Liberia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1F8"),
        QStringLiteral(u"lesotho_flag"),
        QStringLiteral(u"flag: Lesotho"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1F9"),
        QStringLiteral(u"lithuania_flag"),
        QStringLiteral(u"flag: Lithuania"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1FA"),
        QStringLiteral(u"luxembourg_flag"),
        QStringLiteral(u"flag: Luxembourg"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1FB"),
        QStringLiteral(u"latvia_flag"),
        QStringLiteral(u"flag: Latvia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F1\U0001F1FE"),
        QStringLiteral(u"libya_flag"),
        QStringLiteral(u"flag: Libya"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1E6"),
        QStringLiteral(u"morocco_flag"),
        QStringLiteral(u"flag: Morocco"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1E8"),
        QStringLiteral(u"monaco_flag"),
        QStringLiteral(u"flag: Monaco"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1E9"),
        QStringLiteral(u"moldova_flag"),
        QStringLiteral(u"flag: Moldova"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1EA"),
        QStringLiteral(u"montenegro_flag"),
        QStringLiteral(u"flag: Montenegro"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1EB"),
        QStringLiteral(u"st_martin_flag"),
        QStringLiteral(u"flag: St. Martin"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1EC"),
        QStringLiteral(u"madagascar_flag"),
        QStringLiteral(u"flag: Madagascar"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1ED"),
        QStringLiteral(u"marshall_islands_flag"),
        QStringLiteral(u"flag: Marshall Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F0"),
        QStringLiteral(u"north_macedonia_flag"),
        QStringLiteral(u"flag: North Macedonia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F1"),
        QStringLiteral(u"mali_flag"),
        QStringLiteral(u"flag: Mali"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F2"),
        QStringLiteral(u"myanmar_burma_flag"),
        QStringLiteral(u"flag: Myanmar (Burma)"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F3"),
        QStringLiteral(u"mongolia_flag"),
        QStringLiteral(u"flag: Mongolia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F4"),
        QStringLiteral(u"macao_sar_china_flag"),
        QStringLiteral(u"flag: Macao SAR China"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F5"),
        QStringLiteral(u"northern_mariana_islands_flag"),
        QStringLiteral(u"flag: Northern Mariana Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F6"),
        QStringLiteral(u"martinique_flag"),
        QStringLiteral(u"flag: Martinique"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F7"),
        QStringLiteral(u"mauritania_flag"),
        QStringLiteral(u"flag: Mauritania"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F8"),
        QStringLiteral(u"montserrat_flag"),
        QStringLiteral(u"flag: Montserrat"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1F9"),
        QStringLiteral(u"malta_flag"),
        QStringLiteral(u"flag: Malta"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1FA"),
        QStringLiteral(u"mauritius_flag"),
        QStringLiteral(u"flag: Mauritius"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1FB"),
        QStringLiteral(u"maldives_flag"),
        QStringLiteral(u"flag: Maldives"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1FC"),
        QStringLiteral(u"malawi_flag"),
        QStringLiteral(u"flag: Malawi"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1FD"),
        QStringLiteral(u"mexico_flag"),
        QStringLiteral(u"flag: Mexico"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1FE"),
        QStringLiteral(u"malaysia_flag"),
        QStringLiteral(u"flag: Malaysia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F2\U0001F1FF"),
        QStringLiteral(u"mozambique_flag"),
        QStringLiteral(u"flag: Mozambique"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1E6"),
        QStringLiteral(u"namibia_flag"),
        QStringLiteral(u"flag: Namibia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1E8"),
        QStringLiteral(u"new_caledonia_flag"),
        QStringLiteral(u"flag: New Caledonia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1EA"),
        QStringLiteral(u"niger_flag"),
        QStringLiteral(u"flag: Niger"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1EB"),
        QStringLiteral(u"norfolk_island_flag"),
        QStringLiteral(u"flag: Norfolk Island"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1EC"),
        QStringLiteral(u"nigeria_flag"),
        QStringLiteral(u"flag: Nigeria"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1EE"),
        QStringLiteral(u"nicaragua_flag"),
        QStringLiteral(u"flag: Nicaragua"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1F1"),
        QStringLiteral(u"netherlands_flag"),
        QStringLiteral(u"flag: Netherlands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1F4"),
        QStringLiteral(u"norway_flag"),
        QStringLiteral(u"flag: Norway"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1F5"),
        QStringLiteral(u"nepal_flag"),
        QStringLiteral(u"flag: Nepal"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1F7"),
        QStringLiteral(u"nauru_flag"),
        QStringLiteral(u"flag: Nauru"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1FA"),
        QStringLiteral(u"niue_flag"),
        QStringLiteral(u"flag: Niue"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F3\U0001F1FF"),
        QStringLiteral(u"new_zealand_flag"),
        QStringLiteral(u"flag: New Zealand"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F4\U0001F1F2"),
        QStringLiteral(u"oman_flag"),
        QStringLiteral(u"flag: Oman"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1E6"),
        QStringLiteral(u"panama_flag"),
        QStringLiteral(u"flag: Panama"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1EA"),
        QStringLiteral(u"peru_flag"),
        QStringLiteral(u"flag: Peru"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1EB"),
        QStringLiteral(u"french_polynesia_flag"),
        QStringLiteral(u"flag: French Polynesia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1EC"),
        QStringLiteral(u"papua_new_guinea_flag"),
        QStringLiteral(u"flag: Papua New Guinea"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1ED"),
        QStringLiteral(u"philippines_flag"),
        QStringLiteral(u"flag: Philippines"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1F0"),
        QStringLiteral(u"pakistan_flag"),
        QStringLiteral(u"flag: Pakistan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1F1"),
        QStringLiteral(u"poland_flag"),
        QStringLiteral(u"flag: Poland"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1F2"),
        QStringLiteral(u"st_pierre_and_miquelon_flag"),
        QStringLiteral(u"flag: St. Pierre & Miquelon"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1F3"),
        QStringLiteral(u"pitcairn_islands_flag"),
        QStringLiteral(u"flag: Pitcairn Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1F7"),
        QStringLiteral(u"puerto_rico_flag"),
        QStringLiteral(u"flag: Puerto Rico"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1F8"),
        QStringLiteral(u"palestinian_territories_flag"),
        QStringLiteral(u"flag: Palestinian Territories"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1F9"),
        QStringLiteral(u"portugal_flag"),
        QStringLiteral(u"flag: Portugal"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1FC"),
        QStringLiteral(u"palau_flag"),
        QStringLiteral(u"flag: Palau"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F5\U0001F1FE"),
        QStringLiteral(u"paraguay_flag"),
        QStringLiteral(u"flag: Paraguay"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F6\U0001F1E6"),
        QStringLiteral(u"qatar_flag"),
        QStringLiteral(u"flag: Qatar"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F7\U0001F1EA"),
        QStringLiteral(u"reunion_flag"),
        QStringLiteral(u"flag: Réunion"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F7\U0001F1F4"),
        QStringLiteral(u"romania_flag"),
        QStringLiteral(u"flag: Romania"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F7\U0001F1F8"),
        QStringLiteral(u"serbia_flag"),
        QStringLiteral(u"flag: Serbia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F7\U0001F1FA"),
        QStringLiteral(u"russia_flag"),
        QStringLiteral(u"flag: Russia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F7\U0001F1FC"),
        QStringLiteral(u"rwanda_flag"),
        QStringLiteral(u"flag: Rwanda"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1E6"),
        QStringLiteral(u"saudi_arabia_flag"),
        QStringLiteral(u"flag: Saudi Arabia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1E7"),
        QStringLiteral(u"solomon_islands_flag"),
        QStringLiteral(u"flag: Solomon Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1E8"),
        QStringLiteral(u"seychelles_flag"),
        QStringLiteral(u"flag: Seychelles"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1E9"),
        QStringLiteral(u"sudan_flag"),
        QStringLiteral(u"flag: Sudan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1EA"),
        QStringLiteral(u"sweden_flag"),
        QStringLiteral(u"flag: Sweden"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1EC"),
        QStringLiteral(u"singapore_flag"),
        QStringLiteral(u"flag: Singapore"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1ED"),
        QStringLiteral(u"st_helena_flag"),
        QStringLiteral(u"flag: St. Helena"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1EE"),
        QStringLiteral(u"slovenia_flag"),
        QStringLiteral(u"flag: Slovenia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1EF"),
        QStringLiteral(u"svalbard_and_jan_mayen_flag"),
        QStringLiteral(u"flag: Svalbard & Jan Mayen"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F0"),
        QStringLiteral(u"slovakia_flag"),
        QStringLiteral(u"flag: Slovakia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F1"),
        QStringLiteral(u"sierra_leone_flag"),
        QStringLiteral(u"flag: Sierra Leone"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F2"),
        QStringLiteral(u"san_marino_flag"),
        QStringLiteral(u"flag: San Marino"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F3"),
        QStringLiteral(u"senegal_flag"),
        QStringLiteral(u"flag: Senegal"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F4"),
        QStringLiteral(u"somalia_flag"),
        QStringLiteral(u"flag: Somalia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F7"),
        QStringLiteral(u"suriname_flag"),
        QStringLiteral(u"flag: Suriname"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F8"),
        QStringLiteral(u"south_sudan_flag"),
        QStringLiteral(u"flag: South Sudan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1F9"),
        QStringLiteral(u"sao_tome_and_principe_flag"),
        QStringLiteral(u"flag: São Tomé & Príncipe"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1FB"),
        QStringLiteral(u"el_salvador_flag"),
        QStringLiteral(u"flag: El Salvador"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1FD"),
        QStringLiteral(u"sint_maarten_flag"),
        QStringLiteral(u"flag: Sint Maarten"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1FE"),
        QStringLiteral(u"syria_flag"),
        QStringLiteral(u"flag: Syria"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F8\U0001F1FF"),
        QStringLiteral(u"eswatini_flag"),
        QStringLiteral(u"flag: Eswatini"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1E6"),
        QStringLiteral(u"tristan_da_cunha_flag"),
        QStringLiteral(u"flag: Tristan da Cunha"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1E8"),
        QStringLiteral(u"turks_and_caicos_islands_flag"),
        QStringLiteral(u"flag: Turks & Caicos Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1E9"),
        QStringLiteral(u"chad_flag"),
        QStringLiteral(u"flag: Chad"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1EB"),
        QStringLiteral(u"french_southern_territories_flag"),
        QStringLiteral(u"flag: French Southern Territories"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1EC"),
        QStringLiteral(u"togo_flag"),
        QStringLiteral(u"flag: Togo"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1ED"),
        QStringLiteral(u"thailand_flag"),
        QStringLiteral(u"flag: Thailand"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1EF"),
        QStringLiteral(u"tajikistan_flag"),
        QStringLiteral(u"flag: Tajikistan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1F0"),
        QStringLiteral(u"tokelau_flag"),
        QStringLiteral(u"flag: Tokelau"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1F1"),
        QStringLiteral(u"timor_leste_flag"),
        QStringLiteral(u"flag: Timor-Leste"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1F2"),
        QStringLiteral(u"turkmenistan_flag"),
        QStringLiteral(u"flag: Turkmenistan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1F3"),
        QStringLiteral(u"tunisia_flag"),
        QStringLiteral(u"flag: Tunisia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1F4"),
        QStringLiteral(u"tonga_flag"),
        QStringLiteral(u"flag: Tonga"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1F7"),
        QStringLiteral(u"turkey_flag"),
        QStringLiteral(u"flag: Turkey"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1F9"),
        QStringLiteral(u"trinidad_and_tobago_flag"),
        QStringLiteral(u"flag: Trinidad & Tobago"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1FB"),
        QStringLiteral(u"tuvalu_flag"),
        QStringLiteral(u"flag: Tuvalu"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1FC"),
        QStringLiteral(u"taiwan_flag"),
        QStringLiteral(u"flag: Taiwan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1F9\U0001F1FF"),
        QStringLiteral(u"tanzania_flag"),
        QStringLiteral(u"flag: Tanzania"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FA\U0001F1E6"),
        QStringLiteral(u"ukraine_flag"),
        QStringLiteral(u"flag: Ukraine"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FA\U0001F1EC"),
        QStringLiteral(u"uganda_flag"),
        QStringLiteral(u"flag: Uganda"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FA\U0001F1F2"),
        QStringLiteral(u"us_outlying_islands_flag"),
        QStringLiteral(u"flag: U.S. Outlying Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FA\U0001F1F3"),
        QStringLiteral(u"united_nations_flag"),
        QStringLiteral(u"flag: United Nations"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FA\U0001F1F8"),
        QStringLiteral(u"united_states_flag"),
        QStringLiteral(u"flag: United States"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FA\U0001F1FE"),
        QStringLiteral(u"uruguay_flag"),
        QStringLiteral(u"flag: Uruguay"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FA\U0001F1FF"),
        QStringLiteral(u"uzbekistan_flag"),
        QStringLiteral(u"flag: Uzbekistan"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FB\U0001F1E6"),
        QStringLiteral(u"vatican_city_flag"),
        QStringLiteral(u"flag: Vatican City"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FB\U0001F1E8"),
        QStringLiteral(u"st_vincent_and_grenadines_flag"),
        QStringLiteral(u"flag: St. Vincent & Grenadines"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FB\U0001F1EA"),
        QStringLiteral(u"venezuela_flag"),
        QStringLiteral(u"flag: Venezuela"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FB\U0001F1EC"),
        QStringLiteral(u"british_virgin_islands_flag"),
        QStringLiteral(u"flag: British Virgin Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FB\U0001F1EE"),
        QStringLiteral(u"us_virgin_islands_flag"),
        QStringLiteral(u"flag: U.S. Virgin Islands"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FB\U0001F1F3"),
        QStringLiteral(u"vietnam_flag"),
        QStringLiteral(u"flag: Vietnam"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FB\U0001F1FA"),
        QStringLiteral(u"vanuatu_flag"),
        QStringLiteral(u"flag: Vanuatu"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FC\U0001F1EB"),
        QStringLiteral(u"wallis_and_futuna_flag"),
        QStringLiteral(u"flag: Wallis & Futuna"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FC\U0001F1F8"),
        QStringLiteral(u"samoa_flag"),
        QStringLiteral(u"flag: Samoa"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FD\U0001F1F0"),
        QStringLiteral(u"kosovo_flag"),
        QStringLiteral(u"flag: Kosovo"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FE\U0001F1EA"),
        QStringLiteral(u"yemen_flag"),
        QStringLiteral(u"flag: Yemen"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FE\U0001F1F9"),
        QStringLiteral(u"mayotte_flag"),
        QStringLiteral(u"flag: Mayotte"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FF\U0001F1E6"),
        QStringLiteral(u"south_africa_flag"),
        QStringLiteral(u"flag: South Africa"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FF\U0001F1F2"),
        QStringLiteral(u"zambia_flag"),
        QStringLiteral(u"flag: Zambia"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F1FF\U0001F1FC"),
        QStringLiteral(u"zimbabwe_flag"),
        QStringLiteral(u"flag: Zimbabwe"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F4\U000E0067\U000E0062\U000E0065\U000E006E\U000E0067\U000E007F"),
        QStringLiteral(u"england_flag"),
        QStringLiteral(u"flag: England"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F4\U000E0067\U000E0062\U000E0073\U000E0063\U000E0074\U000E007F"),
        QStringLiteral(u"scotland_flag"),
        QStringLiteral(u"flag: Scotland"),
        emoji::Emoji::Category::Flags},
  Emoji{QStringLiteral(u"\U0001F3F4\U000E0067\U000E0062\U000E0077\U000E006C\U000E0073\U000E007F"),
        QStringLiteral(u"wales_flag"),
        QStringLiteral(u"flag: Wales"),
        emoji::Emoji::Category::Flags},
};
